<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform xmlns="http://schemas.xmlsoap.org/wsdl/" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:process="http://schemas.xml.org/wsdl/process/" xmlns:plnk="http://schemas.xmlsoap.org/ws/2003/05/partner-link/" xmlns:jms="http://schemas.xmlsoap.org/wsdl/jms/" xmlns:format="http://schemas.xmlsoap.org/wsdl/formatbinding/" xmlns:fdl="http://www.ibm.com/workflow/2003" xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xalan/java" extension-element-prefixes="xalan java" exclude-result-prefixes="fdl" version="1.0">
	<!--
			  BEGIN CMVC
			  *************************************************************************
			  
			  Workfile: BPCSRVR/ws/code/workflow.fdl2bpel/src/com/ibm/bpe/fdl2bpel/converter/v602/xfdl2bpel_wsdl.xsl, WAS.workflow, WBI602.BPCSRVR, m0705.08
			  Last update: 06/11/24 08:03:59
			  SCCS path, id: /family/botp/vc/10/8/3/1/s.74 1.9
			  
			  *************************************************************************
			  END CMVC
			  BEGIN COPYRIGHT
			  *************************************************************************
			  
			  IBM Confidential
			  OCO Source Materials
			  5655-FLW (C) Copyright IBM Corporation 2003, 2006.
			  The source code for this program is not published or otherwise
			  divested of its trade secrets, irrespective of what has been
			  deposited with the U.S. Copyright Office.
			  
			  *************************************************************************
			  END COPYRIGHT
	-->
	<!--
		*****************************************************************************************************************************
		    	Version:  WBI 6.0.2
		*****************************************************************************************************************************
		    	Task:      Create a WSDL file that containes the required service informations for a business process
		*****************************************************************************************************************************
		    	Author: Jens Grotrian (jgr@de.ibm.com)
		*****************************************************************************************************************************
	 -->
	<xsl:strip-space elements="*"/>
	<xsl:output method="xml" indent="yes" xalan:indent-amount="5"/>
	<!--************************************ -->
	<!--*        Configurable parameters   * -->
	<!--************************************ -->
	<!-- "xsdfile": XMLSchema definition file for FDL data types -->
	<xsl:param name="xsdfile"/>
	<!-- "outputdir": path of target directory -->
	<xsl:param name="outputdir" select="''"/>
	<!-- "createPredefinedDataMembers": Create the predefined MQWF data structure members -->
	<xsl:param name="createPredefinedDataMembers" select="'TRUE'"/>
	<!-- "targetPackageXMLSchema": used for the creation of format type maps -->
	<xsl:param name="targetPackageXMLSchema" select="'com.ibm.www.workflow.schema'"/>
	<!-- "enable_LI566_LateBoundSubprocess" -->
	<xsl:param name="enable_LI566_LateBoundSubprocess" select="'TRUE'"/>
	<!-- "enable_LI802_Generate_SCDL" -->
	<xsl:param name="enable_LI802_Generate_SCDL" select="'TRUE'"/>
	<!-- "enable_LI976_Eliminate_long_names" -->
	<xsl:param name="enable_LI976_Eliminate_long_names" select="'FALSE'"/>
	<!--************************************ -->
	<!--*        Global parameters             * -->
	<!--************************************ -->
	<!-- "end of line" character string -->
	<xsl:param name="eol" select='"&#xA;"'/>
	<!-- activity-status-message-name 	-->
	<xsl:param name="activity-status-message-name" select="'ActivityStatus'"/>
	<!--"activity-status-part-name": Part name used in status "variables" -->
	<xsl:param name="activity-status-part-name" select="'ActivityStatus'"/>
	<!-- message-part-name -->
	<xsl:param name="message-part-name" select="'Part1'"/>
	<!-- UPES-message-part-name -->
	<xsl:param name="UPES-message-part-name" select="'Container'"/>
	<!-- "message-suffix": Suffix appended to "standard" message names	-->
	<xsl:param name="message-suffix" select="'_MSG'"/>
	<!-- "UPES-input-message-suffix": Suffix appended to "UPES" input message names -->
	<xsl:param name="UPES-input-message-suffix" select="'_UPES_IN_MSG'"/>
	<!-- "UPES-output-message-suffix": Suffix appended to "UPES" output message names -->
	<xsl:param name="UPES-output-message-suffix" select="'_UPES_OUT_MSG'"/>
	<!-- "port-type-suffix": Suffix appended to "port type" names	-->
	<xsl:param name="port-type-suffix" select="'_PT'"/>
	<!-- "operation-suffix": Suffix appended to "operation" names	-->
	<xsl:param name="operation-suffix" select="'_OP'"/>
	<!-- "UPES-synchronous-operation-suffix": Suffix appended to synchronous UPES "operation" names -->
	<xsl:param name="UPES-synchronous-operation-suffix" select="'_UPES_S_OP'"/>
	<!-- "UPES-asynchronous-operation-suffix": Suffix appended to asynchronous UPES "operation" names -->
	<xsl:param name="UPES-asynchronous-operation-suffix" select="'_UPES_A_OP'"/>
	<!-- "operation-input-name-suffix": Suffix appended to "operation" input names	-->
	<xsl:param name="operation-input-name-suffix" select="'_Request'"/>
	<!-- "operation-output-name-suffix": Suffix appended to "operation" output names -->
	<xsl:param name="operation-output-name-suffix" select="'_Response'"/>
	<!-- "operation-fault-name-suffix": Suffix appended to "operation" fault names -->
	<xsl:param name="operation-fault-name-suffix" select="'_Fault'"/>
	<!-- "partner-link-type-suffix": Suffix appended to "partner link type" names -->
	<xsl:param name="partner-link-type-suffix" select="'_PLT'"/>
	<!-- "UPES-partner-link-type-suffix": Suffix appended to "partner link type" names -->
	<xsl:param name="UPES-partner-link-type-suffix" select="'_UPES_PLT'"/>
	<!-- "role-suffix": Suffix appended to role names 	-->
	<xsl:param name="role-suffix" select="'_Role'"/>
	<!-- "Error" Message severity 1 -->
	<xsl:param name="Error" select="1"/>
	<!-- "Warning" Message severity 2 -->
	<xsl:param name="Warning" select="2"/>
	<!-- "Information" Message severity 3 -->
	<xsl:param name="Information" select="3"/>
	<!--
		*** Parameters also used in XSD file ***
	-->
	<!-- "lower-case-characters": "aäbcdefghijklmnoöpqrstuüvwxyz" -->
	<xsl:param name="lower-case-characters" select="'aäbcdefghijklmnoöpqrstuüvwxyz'"/>
	<!-- "Upper-case-characters": "AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ" -->
	<xsl:param name="upper-case-characters" select="'AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ'"/>
	<!-- "message-type-suffix": Suffix appended to message type names	-->
	<xsl:param name="message-type-suffix" select="'_MT'"/>
	<!-- "UPES-input-message-type-suffix": Suffix appended to UPES input message type names -->
	<xsl:param name="UPES-input-message-type-suffix" select="'_UPES_IN_MT'"/>
	<!-- "UPES-output-message-type-suffix": Suffix appended to UPES output message type names -->
	<xsl:param name="UPES-output-message-type-suffix" select="'_UPES_OUT_MT'"/>
	<!--************************** -->
	<!--*        Keys                   * -->
	<!--************************** -->
	<!--
		Key "program-activity-implemented-by-program" represents a "mapping" between
		program names (as "key objects") and program activities (as "value objects")
	-->
	<xsl:key name="program-activity-implemented-by-program" match="fdl:programActivity" use="fdl:program/@name"/>
	<!--
		Key "program-activity-implemented-by-programExecutionUnit" represents a "mapping" between
		programExecutionUnit (UPES) (as "key objects") and program activities (as "value objects")
	-->
	<xsl:key name="program-activity-implemented-by-programExecutionUnit" match="fdl:programActivity" use="fdl:program/@programExecutionUnit"/>
	<!--
		Key "UPES-activity-receiving-data-structure" represents a "mapping" between
		data structure names (as "key objects") and program activities (as "value objects")
	-->
	<xsl:key name="UPES-activity-receiving-data-structure" match="fdl:programActivity[ fdl:program/@programExecutionUnit ]" use="fdl:input/@type"/>
	<!--************************** -->
	<!--*        Templates           *-->
	<!--************************** -->
	<!-- 
		*****************************************************************************************************************************
		Initial template 
		*****************************************************************************************************************************
	-->
	<xsl:template match="/">
		<xsl:apply-templates select="fdl:definitions" mode="wsdl-definitions"/>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"wsdl-definitions" template:
		
		Translates "fdl:definitions" into "wsdl:definitions".
		*****************************************************************************************************************************
	-->
	<xsl:template match="fdl:definitions" mode="wsdl-definitions">
		<definitions xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:mqwf="http://www.ibm.com/xmlns/prod/websphere/mqwf/schema/" xmlns:wsdl1="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/" targetNamespace="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/">
			<!-- 
				Create partner link types 
			-->
			<!-- Create comment: *** Partner link types *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** Partner link types *** --&gt;', $eol)" disable-output-escaping="yes"/>
			<!-- Create partner link types for FDL processes -->
			<xsl:apply-templates select="fdl:process | fdl:create/fdl:process | fdl:update/fdl:process | fdl:replace/fdl:process" mode="partner-link-types"/>
			<xsl:if test="'TRUE' = translate($enable_LI566_LateBoundSubprocess, $lower-case-characters, $upper-case-characters)">
				<!-- Create partner link types for FDL process activities calling a late-bound subprocess -->
				<xsl:apply-templates select="//fdl:processActivity[ fdl:process/fdl:dataStructureMemberName/fdl:nameComponent ]" mode="partner-link-types"/>
			</xsl:if>
			<!-- Create partner link types for applications called by FDL program activities -->
			<xsl:apply-templates select="fdl:program[ //fdl:programActivity/fdl:program/@name = @name ] 
												| fdl:create/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
												| fdl:update/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
												| fdl:replace/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]" mode="partner-link-types"/>
			<!-- Create partner link types for UPES servers called by FDL program activities -->
			<xsl:apply-templates select="fdl:server | fdl:create/fdl:server | fdl:update/fdl:server | fdl:replace/fdl:server" mode="partner-link-types"/>
			<!-- 
				Import shared data type definitions (derived from FDL data structures) 
			-->
			<!-- Create comment: *** Import message type definitions *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** Import message type definitions *** --&gt;', $eol)" disable-output-escaping="yes"/>
			<xsl:variable name="xsdfile-local-name" select="substring-after($xsdfile, $outputdir)"/>
			<types>
				<xsd:schema targetNamespace="http://www.ibm.com/xmlns/prod/websphere/mqwf/schema/">
					<xsd:include schemaLocation="{$xsdfile-local-name}"/>
				</xsd:schema>
			</types>
			<!-- 
				Create Messages 
			-->
			<!-- Create comment: *** Messages *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** Messages *** --&gt;', $eol)" disable-output-escaping="yes"/>
			<!-- Create WSDL message for FDL data structures -->
			<xsl:apply-templates select=" fdl:structure[  (//fdl:process//fdl:input | //fdl:process//fdl:output )/@type = @name ]
												| fdl:create/fdl:structure[  (//fdl:process//fdl:input | //fdl:process//fdl:output )/@type = @name ]
												| fdl:update/fdl:structure[  (//fdl:process//fdl:input | //fdl:process//fdl:output )/@type = @name ]
												| fdl:replace/fdl:structure[  (//fdl:process//fdl:input | //fdl:process//fdl:output )/@type = @name ]" mode="wsdl-messages"/>
			<!-- Create another auxiliary message used for loop control -->
			<message name="{$activity-status-message-name}{$message-suffix}">
				<part type="xsd:string" name="{$activity-status-part-name}"/>
			</message>
			<!-- 
				Create port types
			-->
			<!-- Create comment: *** Port types *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** Port types *** --&gt;', $eol)" disable-output-escaping="yes"/>
			<!-- Create port types for FDL processes -->
			<xsl:apply-templates select="fdl:process | fdl:update/fdl:process | fdl:replace/fdl:process" mode="port-types"/>
			<xsl:if test="'TRUE' = translate($enable_LI566_LateBoundSubprocess, $lower-case-characters, $upper-case-characters)">
				<!-- Create port types for FDL process activities calling a late-bound subprocess -->
				<xsl:apply-templates select="//fdl:processActivity[ fdl:process/fdl:dataStructureMemberName/fdl:nameComponent ]" mode="port-types"/>
			</xsl:if>
			<!-- Create port types for applications (fdl:program) called by FDL program activities -->
			<xsl:apply-templates select="fdl:program[ //fdl:programActivity/fdl:program/@name = @name ] 
												| fdl:create/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
												| fdl:update/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]
												| fdl:replace/fdl:program[ //fdl:programActivity/fdl:program/@name = @name ]" mode="port-types"/>
			<!-- Create port types for UPES server definition (fdl:server) that is referenced by FDL program activities -->
			<xsl:apply-templates select="fdl:server 
												| fdl:create/fdl:server
												| fdl:update/fdl:server
												| fdl:replace/fdl:server" mode="port-types"/>
		</definitions>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"wsdl-messages" template:
		
		Translates "fdl:structure" into "wsdl:message".
		(if it is referenced by some "fdl:input" or "fdl:output")
		Note that "update" normally occurs with "default structure".
		It is handled like a "created" structure.
		*****************************************************************************************************************************
	-->
	<xsl:template match="fdl:structure" mode="wsdl-messages">
		<xsl:choose>
			<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
				<!-- Create a "standard" message type with predefined data members -->
				<message name="{@name}{$message-suffix}">
					<part type="mqwf:{@name}{$message-type-suffix}" name="{$message-part-name}"/>
				</message>
			</xsl:when>
			<xsl:otherwise>
				<!-- Create a "standard" message type without predefined data members -->
				<message name="{@name}{$message-suffix}">
					<part type="mqwf:{@name}" name="{$message-part-name}"/>
				</message>
			</xsl:otherwise>
		</xsl:choose>
		<!-- Create another message types if  the message is passed to an "UPES" activity -->
		<xsl:variable name="data-is-UPES-input">
			<xsl:call-template name="data-is-UPES-input">
				<xsl:with-param name="structure" select="current()"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:if test="$data-is-UPES-input = 'TRUE'">
			<!-- 
				Create for each combination of input/output type a message type.
				(You have to consider "combination of input/output types", because 
				the output type determines the type of element "MessageDefaultContainer"!)
			 -->
			<xsl:variable name="current-data-structure-name" select="@name"/>
			<xsl:for-each select="key('UPES-activity-receiving-data-structure', $current-data-structure-name)">
				<xsl:variable name="current-UPES-activity" select="current()"/>
				<xsl:for-each select="ancestor::fdl:definitions/fdl:structure[ @name = $current-UPES-activity/fdl:output/@type ]
											| ancestor::fdl:definitions/fdl:create/fdl:structure[ @name = $current-UPES-activity/fdl:output/@type ]
											| ancestor::fdl:definitions/fdl:update/fdl:structure[ @name = $current-UPES-activity/fdl:output/@type ]
											| ancestor::fdl:definitions/fdl:replace/fdl:structure[ @name = $current-UPES-activity/fdl:output/@type ]">
					<xsl:if test="not( current()/@name = $current-UPES-activity/preceding::fdl:programActivity[ fdl:input/@type = $current-data-structure-name and fdl:program/@programExecutionUnit ]/fdl:output/@type )">
						<xsl:choose>
							<!-- CASE: data structures of input and output are the same (use simple type name) -->
							<xsl:when test="$current-data-structure-name = current()/@name">
								<message name="{$current-data-structure-name}{$UPES-input-message-suffix}">
									<part type="mqwf:{$current-data-structure-name}{$UPES-input-message-type-suffix}" name="{$UPES-message-part-name}"/>
								</message>
							</xsl:when>
							<!-- 
								OTHERWISE: different data structures of input and output (type name consists of 
											    a combination of input and output data structures names)
							-->
							<xsl:otherwise>
								<message name="{$current-data-structure-name}_{current()/@name}{$UPES-input-message-suffix}">
									<part type="mqwf:{$current-data-structure-name}_{current()/@name}{$UPES-input-message-type-suffix}" name="{$UPES-message-part-name}"/>
								</message>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:if>
		<!-- Create another message types if  the message is received from an "UPES" activity -->
		<xsl:variable name="data-is-UPES-output">
			<xsl:call-template name="data-is-UPES-output">
				<xsl:with-param name="structure" select="current()"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:if test="$data-is-UPES-output = 'TRUE'">
			<message name="{@name}{$UPES-output-message-suffix}">
				<part type="mqwf:{@name}{$UPES-output-message-type-suffix}" name="{$UPES-message-part-name}"/>
			</message>
		</xsl:if>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"port-types" template:
		
		Creates a "wsdl:portType" for each "fdl:process".
		(representing the process interface)
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:process" mode="port-types">
		<!-- Create comment: Port type for process "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Port type for process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<portType name="{@name}{$port-type-suffix}">
			<!-- Assign a single wsdl:operation with wsdl:input/wsdl:output taken from fdl:process -->
			<operation name="{@name}{$operation-suffix}">
				<input message="wsdl1:{fdl:input/@type}{$message-suffix}" name="{@name}{$operation-suffix}{$operation-input-name-suffix}"/>
				<output message="wsdl1:{fdl:output/@type}{$message-suffix}" name="{@name}{$operation-suffix}{$operation-output-name-suffix}"/>
			</operation>
		</portType>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"port-types" template:
		
		Creates a "wsdl:portType" for each "fdl:processActivity"
		that references a late-bound subprocess
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:processActivity" mode="port-types">
		<!-- Use name prefix in order to have unique operation names -->
		<xsl:variable name="name-prefix">
			<xsl:apply-templates select="current()/ancestor::fdl:process" mode="activity-name-prefix">
				<xsl:with-param name="activity" select="current()"/>
			</xsl:apply-templates>
		</xsl:variable>
		<!-- Create comment: Port type for processActivity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Port type for late-bound subprocess invoked by process activity &quot;', $name-prefix, @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<portType name="{$name-prefix}{@name}{$port-type-suffix}">
			<!-- Assign a single wsdl:operation with wsdl:input/wsdl:output taken from fdl:process -->
			<operation name="{$name-prefix}{@name}{$operation-suffix}">
				<input message="wsdl1:{fdl:input/@type}{$message-suffix}" name="{$name-prefix}{@name}{$operation-suffix}{$operation-input-name-suffix}"/>
				<output message="wsdl1:{fdl:output/@type}{$message-suffix}" name="{$name-prefix}{@name}{$operation-suffix}{$operation-output-name-suffix}"/>
			</operation>
		</portType>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"port-types" template:
		
		Creates a "wsdl:portType" for each "fdl:program".
		(if it is referenced by some "fdl:programActivity")
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:program" mode="port-types">
		<!-- Create comment: Port type for program "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Port type for program &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<portType name="{@name}{$port-type-suffix}">
			<xsl:choose>
				<!-- 
						CASE: If attribute "structuresFromActivity" = "no", then create "wsdl:operation" elements 
						         with "wsdl:input" and "wsdl:output" taken from "fdl:program".
				-->
				<xsl:when test="@structuresFromActivity='no' or not(@structuresFromActivity)">
					<!-- Create comment: Operation used in a "standard" activity -->
					<xsl:value-of select="concat($eol, '&lt;!-- Operation used in a &quot;standard&quot; activity --&gt;', $eol)" disable-output-escaping="yes"/>
					<operation name="{@name}{$operation-suffix}">
						<input message="wsdl1:{fdl:input/@type}{$message-suffix}" name="{@name}{$operation-suffix}{$operation-input-name-suffix}"/>
						<output message="wsdl1:{fdl:output/@type}{$message-suffix}" name="{@name}{$operation-suffix}{$operation-output-name-suffix}"/>
					</operation>
				</xsl:when>
				<!-- 
						OTHERWISE: Assign a "wsdl:operation" for each "fdl:programActivity" that is implemented by "fdl:program".
				-->
				<xsl:otherwise>
					<xsl:for-each select="key('program-activity-implemented-by-program', @name)">
						<!-- Use name prefix in order to have unique operation names -->
						<xsl:variable name="name-prefix">
							<xsl:apply-templates select="current()/ancestor::fdl:process" mode="activity-name-prefix">
								<xsl:with-param name="activity" select="current()"/>
							</xsl:apply-templates>
						</xsl:variable>
						<!-- Create comment: Operation used in activity "nnn" -->
						<xsl:value-of select="concat($eol, '&lt;!-- Operation used in activity &quot;', $name-prefix, @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
						<operation name="{$name-prefix}{@name}{$operation-suffix}">
							<input message="wsdl1:{fdl:input/@type}{$message-suffix}" name="{$name-prefix}{@name}{$operation-suffix}{$operation-input-name-suffix}"/>
							<output message="wsdl1:{fdl:output/@type}{$message-suffix}" name="{$name-prefix}{@name}{$operation-suffix}{$operation-output-name-suffix}"/>
						</operation>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
		</portType>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"port-types" template:
		
		Creates a "wsdl:portType" for each "fdl:server".
		(if it is referenced by some "fdl:programActivity")
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:server" mode="port-types">
		<xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
		<xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
		<!-- Create port type only if the server is referred to by some program activity -->
		<xsl:if test="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
			<!-- Create comment: Port type for server "nnn" -->
			<xsl:value-of select="concat($eol, '&lt;!-- Port type for server &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			<portType name="{@name}{$port-type-suffix}">
				<!-- 
					Assign a "wsdl:operation" for each "fdl:programActivity" that is implemented by "fdl:server".
				-->
				<xsl:for-each select="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
					<xsl:variable name="program-activity-type">
						<xsl:call-template name="program-activity-type">
							<xsl:with-param name="activity" select="current()"/>
						</xsl:call-template>
					</xsl:variable>
					<!-- Create "wsdl:operation" only if the program activity is of type "service invocation activity" -->
					<xsl:if test="$program-activity-type = 'service invocation activity'">
						<!-- Use name prefix in order to have unique operation names -->
						<xsl:variable name="name-prefix">
							<xsl:apply-templates select="current()/ancestor::fdl:process" mode="activity-name-prefix">
								<xsl:with-param name="activity" select="current()"/>
							</xsl:apply-templates>
						</xsl:variable>
						<!-- Create comment: Operation used in activity "nnn" -->
						<xsl:value-of select="concat($eol, '&lt;!-- Operation used in activity &quot;', $name-prefix, @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
						<xsl:variable name="UPES-execution-mode">
							<xsl:call-template name="UPES-execution-mode">
								<xsl:with-param name="activity" select="current()"/>
							</xsl:call-template>
						</xsl:variable>
						<xsl:choose>
							<!-- CASE: asynchronous execution mode -->
							<xsl:when test="$UPES-execution-mode = 'asynchronous'">
								<xsl:choose>
									<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
										<operation name="{$name-prefix}{@name}{$UPES-asynchronous-operation-suffix}">
											<xsl:choose>
												<!-- CASE: data structures of input and output are the same (use simple type name) -->
												<xsl:when test="fdl:input/@type = fdl:output/@type">
													<input message="wsdl1:{fdl:input/@type}{$UPES-input-message-suffix}" name="{$name-prefix}{@name}{$UPES-asynchronous-operation-suffix}{$operation-input-name-suffix}"/>
												</xsl:when>
												<!-- 
														OTHERWISE: different data structures of input and output (type name consists of 
																		   a combination of input and output data structures names)
												-->
												<xsl:otherwise>
													<input message="wsdl1:{fdl:input/@type}_{fdl:output/@type}{$UPES-input-message-suffix}" name="{$name-prefix}{@name}{$UPES-asynchronous-operation-suffix}{$operation-input-name-suffix}"/>
												</xsl:otherwise>
											</xsl:choose>
										</operation>
									</xsl:when>
									<xsl:otherwise>
										<operation name="{$name-prefix}{@name}{$UPES-asynchronous-operation-suffix}">
											<xsl:choose>
												<!-- CASE: data structures of input and output are the same (use simple type name) -->
												<xsl:when test="fdl:input/@type = fdl:output/@type">
													<input message="wsdl1:{fdl:input/@type}{$UPES-input-message-suffix}" name="{$name-prefix}{@name}{$UPES-asynchronous-operation-suffix}{$operation-input-name-suffix}"/>
												</xsl:when>
												<!-- 
														OTHERWISE: different data structures of input and output (type name consists of 
																		   a combination of input and output data structures names)
												-->
												<xsl:otherwise>
													<input message="wsdl1:{fdl:input/@type}_{fdl:output/@type}{$UPES-input-message-suffix}" name="{$name-prefix}{@name}{$UPES-asynchronous-operation-suffix}{$operation-input-name-suffix}"/>
												</xsl:otherwise>
											</xsl:choose>
										</operation>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<!-- OTHERWISE: synchronous execution mode assumed -->
							<xsl:otherwise>
								<operation name="{$name-prefix}{@name}{$UPES-synchronous-operation-suffix}">
									<xsl:choose>
										<!-- CASE: data structures of input and output are the same (use simple type name) -->
										<xsl:when test="fdl:input/@type = fdl:output/@type">
											<input message="wsdl1:{fdl:input/@type}{$UPES-input-message-suffix}" name="{$name-prefix}{@name}{$UPES-synchronous-operation-suffix}{$operation-input-name-suffix}"/>
										</xsl:when>
										<!-- 
											OTHERWISE: different data structures of input and output (type name consists of 
															   a combination of input and output data structures names)
									-->
										<xsl:otherwise>
											<input message="wsdl1:{fdl:input/@type}_{fdl:output/@type}{$UPES-input-message-suffix}" name="{$name-prefix}{@name}{$UPES-synchronous-operation-suffix}{$operation-input-name-suffix}"/>
										</xsl:otherwise>
									</xsl:choose>
									<output message="wsdl1:{fdl:output/@type}{$UPES-output-message-suffix}" name="{$name-prefix}{@name}{$UPES-synchronous-operation-suffix}{$operation-output-name-suffix}"/>
									<xsl:if test="'TRUE' = translate($enable_LI802_Generate_SCDL, $lower-case-characters, $upper-case-characters)">
										<fault message="wsdl1:{fdl:output/@type}{$UPES-output-message-suffix}" name="{$name-prefix}{@name}{$UPES-synchronous-operation-suffix}{$operation-fault-name-suffix}"/>
									</xsl:if>
								</operation>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</portType>
		</xsl:if>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"partner-link-types" template:
		
		Creates a "plnk:partnerLinkType" for each "fdl:process".
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:process" mode="partner-link-types">
		<!-- Create comment: Partner link type for process "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Partner link type for process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<plnk:partnerLinkType name="{@name}{$partner-link-type-suffix}">
			<!-- Assign a "service" role -->
			<plnk:role name="{@name}{$role-suffix}">
				<plnk:portType name="wsdl1:{@name}{$port-type-suffix}"/>
			</plnk:role>
		</plnk:partnerLinkType>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"partner-link-types" template:
		
		Creates a "plnk:partnerLinkType" for each "fdl:processActivity"
		that is references a late-bound subprocess.
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:processActivity" mode="partner-link-types">
		<!-- Use name prefix in order to have unique operation names -->
		<xsl:variable name="name-prefix">
			<xsl:apply-templates select="current()/ancestor::fdl:process" mode="activity-name-prefix">
				<xsl:with-param name="activity" select="current()"/>
			</xsl:apply-templates>
		</xsl:variable>
		<!-- Create comment: Partner link type for late-bound subprocess invoked by process activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Partner link type for late-bound subprocess invoked by process activity &quot;', $name-prefix, @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<plnk:partnerLinkType name="{$name-prefix}{@name}{$partner-link-type-suffix}">
			<!-- Assign a single "server" role -->
			<plnk:role name="{$name-prefix}{@name}{$role-suffix}">
				<plnk:portType name="wsdl1:{$name-prefix}{@name}{$port-type-suffix}"/>
			</plnk:role>
		</plnk:partnerLinkType>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"partner-link-types" template:
		
		Creates a "plnk:partnerLinkType" for each "fdl:program".
		that is referenced by some "fdl:programActivity".
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:program" mode="partner-link-types">
		<!-- Create comment: Partner link type for program "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Partner link type for program &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<plnk:partnerLinkType name="{@name}{$partner-link-type-suffix}">
			<!-- Assign a single "requester" role -->
			<plnk:role name="{@name}{$role-suffix}">
				<plnk:portType name="wsdl1:{@name}{$port-type-suffix}"/>
			</plnk:role>
		</plnk:partnerLinkType>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"partner-link-types" template:
		
		Creates a "plnk:partnerLinkType" for each "fdl:server".
		that is referenced by some "fdl:programActivity".
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:server" mode="partner-link-types">
		<xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
		<xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
		<!-- Create port type only if the server is referred to by some program activity -->
		<xsl:if test="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
			<!-- Create comment: Partner link type for server "nnn" -->
			<xsl:value-of select="concat($eol, '&lt;!-- Partner link type for server &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			<plnk:partnerLinkType name="{@name}{$partner-link-type-suffix}">
				<!-- Assign a single "requester" role -->
				<plnk:role name="{@name}{$role-suffix}">
					<plnk:portType name="wsdl1:{@name}{$port-type-suffix}"/>
				</plnk:role>
			</plnk:partnerLinkType>
		</xsl:if>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"program-invokes-UPES" template:
		
		Returns true, if the program invokes a user-defined program execution server (UPES)
		*****************************************************************************************************************************
	 -->
	<xsl:template name="program-invokes-UPES">
		<xsl:param name="program-name"/>
		<xsl:variable name="UPES-activities">
			<xsl:for-each select="key('program-activity-implemented-by-program', @name)">
				<xsl:variable name="program-activity-type">
					<xsl:call-template name="program-activity-type">
						<xsl:with-param name="activity" select="current()"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="$program-activity-type = 'service invocation activity'">
					<xsl:copy-of select="current()"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="xalan:nodeset($UPES-activities)/*">
				<xsl:value-of select="'TRUE'"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'FALSE'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"data-is-UPES-input" template:
		
		Returns true, if the data is input to a user-defined program execution server (UPES)
		*****************************************************************************************************************************
	 -->
	<xsl:template name="data-is-UPES-input">
		<xsl:param name="structure"/>
		<xsl:variable name="UPES-activities">
			<xsl:for-each select="//fdl:programActivity[ fdl:input/@type = $structure/@name ]">
				<xsl:variable name="program-activity-type">
					<xsl:call-template name="program-activity-type">
						<xsl:with-param name="activity" select="current()"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="$program-activity-type = 'service invocation activity'">
					<xsl:copy-of select="current()"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="xalan:nodeset($UPES-activities)/*">
				<xsl:value-of select="'TRUE'"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'FALSE'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"data-is-UPES-output" template:
		
		Returns true, if the data is output of a user-defined program execution server (UPES)
		*****************************************************************************************************************************
	 -->
	<xsl:template name="data-is-UPES-output">
		<xsl:param name="structure"/>
		<xsl:variable name="UPES-activities">
			<xsl:for-each select="//fdl:programActivity[ fdl:output/@type = $structure/@name ]">
				<xsl:variable name="program-activity-type">
					<xsl:call-template name="program-activity-type">
						<xsl:with-param name="activity" select="current()"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="$program-activity-type = 'service invocation activity'">
					<xsl:copy-of select="current()"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="xalan:nodeset($UPES-activities)/*">
				<xsl:value-of select="'TRUE'"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'FALSE'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		Template "UPES-execution-mode":

		Determines the execution mode of an "UPES" program activity.
		Selects from types "synchronous", "asynchronous"
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_BPEL.XSL", "XFDLBPEL_SCDL.XSL"!)
		*****************************************************************************************************************************
	 -->
	<xsl:template name="UPES-execution-mode">
		<xsl:param name="activity"/>
		<xsl:choose>
			<!-- 
				CASE: "synchronous invocation" 
			-->
			<xsl:when test="$activity/fdl:program/@synchronization = 'nested'">
				<xsl:value-of select="'synchronous'"/>
			</xsl:when>
			<!-- 
				CASE: "asynchronous invocation" 
			-->
			<xsl:when test="$activity/fdl:program/@synchronization = 'chained'">
				<xsl:value-of select="'asynchronous'"/>
			</xsl:when>
			<!-- 
				OTHERWISE: "*** not defined ***" 
			-->
			<xsl:otherwise>
				<xsl:value-of select="'*** not defined ***'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"activity-name-prefix" template:
		
		Determines name prefix of a given FDL program activity.
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_SCDL.XSL" and "XFDLBPEL_BPEL.XSL"!)
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:process" mode="activity-name-prefix">
		<xsl:param name="activity"/>
		<xsl:choose>
			<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
				<!-- Name prefix not required: return empty string -->
				<xsl:value-of select="''"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="fdl:programActivity[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:when test="fdl:processActivity[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:when test="fdl:block[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="fdl:block" mode="activity-name-prefix">
							<xsl:with-param name="activity" select="$activity"/>
							<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="fdl:block" mode="activity-name-prefix">
		<xsl:param name="activity"/>
		<xsl:param name="name-prefix"/>
		<xsl:variable name="next-name-prefix" select="concat($name-prefix,  @name, '_')"/>
		<xsl:choose>
			<xsl:when test="fdl:blockImplementation/fdl:programActivity[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:when test="fdl:blockImplementation/fdl:processActivity[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:when test="fdl:blockImplementation/fdl:block[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="fdl:blockImplementation/fdl:block" mode="activity-name-prefix">
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="name-prefix" select="$next-name-prefix"/>
				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		Template "program-activity-type":

		Determines the type of an FDL program activity.
		Selects from types "empty activity", "service invocation activity" (UPES activity),  "staff activity",
		"assumed staff activity"
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_XSD.XSL" AND "XFDLBPEL_BPEL.XSL"!)
		*****************************************************************************************************************************
	 -->
	<xsl:template name="program-activity-type">
		<xsl:param name="activity"/>
		<xsl:choose>
			<!-- 
				CASE: "empty activity" 
					A program activity is an "empty activity" if 
					1) if the activity implementation is a program with the name FMCINTERNALNOOP
					2) the execution mode is chained
					3) the input and output data structures are the same
			-->
			<xsl:when test="$activity/fdl:program/@name='FMCINTERNALNOOP' 
								and $activity/fdl:program/@synchronization='chained'
								and $activity/fdl:input/@type = $activity/fdl:output/@type">
				<xsl:value-of select="'empty activity'"/>
			</xsl:when>
			<!-- 
				CASE: "service invocation activity" 
					A program activity is an "service invocation activity" if a user-defined program execution server
					(UPES) is specified (attribute "fdl:program/@programExecutionUnit").
			-->
			<xsl:when test="$activity/fdl:program/@programExecutionUnit">
				<xsl:value-of select="'service invocation activity'"/>
			</xsl:when>
			<!-- 
				CASE: "staff activity" 
					A program activity is a "staff activity" if the following conditions apply:
					1. Attribute "checkoutPossible" indicates that it can be checked out from the runtime database.
					2. Start type is "manual"
			-->
			<xsl:when test="$activity/fdl:join/@startType='manual' and ( $activity/fdl:defaultSetting/@checkoutPossible='yes'  
								 or $activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='yes' )">
				<xsl:value-of select="'staff activity'"/>
			</xsl:when>
			<!-- 
				OTHERWISE: "unclassified activity" 
					A program activity is an "unclassified activity" if none of the above rules apply.
					In this case assume a "staff activity".
			-->
			<xsl:otherwise>
				<xsl:value-of select="'assumed staff activity'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:transform>
