<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:scdl="http://www.ibm.com/xmlns/prod/websphere/scdl/6.0.0" xmlns:wsdls="http://schemas.xmlsoap.org/wsdl/" xmlns:fdl="http://www.ibm.com/workflow/2003" xmlns:redirect="http://xml.apache.org/xalan/redirect" xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xalan/java" extension-element-prefixes="redirect xalan java" exclude-result-prefixes="fdl wsdls" version="1.0">
	<!--
			  BEGIN CMVC
			  *************************************************************************
			  
			  Workfile: BPCSRVR/ws/code/workflow.fdl2bpel/src/com/ibm/bpe/fdl2bpel/converter/v61/xfdl2bpel_scdl.xsl, WAS.workflow, WBI602.BPCSRVR, m0705.08
			  Last update: 06/11/24 08:08:44
			  SCCS path, id: /family/botp/vc/10/6/5/9/s.54 1.20
			  
			  *************************************************************************
			  END CMVC
			  BEGIN COPYRIGHT
			  *************************************************************************
			  
			  IBM Confidential
			  OCO Source Materials
			  5655-FLW (C) Copyright IBM Corporation 2003, 2006.
			  The source code for this program is not published or otherwise
			  divested of its trade secrets, irrespective of what has been
			  deposited with the U.S. Copyright Office.
			  
			  *************************************************************************
			  END COPYRIGHT
	-->
	<!--
		*****************************************************************************************************************************
		    	Version:  WBI 6.1
		*****************************************************************************************************************************
		    	Task:      Create SCDL files that belong to an SCA module
		*****************************************************************************************************************************
		    	Author: Jens Grotrian (jgr@de.ibm.com)
		*****************************************************************************************************************************
	 -->
	<xsl:strip-space elements="*"/>
	<xsl:output method="xml" indent="yes" xalan:indent-amount="5"/>
	<!--************************************ -->
	<!--*        Configurable parameters   * -->
	<!--************************************ -->
	<!-- "wsdlfile": path of target directory -->
	<xsl:param name="wsdlfile" select="''"/>
	<!-- "outputExtDir: output directory relative to WSADIE workspace root" -->
	<xsl:param name="outputExtDir" select="'FDL2BPEL'"/>
	<!-- "outputdir": path of target directory -->
	<xsl:param name="outputdir" select="''"/>
	<!-- "enable_LI802_Generate_SCDL" -->
	<xsl:param name="enable_LI802_Generate_SCDL" select="'TRUE'"/>
	<!-- "enable_LI339_UPES_Binding" (requires "enable_LI802_Generate_SCDL") -->
	<xsl:param name="enable_LI339_UPES_Binding" select="'TRUE'"/>
	<!-- "enable_LI976_Eliminate_long_names" -->
	<xsl:param name="enable_LI976_Eliminate_long_names" select="'FALSE'"/>
	<!--************************** -->
	<!--*        Parameters         * -->
	<!--************************** -->
	<!-- "data-binding-suffix": Suffix appended to data binding names -->
	<xsl:param name="data-binding-suffix" select="'_DataBindingImpl'"/>
	<!-- "data-binding-package-name": package name of a data binding Java class -->
	<xsl:param name="data-binding-package-name" select="'com.ibm.workflow.sca.jms.data'"/>
	<!-- "reply-queue-suffix":  Suffix belonging to a JNDI JMS reply queue name -->
	<xsl:param name="reply-queue-suffix" select="'_REPLY'"/>
	<!-- "callback-queue-suffix":  Suffix belonging to a JNDI JMS callback queue name -->
	<xsl:param name="callback-queue-suffix" select="'_CALLBACK'"/>
	<!-- "native_XML_queue_name_prefix":  Prefix added to generated XML message target name if the message format is native XML -->
	<xsl:param name="native_XML_queue_name_prefix" select="''"/>
	<!-- "JMS_compliant_XML_queue_name_prefix":  Prefix added to generated XML message target name if the message format is JMS-compliant XML -->
	<xsl:param name="JMS_compliant_XML_queue_name_prefix" select="'JMS_'"/>
	<!-- "listener-port-name-suffix": Suffix appended to "listener port" names	-->
	<xsl:param name="listener-port-name-suffix" select="'_LP'"/>
	<!-- "destination-name-default":  default name of a messaging destination (queue) -->
	<xsl:param name="destination-name-default" select="'unknown-destination'"/>
	<!-- "connectionFactoryNameDefault":  -->
	<xsl:param name="connectionFactoryNameDefault" select="'FMCQM'"/>
	<!-- "maxBaseQueueNameLength" -->
	<xsl:param name="maxBaseQueueNameLength" select="48"/>
	<!-- "AsyncUpesClassName" contains the class name of the generic databinding for asyncronous UPES -->
	<xsl:param name="AsyncUpesClassName" select="'AsyncUPES'"/>
	<!--
		*** Parameters also used in WSDL file ***
	-->
	<!-- "lower-case-characters": "aäbcdefghijklmnoöpqrstuüvwxyz" -->
	<xsl:param name="lower-case-characters" select="'aäbcdefghijklmnoöpqrstuüvwxyz'"/>
	<!-- "upper-case-characters": "AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ" -->
	<xsl:param name="upper-case-characters" select="'AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ'"/>
	<!-- "port-type-suffix": Suffix appended to "port type" names	-->
	<xsl:param name="port-type-suffix" select="'_PT'"/>
	<!-- "operation-suffix": Suffix appended to "operation" names	-->
	<xsl:param name="operation-suffix" select="'_OP'"/>
	<!-- "UPES-output-message-suffix": Suffix appended to "UPES" output message names -->
	<xsl:param name="UPES-output-message-suffix" select="'_UPES_OUT_MSG'"/>
	<!--
		*** Parameters also used in BPEL files ***
	-->
	<!-- "partner-link-suffix": Suffix appended to "partner link" names -->
	<xsl:param name="partner-link-suffix" select="'_PL'"/>
	<!-- "Error" Message severity 1 -->
	<xsl:param name="Error" select="1"/>
	<!-- "Warning" Message severity 2 -->
	<xsl:param name="Warning" select="2"/>
	<!-- "Information" Message severity 3 -->
	<xsl:param name="Information" select="3"/>
	<!--************************** -->
	<!--*        Keys                   * -->
	<!--************************** -->
	<!--
		Key "program-activity-implemented-by-programExecutionUnit" represents a "mapping" between
		programExecutionUnit (UPES) (as "key objects") and program activities (as "value objects")
	-->
	<xsl:key name="program-activity-implemented-by-programExecutionUnit" match="fdl:programActivity" use="fdl:program/@programExecutionUnit"/>
	<!--
		*****************************************************************************************************************************
		Initial template
		*****************************************************************************************************************************
	-->
	<xsl:template match="/">
		<xsl:if test="'TRUE' = translate($enable_LI802_Generate_SCDL, $lower-case-characters, $upper-case-characters)">
			<!-- Create component file for each FDL processes -->
			<xsl:apply-templates select="fdl:definitions/fdl:process |
													 fdl:definitions/fdl:create/fdl:process |
													 fdl:definitions/fdl:update/fdl:process |
													 fdl:definitions/fdl:replace/fdl:process" mode="component"/>
			<!-- Test BEGIN -->
			<xsl:apply-templates select="fdl:definitions/fdl:server |
													 fdl:definitions/fdl:create/fdl:server |
													 fdl:definitions/fdl:update/fdl:server |
													 fdl:definitions/fdl:replace/fdl:server" mode="import"/>
			<!-- Test END -->
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"component" template:
		
		Translates "fdl:process" into scdl files with extension "component"
		Create iSCA "import" elements for a each descendant "fdl:programActivity" that invokes a UPES
		*****************************************************************************************************************************
	-->
	<xsl:template match="fdl:process" mode="component">
		<xsl:variable name="scdlfile-local-name" select="concat(@name, '.component')"/>
		<xsl:variable name="scdlfile-path-name" select="concat($outputdir, $scdlfile-local-name)"/>
		<xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $scdlfile-local-name)"/>
		<xsl:variable name="addScdl" select="java:com.ibm.bpe.fdl2bpel.converter.ScdlList.add($scdlfile-path-name)"/>
		<redirect:write select="concat($outputdir, $scdlfile-local-name)">
			<scdl:component xmlns:wsdl="http://www.ibm.com/xmlns/prod/websphere/scdl/wsdl/6.0.0" xmlns:process="http://www.ibm.com/xmlns/prod/websphere/scdl/business-process/6.0.0" xmlns:ns1="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/" displayName="{@displayName}" name="{@name}">
				<interfaces>
					<interface portType="ns1:{@name}{$port-type-suffix}" preferredInteractionStyle="async" xsi:type="wsdl:WSDLPortType">
						<scdl:interfaceQualifier value="false" xsi:type="scdl:JoinTransaction"/>
						<method name="{@name}{$operation-suffix}"/>
					</interface>
				</interfaces>
				<references>
					<!-- Create references for FDL process activities calling a subprocess -->
					<xsl:apply-templates select="descendant::fdl:processActivity[ fdl:process ]" mode="reference">
						<xsl:with-param name="process" select="current()"/>
					</xsl:apply-templates>
					<!-- Create references for FDL server  -->
					<xsl:apply-templates select="//fdl:server
												| //fdl:create/fdl:server
												| //fdl:update/fdl:server
												| //fdl:replace/fdl:server" mode="reference">
						<xsl:with-param name="process" select="current()"/>
					</xsl:apply-templates>
				</references>
				<implementation xsi:type="process:ProcessImplementation">
					<scdl:implementationQualifier value="global" xsi:type="scdl:Transaction"/>
					<process bpel="/{@name}.bpel"/>
				</implementation>
			</scdl:component>
		</redirect:write>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"reference" template:
		Creates a "reference" element for each "fdl:processActivity" calling another process.
		*****************************************************************************************************************************
	-->
	<xsl:template match="fdl:processActivity" mode="reference">
		<xsl:param name="process"/>
		<xsl:choose>
			<!-- CASE: late-bound process invocation (process name taken from container) -->
			<xsl:when test="fdl:process/fdl:dataStructureMemberName">
				<xsl:variable name="name-prefix">
					<xsl:apply-templates select="$process" mode="activity-name-prefix">
						<xsl:with-param name="activity" select="current()"/>
					</xsl:apply-templates>
				</xsl:variable>
				<reference name="{$name-prefix}{@name}{$partner-link-suffix}">
					<interface portType="ns1:{$name-prefix}{@name}{$port-type-suffix}" xsi:type="wsdl:WSDLPortType">
						<method name="{$name-prefix}{@name}{$operation-suffix}"/>
					</interface>
					<scdl:referenceQualifier value="commit" xsi:type="scdl:DeliverAsyncAt"/>
				</reference>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="not( preceding::fdl:processActivity[ ancestor::fdl:process/@name =$process/@name and fdl:process/@name = current()/fdl:process/@name ] )">
					<reference name="{fdl:process/@name}{$partner-link-suffix}">
						<interface portType="ns1:{fdl:process/@name}{$port-type-suffix}" xsi:type="wsdl:WSDLPortType">
							<method name="{fdl:process/@name}{$operation-suffix}"/>
						</interface>
						<scdl:referenceQualifier value="commit" xsi:type="scdl:DeliverAsyncAt"/>
					</reference>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"reference" template:
		Creates a "reference" element for each "fdl:server" that is referred to by some program activity.
		*****************************************************************************************************************************
	-->
	<xsl:template match="fdl:server" mode="reference">
		<xsl:param name="process"/>
		<xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
		<xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
		<!-- Create reference only if the server is referred to by some program activity contained in the process -->
		<xsl:if test="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))[ @name = $process//fdl:programActivity/@name ]">
			<xsl:variable name="partner-link-name" select="concat(@name, $partner-link-suffix)"/>
			<xsl:variable name="port-type-name" select="concat(@name, $port-type-suffix)"/>
			<xsl:variable name="port-type" select="document($wsdlfile)/wsdls:definitions/wsdls:portType[ @name =$port-type-name ]"/>
			<!-- Create the "reference" -->
			<reference name="{$partner-link-name}">
				<interface portType="ns1:{$port-type-name}" xsi:type="wsdl:WSDLPortType">
					<xsl:for-each select="$port-type/wsdls:operation">
						<method name="{@name}"/>
					</xsl:for-each>
				</interface>
				<scdl:referenceQualifier value="commit" xsi:type="scdl:DeliverAsyncAt"/>
				<wire target="{@name}"/>
			</reference>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"import" template:
		Create import for a each "fdl:programActivity" that invokes a UPES
		*****************************************************************************************************************************
	-->
	<xsl:template match="fdl:server" mode="import">
		<xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
		<xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
		<!-- Create port type only if the server is referred to by some program activity -->
		<xsl:if test="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))">
			<xsl:variable name="port-type-name" select="concat(@name, $port-type-suffix)"/>
			<xsl:variable name="port-type" select="document($wsdlfile)/wsdls:definitions/wsdls:portType[ @name =$port-type-name ]"/>
			<xsl:variable name="connectionFactoryName">
				<xsl:choose>
					<xsl:when test="fdl:userDefinedProgramExecutionServer/@queueManagerName">
						<xsl:value-of select="fdl:userDefinedProgramExecutionServer/@queueManagerName"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$connectionFactoryNameDefault"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="send-queue-name">
				<xsl:choose>
					<xsl:when test="fdl:userDefinedProgramExecutionServer/@physicalQueueName">
						<xsl:choose>
							<xsl:when test="fdl:userDefinedProgramExecutionServer/@messageFormat='JMS_XML'">
								<xsl:value-of select="concat($JMS_compliant_XML_queue_name_prefix, fdl:userDefinedProgramExecutionServer/@physicalQueueName)"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="concat($native_XML_queue_name_prefix, fdl:userDefinedProgramExecutionServer/@physicalQueueName)"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$destination-name-default"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<!-- FG: added variable that hold the target-client type depending on the messageFormat
                   JMS_...  ==> target-client-type = JMS   otherwise   = MQ
			-->
			<xsl:variable name="target-client-type">
				<xsl:choose>
					<xsl:when test="'TRUE'=starts-with($send-queue-name,$JMS_compliant_XML_queue_name_prefix)">
						<xsl:value-of select="'JMS'"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="'MQ'"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="reply-queue-name" select="concat($send-queue-name, $reply-queue-suffix)"/>
			<xsl:variable name="scdlfile-local-name" select="concat(@name, '.import')"/>
			<xsl:variable name="scdlfile-path-name" select="concat($outputdir, $scdlfile-local-name)"/>
			<xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $scdlfile-local-name)"/>
			<xsl:variable name="addScdl" select="java:com.ibm.bpe.fdl2bpel.converter.ScdlList.add($scdlfile-path-name)"/>
			<redirect:write select="concat($outputdir, $scdlfile-local-name)">
				<scdl:import xmlns:wsdl="http://www.ibm.com/xmlns/prod/websphere/scdl/wsdl/6.0.0" xmlns:ns1="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/" xmlns:mqjms="http://www.ibm.com/xmlns/prod/websphere/scdl/mqjms/6.0.0" displayName="{@name}" name="{@name}">
					<!-- Create the "interfaces" element -->
					<interfaces>
						<interface portType="ns1:{$port-type/@name}" xsi:type="wsdl:WSDLPortType">
							<xsl:for-each select="$port-type/wsdls:operation">
								<method name="{@name}"/>
							</xsl:for-each>
						</interface>
					</interfaces>
					<esbBinding responseCorrelationScheme="RequestMsgIDToCorrelID" xsi:type="mqjms:MQJMSImportBinding">
						<outboundConnection>
							<mqConfiguration>
								<queueManager>
									<xsl:value-of select="$connectionFactoryName"/>
								</queueManager>
							</mqConfiguration>
						</outboundConnection>
						<responseListener/>
						<send targetClient="{$target-client-type}" type="javax.jms.Queue">
							<baseName>
								<xsl:if test="string-length($send-queue-name) &gt; $maxBaseQueueNameLength">
									<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'BaseQueueNameTooLong', $send-queue-name, $maxBaseQueueNameLength), ' ***')"/>
								</xsl:if>
								<xsl:value-of select="$send-queue-name"/>
							</baseName>
						</send>
						<receive targetClient="{$target-client-type}" type="javax.jms.Queue">
							<xsl:if test="string-length($reply-queue-name) &gt; $maxBaseQueueNameLength">
								<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'BaseQueueNameTooLong', $reply-queue-name, $maxBaseQueueNameLength), ' ***')"/>
							</xsl:if>
							<baseName>
								<xsl:value-of select="$reply-queue-name"/>
							</baseName>
						</receive>
						<xsl:for-each select="$port-type/wsdls:operation">
							<xsl:variable name="message-name" select="substring-after(current()/wsdls:output/@message, ':')"/>
							<!-- FG: In case of asynchron port-type definition there is no wsdls:output element available.
                                                                 So a generic DatabindingImpl class is used for
                                                                 asynchron UPES invocation.
							-->
							<xsl:variable name="class-name">
								<xsl:choose>
									<xsl:when test="current()/wsdls:output/@message">
										<xsl:value-of select="concat(translate(substring($message-name, 1, 1), $lower-case-characters, $upper-case-characters), substring($message-name, 2))"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$AsyncUpesClassName"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:variable>
							<xsl:variable name="data-binding-type">
								<xsl:choose>
									<xsl:when test="'TRUE' = translate($enable_LI339_UPES_Binding, $lower-case-characters, $upper-case-characters)">
										<xsl:value-of select="concat($data-binding-package-name, '.', $class-name, $data-binding-suffix)"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="'com.ibm.websphere.sca.jms.data.impl.JMSDataBindingImplXML'"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:variable>
							<methodBinding outDataBindingType="{$data-binding-type}" inDataBindingType="{$data-binding-type}" method="{@name}"/>
						</xsl:for-each>
					</esbBinding>
				</scdl:import>
			</redirect:write>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		Template "UPES-execution-mode":

		Determines the execution mode of an "UPES" program activity.
		Selects from types "synchronous", "asynchronous"
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_WSDL.XSL", "XFDLBPEL_BPEL.XSL"!)
		*****************************************************************************************************************************
	 -->
	<xsl:template name="UPES-execution-mode">
		<xsl:param name="activity"/>
		<xsl:choose>
			<!--
				CASE: "synchronous invocation"
			-->
			<xsl:when test="$activity/fdl:program/@synchronization = 'nested'">
				<xsl:value-of select="'synchronous'"/>
			</xsl:when>
			<!--
				CASE: "asynchronous invocation"
			-->
			<xsl:when test="$activity/fdl:program/@synchronization = 'chained'">
				<xsl:value-of select="'asynchronous'"/>
			</xsl:when>
			<!--
				OTHERWISE: "*** not defined ***"
			-->
			<xsl:otherwise>
				<xsl:value-of select="'*** not defined ***'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"activity-name-prefix" template:
		
		Determines name prefix of a given FDL program activity.
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_WSDL.XSL" and "XFDLBPEL_BPEL.XSL"!)
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:process" mode="activity-name-prefix">
		<xsl:param name="activity"/>
		<xsl:choose>
			<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
				<!-- Name prefix not required: return empty string -->
				<xsl:value-of select="''"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="fdl:programActivity[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:when test="fdl:processActivity[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:when test="fdl:block[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="fdl:block" mode="activity-name-prefix">
							<xsl:with-param name="activity" select="$activity"/>
							<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="fdl:block" mode="activity-name-prefix">
		<xsl:param name="activity"/>
		<xsl:param name="name-prefix"/>
		<xsl:variable name="next-name-prefix" select="concat($name-prefix,  @name, '_')"/>
		<xsl:choose>
			<xsl:when test="fdl:blockImplementation/fdl:programActivity[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:when test="fdl:blockImplementation/fdl:processActivity[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:when test="fdl:blockImplementation/fdl:block[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="fdl:blockImplementation/fdl:block" mode="activity-name-prefix">
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="name-prefix" select="$next-name-prefix"/>
				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		Template "program-activity-type":

		Determines the type of an FDL program activity.
		Selects from types "empty activity", "service invocation activity" (UPES activity),  "staff activity",
		"assumed staff activity"
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_XSD.XSL", "XFDLBPEL_WSDL.XSL" AND "XFDLBPEL_BPEL.XSL"!)
		*****************************************************************************************************************************
	 -->
	<xsl:template name="program-activity-type">
		<xsl:param name="activity"/>
		<xsl:choose>
			<!--
				CASE: "empty activity"
					A program activity is an "empty activity" if
					1) if the activity implementation is a program with the name FMCINTERNALNOOP
					2) the execution mode is chained
					3) the input and output data structures are the same
			-->
			<xsl:when test="$activity/fdl:program/@name='FMCINTERNALNOOP'
								and $activity/fdl:program/@synchronization='chained'
								and $activity/fdl:input/@type = $activity/fdl:output/@type">
				<xsl:value-of select="'empty activity'"/>
			</xsl:when>
			<!--
				CASE: "service invocation activity"
					A program activity is an "service invocation activity" if a user-defined program execution server
					(UPES) is specified (attribute "fdl:program/@programExecutionUnit").
			-->
			<xsl:when test="$activity/fdl:program/@programExecutionUnit">
				<xsl:value-of select="'service invocation activity'"/>
			</xsl:when>
			<!--
				CASE: "staff activity"
					A program activity is a "staff activity" if the following conditions apply:
					1. Attribute "checkoutPossible" indicates that it can be checked out from the runtime database.
					2. Start type is "manual"
			-->
			<xsl:when test="$activity/fdl:join/@startType='manual' and ( $activity/fdl:defaultSetting/@checkoutPossible='yes'
								 or $activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='yes' )">
				<xsl:value-of select="'staff activity'"/>
			</xsl:when>
			<!--
				OTHERWISE: "unclassified activity"
					A program activity is an "unclassified activity" if none of the above rules apply.
					In this case assume a "staff activity".
			-->
			<xsl:otherwise>
				<xsl:value-of select="'assumed staff activity'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:transform>
