<?xml version="1.0" encoding="UTF-8"?>
<EventSpec
  xmlns="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/es"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/es es.xsd"
  targetNamespace="http://www.ibm.com/xmlns/prod/websphere/scdl/business-process/6.0.0"
  name="BFMEvents">

  <Events>
    <Event name="BPC.BFM.BASE" parent="WBI.MonitoringEvent">
      <Payload>
        <!-- Don't know what role actually expresses -->
        <Data role="Information" name="BPCEventCode" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="processTemplateName"
          type="string" minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="processTemplateValidFrom"
          type="string" minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.PROCESS.BASE" parent="BPC.BFM.BASE">
      <Payload>
        <Data role="Information" name="processInstanceExecutionState"
          type="string" minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.PROCESS.STATUS"
      parent="BPC.BFM.PROCESS.BASE">
      <Payload>
        <Data role="Information" name="processTemplateId" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="processInstanceDescription"
          type="string" minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.PROCESS.START"
      parent="BPC.BFM.PROCESS.STATUS">
      <Payload>
        <Data role="Information" name="username" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.PROCESS.FAILURE"
      parent="BPC.BFM.PROCESS.STATUS">
      <Payload>
        <Data role="Information" name="processFailedException"
          type="string" minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.PROCESS.CORREL"
      parent="BPC.BFM.PROCESS.STATUS">
      <Payload>
        <Data role="Information" name="correlationSet"
          type="hexBinary" minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.PROCESS.WISTATUS"
      parent="BPC.BFM.PROCESS.STATUS">
      <Payload>
        <Data role="Information" name="username" type="string"
          minOccurs="1" maxOccurs="unbounded" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.PROCESS.WITRANSFER"
      parent="BPC.BFM.PROCESS.STATUS">
      <Payload>
        <Data role="Information" name="current" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="target" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.PROCESS.ESCALATED"
      parent="BPC.BFM.PROCESS.STATUS">
        <Payload>
            <Data role="Information" name="escalationName" 
                type="string" minOccurs="1" maxOccurs="1" />
        </Payload>
    </Event>
        
    <Event name="BPC.BFM.ACTIVITY.BASE" parent="BPC.BFM.BASE">
      <Payload>
        <Data role="Information" name="activityKind" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="state" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="bpelId" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.ACTIVITY.STATUS"
      parent="BPC.BFM.ACTIVITY.BASE">
      <Payload>
        <Data role="Information" name="activityTemplateName"
          type="string" minOccurs="0" maxOccurs="1" />
        <Data role="Information" name="activityTemplateId"
          type="string" minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="activityInstanceDescription"
          type="string" minOccurs="0" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.ACTIVITY.FAILURE"
      parent="BPC.BFM.ACTIVITY.STATUS">
      <Payload>
        <Data role="Information" name="activityFailedException"
          type="string" minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.ACTIVITY.MESSAGE"
      parent="BPC.BFM.ACTIVITY.STATUS">
      <Payload>
        <Data role="Information" name="message" type="primitive businessObject"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.ACTIVITY.CLAIM"
      parent="BPC.BFM.ACTIVITY.STATUS">
      <Payload>
        <Data role="Information" name="username" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="principal" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.ACTIVITY.WISTATUS"
      parent="BPC.BFM.ACTIVITY.STATUS">
      <Payload>
        <Data role="Information" name="username" type="string"
          minOccurs="1" maxOccurs="unbounded" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.ACTIVITY.WITRANSFER"
      parent="BPC.BFM.ACTIVITY.STATUS">
      <Payload>
        <Data role="Information" name="current" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="target" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>

    <Event name="BPC.BFM.ACTIVITY.FOREACH"
      parent="BPC.BFM.ACTIVITY.STATUS">
        <Payload>
            <Data role="Information" name="parallelBranchesStarted" 
                type="string" minOccurs="1" maxOccurs="1" />
        </Payload>
    </Event>

	<Event name="BPC.BFM.ACTIVITY.ESCALATED"
      parent="BPC.BFM.ACTIVITY.STATUS">
        <Payload>
            <Data role="Information" name="escalationName" 
                type="string" minOccurs="1" maxOccurs="1" />
        </Payload>
    </Event>


    <Event name="BPC.BFM.LINK.STATUS" parent="BPC.BFM.BASE">
      <Payload>
        <Data role="Information" name="elementName" type="string"
          minOccurs="0" maxOccurs="1" />
        <Data role="Information" name="description" type="string"
          minOccurs="0" maxOccurs="1" />
        <Data role="Information" name="flowBpelId" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.BFM.VARIABLE.STATUS" parent="BPC.BFM.BASE">
      <Payload>
        <Data role="Information" name="variableName" type="string"
          minOccurs="0" maxOccurs="1" />
        <Data role="Information" name="variableData" type="primitive businessObject"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="bpelId" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>


  </Events>
</EventSpec>
