<?xml version="1.0" encoding="UTF-8"?>
<EventSpec
  xmlns="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/es"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.0/es es.xsd"
  targetNamespace="http://www.ibm.com/xmlns/prod/websphere/scdl/human-task/6.0.0"
  name="HTMEvents">

  <Events>
    <Event name="BPC.HTM.BASE" parent="WBI.MonitoringEvent">
      <Payload>
        <!-- Don't know what role actually expresses -->
        <Data role="Information" name="HTMEventCode" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.TASK.BASE" parent="BPC.HTM.BASE">
      <Payload>
        <Data role="Information" name="taskTemplateName" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="taskTemplateValidFrom"
          type="string" minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="taskTemplateId"
          type="string" minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.TASK.STATUS" parent="BPC.HTM.TASK.BASE">
      <Payload>
        <Data role="Information" name="taskInstanceDescription"
          type="string" minOccurs="0" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.TASK.FOLLOW" parent="BPC.HTM.TASK.BASE">
      <Payload>
        <Data role="Information" name="followTaskId" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.TASK.MESSAGE" parent="BPC.HTM.TASK.STATUS">
      <Payload>
        <Data role="Information" name="message" type="primitive businessObject"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.TASK.INTERACT" parent="BPC.HTM.TASK.STATUS">
      <Payload>
        <Data role="Information" name="username" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.TASK.FAILURE" parent="BPC.HTM.TASK.STATUS">
      <Payload>
        <Data role="Information" name="taskFailedException"
          type="string" minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.TASK.WISTATUS" parent="BPC.HTM.TASK.STATUS">
      <Payload>
        <Data role="Information" name="username" type="string"
          minOccurs="1" maxOccurs="unbounded" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.TASK.WITRANSFER"
      parent="BPC.HTM.TASK.STATUS">
      <Payload>
        <Data role="Information" name="current" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="target" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.ESCALATION.STATUS"
      parent="BPC.HTM.TASK.BASE">
      <Payload>
        <Data role="Information" name="escalationName" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="escalationInstanceDescription"
          type="string" minOccurs="0" maxOccurs="1" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.ESCALATION.WISTATUS"
      parent="BPC.HTM.ESCALATION.STATUS">
      <Payload>
        <Data role="Information" name="username" type="string"
          minOccurs="1" maxOccurs="unbounded" />
      </Payload>
    </Event>
    <Event name="BPC.HTM.ESCALATION.WITRANSFER"
      parent="BPC.HTM.ESCALATION.STATUS">
      <Payload>
        <Data role="Information" name="current" type="string"
          minOccurs="1" maxOccurs="1" />
        <Data role="Information" name="target" type="string"
          minOccurs="1" maxOccurs="1" />
      </Payload>
    </Event>
  </Events>
</EventSpec>
