<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:mqwf="http://www.ibm.com/xmlns/prod/websphere/mqwf/schema/" xmlns:wsdl1="http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/" xmlns:staff="http://www.ibm.com/xmlns/prod/websphere/mqwf/tel/" xmlns:tel="http://www.ibm.com/xmlns/prod/websphere/human-task/6.0.0/" xmlns:bpc="http://www.ibm.com/xmlns/prod/websphere/business-process/6.0.0/" xmlns:bpel="http://schemas.xmlsoap.org/ws/2004/03/business-process/" xmlns:fdl="http://www.ibm.com/workflow/2003" xmlns:redirect="http://xml.apache.org/xalan/redirect" xmlns:xalan="http://xml.apache.org/xalan" xmlns:java="http://xml.apache.org/xalan/java" extension-element-prefixes="redirect xalan java" exclude-result-prefixes="fdl wsdl bpel bpc tel" version="1.0">
	<!--
			  BEGIN CMVC
			  *************************************************************************
			  
			  Workfile: BPCSRVR/ws/code/workflow.fdl2bpel/src/com/ibm/bpe/fdl2bpel/converter/v602/xfdl2bpel_bpel.xsl, WAS.workflow, WBI602.BPCSRVR, m0705.08
			  Last update: 07/01/11 04:33:19
			  SCCS path, id: /family/botp/vc/10/8/3/1/s.70 1.52
			  
			  *************************************************************************
			  END CMVC
			  BEGIN COPYRIGHT
			  *************************************************************************
			  
			  IBM Confidential
			  OCO Source Materials
			  5655-FLW (C) Copyright IBM Corporation 2003, 2006.
			  The source code for this program is not published or otherwise
			  divested of its trade secrets, irrespective of what has been
			  deposited with the U.S. Copyright Office.
			  
			  *************************************************************************
			  END COPYRIGHT
	-->
	<!--
		*****************************************************************************************************************************
		    	Version:  WBI 6.0.2
		*****************************************************************************************************************************
		    	Task:      Create a BPEL file that represents a business process
		*****************************************************************************************************************************
		    	Author: Jens Grotrian (jgr@de.ibm.com)
		*****************************************************************************************************************************
	 -->
	<xsl:strip-space elements="*"/>
	<xsl:output method="xml" indent="yes" xalan:indent-amount="5"/>
	<!--************************************ -->
	<!--*        Configurable parameters   * -->
	<!--************************************ -->
	<!-- "xsdfile": XMLSchema definition file for FDL data types -->
	<xsl:param name="xsdfile"/>
	<!-- "wsdlfile": path of target directory -->
	<xsl:param name="wsdlfile" select="''"/>
	<!-- "outputdir": path of target directory -->
	<xsl:param name="outputdir" select="''"/>
	<!-- "wsdlNamespace": WSDL namespace -->
	<xsl:param name="wsdlNamespace" select="'http://schemas.xmlsoap.org/wsdl/'"/>
	<!-- "telNamespace": TEL namespace -->
	<xsl:param name="telNamespace" select="'http://www.ibm.com/xmlns/prod/websphere/human-task/6.0.0/'"/>
	<!-- "wsdlTargetNamespace": target namespace of imported WSDL file -->
	<xsl:param name="wsdlTargetNamespace" select="'http://www.ibm.com/xmlns/prod/websphere/mqwf/wsdl/'"/>
	<!-- "telTargetNamespace": target namespace of imported TEL files -->
	<xsl:param name="telTargetNamespace" select="'http://www.ibm.com/xmlns/prod/websphere/mqwf/tel/'"/>
	<!-- "process-name": the name of the FDL process to be converted -->
	<xsl:param name="process-name"/>
	<!-- "java": URI for Java expression language-->
	<xsl:param name="JAVA" select="'http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/java/6.0.0/'"/>
	<!-- "java": URI for XPath expression language-->
	<xsl:param name="XPATH" select="'http://www.w3.org/TR/1999/REC-xpath-19991116'"/>
	<!-- "java": URI for builtin expression language-->
	<xsl:param name="BUILTIN" select="'http://www.ibm.com/xmlns/prod/websphere/business-process/expression-lang/built-in/6.0.0/'"/>
	<!-- "queryLanguage": BPEL attribute "queryLanguage" -->
	<xsl:param name="queryLanguage" select="'http://www.w3.org/TR/1999/REC-xpath-19991116'"/>
	<!-- "locale": language locale -->
	<xsl:param name="locale" select="'en-US'"/>
	<!-- "initializePredefinedDataMembers": Initialize the predefined data members _ACTIVITY,  _PROCESS_MODEL -->
	<xsl:param name="initializePredefinedDataMembers" select="'FALSE'"/>
	<!-- "createPredefinedDataMembers": Create the predefined MQWF data structure members -->
	<xsl:param name="createPredefinedDataMembers" select="'TRUE'"/>
	<!-- "enable_LI354_GlobalKeyData" -->
	<xsl:param name="enable_LI354_GlobalKeyData" select="'TRUE'"/>
	<!-- "enable_LI566_LateBoundSubprocess" -->
	<xsl:param name="enable_LI566_LateBoundSubprocess" select="'TRUE'"/>
	<!-- "enable_LI932_ActivityExpiration" -->
	<xsl:param name="enable_LI932_ActivityExpiration" select="'FALSE'"/>
	<!-- "enable_LI976_Eliminate_long_names" -->
	<xsl:param name="enable_LI976_Eliminate_long_names" select="'FALSE'"/>
	<!-- "create_Java_Snippets" -->
	<xsl:param name="create_Java_Snippets" select="'TRUE'"/>
	<!-- "merge_the_output_of_a_staff_activity" -->
	<xsl:param name="merge_the_output_of_a_staff_activity" select="'FALSE'"/>
	<!-- "merge_the_output_of_a_staff_activity" -->
	<xsl:param name="merge_the_output_of_a_process_activity" select="'TRUE'"/>
	<!--************************** -->
	<!--*        Parameters         * -->
	<!--************************** -->
	<!-- "end of line" character string -->
	<xsl:param name="eol" select='"&#xA;"'/>
	<!-- "partner-link-suffix": Suffix appended to "partner link" names -->
	<xsl:param name="partner-link-suffix" select="'_PL'"/>
	<!-- "input-variable-suffix": Suffix appended to names of data input "variables" -->
	<xsl:param name="input-variable-suffix" select="'_IN'"/>
	<!-- "UPES-input-variable-suffix": Suffix appended to names of UPES data input "variables" -->
	<xsl:param name="UPES-input-variable-suffix" select="'_UPES_IN'"/>
	<!-- "output-variable-suffix": Suffix appended to names of data output "variables" -->
	<xsl:param name="output-variable-suffix" select="'_OUT'"/>
	<!-- "UPES-output-variable-suffix": Suffix appended to names of UPES data output "variables" -->
	<xsl:param name="UPES-output-variable-suffix" select="'_UPES_OUT'"/>
	<!-- "human-task-output-variable-suffix": Suffix appended to names of human task data output "variables" -->
	<xsl:param name="human-task-output-variable-suffix" select="'_HT_OUT'"/>
	<!-- "subprocess-output-variable-suffix": Suffix appended to names of subprocess data output "variables" -->
	<xsl:param name="subprocess-output-variable-suffix" select="'_SP_OUT'"/>
	<!-- "status-variable-suffix": Suffix appended to names of activity status "variables" -->
	<xsl:param name="status-variable-suffix" select="'_ST'"/>
	<!-- "activity-started-indicator": Indicator used as value of status "variables" -->
	<xsl:param name="activity-started-indicator" select="'started'"/>
	<!-- "activity-status-reset-indicator": Indicator used as value of status "variables" -->
	<xsl:param name="activity-status-reset-indicator" select="''"/>
	<!-- "maxDisplayNameLength": maximum number of characters in a display name -->
	<xsl:param name="maxDisplayNameLength" select="64"/>
	<!-- "maxDescriptionFieldLength": maximum number of characters in a description field -->
	<xsl:param name="maxDescriptionFieldLength" select="254"/>
	<!-- "maxDocumentationFieldLength": maximum number of characters in a description field -->
	<xsl:param name="maxDocumentationFieldLength" select="4096"/>
	<!-- "default-validFrom": default value for process attribute "validFrom" -->
	<xsl:param name="default-validFrom" select="'2000-01-01T00:00:00'"/>
	<!-- "ActivityImplInvoke": XML message type for UPES invocation -->
	<xsl:param name="ActivityImplInvoke" select="'ActivityImplInvoke'"/>
	<!-- "ptask-name-suffix": Suffix appended to task name -->
	<xsl:param name="ptask-name-suffix" select="'_PTASK'"/>
	<!-- "process-admin-task-suffix": Suffix appended to a process administration task name -->
	<xsl:param name="process-admin-task-suffix" select="'_ATASK_PROC'"/>
	<!-- "activity-admin-task-suffix": Suffix appended to an activity administration task name -->
	<xsl:param name="activity-admin-task-suffix" select="'_ATASK_ACT'"/>
	<!--
		*** Parameters also used in WSDL file ***
	-->
	<!-- "lower-case-characters": "aäbcdefghijklmnoöpqrstuüvwxyz" -->
	<xsl:param name="lower-case-characters" select="'aäbcdefghijklmnoöpqrstuüvwxyz'"/>
	<!-- "Upper-case-characters": "AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ" -->
	<xsl:param name="upper-case-characters" select="'AÄBCDEFGHIJKLMNOÖPQRSTUÜVWXYZ'"/>
	<!-- activity-status-message-name -->
	<xsl:param name="activity-status-message-name" select="'ActivityStatus'"/>
	<!--"activity-status-part-name": Part name used in status "variables" -->
	<xsl:param name="activity-status-part-name" select="'ActivityStatus'"/>
	<!-- message-part-name -->
	<xsl:param name="message-part-name" select="'Part1'"/>
	<!-- "message-suffix": Suffix appended to "message" names -->
	<xsl:param name="message-suffix" select="'_MSG'"/>
	<!-- "UPES-input-message-suffix": Suffix appended to "UPES" input message names -->
	<xsl:param name="UPES-input-message-suffix" select="'_UPES_IN_MSG'"/>
	<!-- "UPES-output-message-suffix": Suffix appended to "UPES" output message names -->
	<xsl:param name="UPES-output-message-suffix" select="'_UPES_OUT_MSG'"/>
	<!-- "port-type-suffix": Suffix appended to "port type" names	-->
	<xsl:param name="port-type-suffix" select="'_PT'"/>
	<!-- "operation-suffix": Suffix appended to "operation" names	-->
	<xsl:param name="operation-suffix" select="'_OP'"/>
	<!-- "UPES-synchronous-operation-suffix": Suffix appended to synchronous UPES "operation" names -->
	<xsl:param name="UPES-synchronous-operation-suffix" select="'_UPES_S_OP'"/>
	<!-- "UPES-asynchronous-operation-suffix": Suffix appended to asynchronous UPES "operation" names -->
	<xsl:param name="UPES-asynchronous-operation-suffix" select="'_UPES_A_OP'"/>
	<!-- "partner-link-type-suffix": Suffix appended to "partner link type" names -->
	<xsl:param name="partner-link-type-suffix" select="'_PLT'"/>
	<!-- "role-suffix": Suffix appended to role names 	-->
	<xsl:param name="role-suffix" select="'_Role'"/>
	<!-- "Error" Message severity 1 -->
	<xsl:param name="Error" select="1"/>
	<!-- "Warning" Message severity 2 -->
	<xsl:param name="Warning" select="2"/>
	<!-- "Information" Message severity 3 -->
	<xsl:param name="Information" select="3"/>
	<!--
		*** Parameters also used in XSD file ***
	-->
	<!-- "message-type-suffix": Suffix appended to message type names -->
	<xsl:param name="message-type-suffix" select="'_MT'"/>
	<!-- "global-container-suffix": Suffix appended to element definitions that specify a "global container" -->
	<xsl:param name="global-container-suffix" select="'_GC'"/>
	<!--
		*** Global variables ***
	-->
	<!-- "wsdlpath": path of directory which contains the WSDL files -->
	<xsl:param name="wsdlpath" select="substring-before($xsdfile, '.')"/>
	<!--************************** -->
	<!--*        Keys                   * -->
	<!--************************** -->
	<!--
		Key "program-activity-implemented-by-programExecutionUnit" represents a "mapping" between
		programExecutionUnit (UPES) (as "key objects") and program activities (as "value objects")
	-->
	<xsl:key name="program-activity-implemented-by-programExecutionUnit" match="fdl:programActivity" use="fdl:program/@programExecutionUnit"/>
	<!--
		*****************************************************************************************************************************
		Initial template
		*****************************************************************************************************************************
	-->
	<xsl:template match="/">
		<xsl:apply-templates select="fdl:definitions/fdl:process[ @name = $process-name ]
		| fdl:definitions/fdl:create/fdl:process[ @name = $process-name ]
		| fdl:definitions/fdl:update/fdl:process[ @name = $process-name ]
		| fdl:definitions/fdl:replace/fdl:process[ @name = $process-name ]" mode="business-process"/>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
 		"business-process" template:
 		
		Creates a "process" for each "fdl:process".
		(writes the result in a separate file with extension ".bpel")
		*****************************************************************************************************************************
	-->
	<xsl:template match="fdl:process" mode="business-process">
		<xsl:variable name="variables">
			<!-- Create comment: *** Variables *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** Variables *** --&gt;', $eol)" disable-output-escaping="yes"/>
			<bpel:variables>
				<!-- Create comment: Variable for the data input of process "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Variable for the data input of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create a "variable" for the data input of the process -->
				<bpel:variable messageType="wsdl1:{fdl:input/@type}{$message-suffix}" name="{@name}{$input-variable-suffix}"/>
				<!-- Create comment: Variable for the data output of process "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Variable for the data output of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create a "variable" for the data output of the process -->
				<bpel:variable messageType="wsdl1:{fdl:output/@type}{$message-suffix}" name="{@name}{$output-variable-suffix}"/>
				<!-- Create an xsd-typed BPEL "variable" for each FDL "Global Container" -->
				<xsl:apply-templates select="fdl:globalContainer" mode="variables">
					<xsl:with-param name="process-name" select="@name"/>
				</xsl:apply-templates>
				<!-- Create "variables" for data input, data output, and optionally an auxiliary "status variable" for each activity contained in the process -->
				<xsl:choose>
					<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
						<xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="variables"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="variables">
							<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</bpel:variables>
		</xsl:variable>
		<xsl:variable name="display-name">
			<xsl:choose>
				<xsl:when test="@displayName">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="@displayName"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="@name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Determine value of "validFrom" attribute -->
		<xsl:variable name="time-stamp">
			<xsl:choose>
				<xsl:when test="@validFrom">
					<!-- Format time stamp (replace blank between date and time by letter 'T') -->
					<xsl:value-of select="concat(substring-before(@validFrom, ' '), 'T', substring-after(@validFrom, ' '))"/>
				</xsl:when>
				<xsl:otherwise>
					<!-- Create dummy time stamp (otherwise the generated BPEL file cannot be viewed with the WebSphere Studio BPEL editor) -->
					<xsl:value-of select="$default-validFrom"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<bpel:process expressionLanguage="{$XPATH}" name="{@name}" suppressJoinFailure="yes" targetNamespace="http://www.ibm.com/xmlns/prod/websphere/mqwf/bpel/" bpc:displayName="{$display-name}" bpc:executionMode="longRunning" bpc:validFrom="{$time-stamp}">
			<!-- Add "autoDelete" attribute -->
			<xsl:if test="fdl:keepProcesses/@maximumDuration">
				<xsl:choose>
					<!-- CASE: never -->
					<xsl:when test="fdl:keepProcesses/@maximumDuration = 'never'">
						<xsl:attribute name="bpc:autoDelete"><xsl:value-of select="'yes'"/></xsl:attribute>
					</xsl:when>
					<!-- CASE: forever -->
					<xsl:when test="fdl:keepProcesses/@maximumDuration = 'forever'">
						<xsl:attribute name="bpc:autoDelete"><xsl:value-of select="'no'"/></xsl:attribute>
					</xsl:when>
				</xsl:choose>
			</xsl:if>
			<!-- Check whether the process is a "peer" or "child" process -->
			<xsl:choose>
				<!-- CASE: "child" process -->
				<xsl:when test="//fdl:processActivity/fdl:process/@name = @name and not(@controlAutonomy='yes')">
					<!-- Add "autonomy" attribute with value "child" -->
					<xsl:attribute name="bpc:autonomy"><xsl:value-of select="'child'"/></xsl:attribute>
				</xsl:when>
				<!-- OTHERWISE: "peer" process -->
				<xsl:otherwise>
					<!-- Add "autonomy" attribute with value "peer" (the default) -->
					<xsl:attribute name="bpc:autonomy"><xsl:value-of select="'peer'"/></xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<!-- Add optional business relevance indicator -->
			<xsl:choose>
				<xsl:when test="fdl:activityDefaultSetting[ @auditFilterDB | @auditFilterMQ ]">
					<xsl:attribute name="bpc:businessRelevant">yes</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="bpc:businessRelevant">no</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<!--
					Issue attribute warnings
				-->
			<xsl:if test="not(@validFrom)">
				<!-- "validFrom" is mandatory for BPEL -->
				<!--COMMENT: *** CWWBMnnnnW: Missing FDL attribute "validFrom" in process "nn" (dummy value created) *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MissingAttribute_ValidFrom', @name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:if>
			<xsl:if test="fdl:keepProcesses/@maximumDuration[ not(. = 'never' or . = 'forever') ]">
				<!--COMMENT: *** CWWBMnnnnW: No BPEL mapping available for FDL option "Keep finished processes for <duration>" in process "nn" *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_KeepFinishedProcessesFor', @name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:if>
			<!-- Process description and documentation -->
			<xsl:if test="fdl:description">
				<xsl:variable name="translated-description">
					<xsl:apply-templates select="fdl:description" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="current()"/>
						<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
						<xsl:with-param name="local-variable-name" select="concat(current()/@name, $input-variable-suffix)"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-description">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-description"/>
						<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:description>
					<!-- FG added:  CDATA for query values -->
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:description>
			</xsl:if>
			<xsl:if test="fdl:documentation">
				<xsl:variable name="translated-documentation">
					<xsl:apply-templates select="fdl:documentation" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="current()"/>
						<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
						<xsl:with-param name="local-variable-name" select="concat(current()/@name, $input-variable-suffix)"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-documentation">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-documentation"/>
						<xsl:with-param name="maximum-length" select="$maxDocumentationFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-documentation) &gt; $maxDocumentationFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDocumentationFieldLength, $translated-documentation), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:documentation>
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-documentation" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:documentation>
			</xsl:if>
			<!-- Process category -->
			<xsl:if test="//fdl:processCategory">
				<bpc:customProperty name="Category">
					<bpc:value>
						<xsl:value-of select="//fdl:processCategory/@name"/>
					</bpc:value>
				</bpc:customProperty>
			</xsl:if>
			<!-- Create global Java definitions -->
			<!-- Create comment: *** Global Java Definitions *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** Global Java Definitions *** --&gt;', $eol)" disable-output-escaping="yes"/>
			<bpc:javaGlobals>
				<xsl:variable name="process-contains-UPES-activities">
					<xsl:call-template name="process-contains-UPES-activities">
						<xsl:with-param name="process" select="current()"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="$process-contains-UPES-activities = 'TRUE'">
					<bpc:import packages="commonj.sdo.DataObject"/>
				</xsl:if>
				<bpc:import packages="com.ibm.bpe.interop.WMQWFHelper"/>
				<bpc:import packages="com.ibm.websphere.bo.BOFactory"/>
				<bpc:import packages="com.ibm.websphere.bo.BOCopy"/>
				<bpc:import packages="com.ibm.websphere.sca.ServiceManager"/>
			</bpc:javaGlobals>
			<!-- Process administrator -->
			<xsl:if test="fdl:staff/fdl:processAdministrator">
				<xsl:variable name="process-admin-task-name" select="concat(@name, $process-admin-task-suffix)"/>
				<!-- Create comment: Reference to process administrator task definition -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** Reference to process administrator task definition *** --&gt;', $eol)" disable-output-escaping="yes"/>
				<bpc:adminTask name="staff:{$process-admin-task-name}"/>
				<!-- Generate TEL file -->
				<xsl:variable name="telfile-local-name" select="concat(@name, '.itel')"/>
				<xsl:variable name="telfile-path-name" select="concat($outputdir, $telfile-local-name)"/>
				<xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $telfile-local-name)"/>
				<xsl:variable name="addITel" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($telfile-path-name)"/>
				<redirect:write select="concat($outputdir, $telfile-local-name)">
					<tel:task defaultLocale="{$locale}" supportsFollowOnTask="no" supportsSubTask="no" kind="aTask" targetNamespace="{$telTargetNamespace}" name="{$process-admin-task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
						<tel:staffSettings>
							<tel:administrator>
								<tel:verb>
									<xsl:apply-templates select="fdl:staff" mode="create-staff-query-verb">
										<xsl:with-param name="name" select="@name"/>
										<xsl:with-param name="node" select="current()"/>
										<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
										<xsl:with-param name="local-variable-name" select="concat(current()/@name, $input-variable-suffix)"/>
										<xsl:with-param name="staff-resolution-target-is-an-activity" select="false()"/>
									</xsl:apply-templates>
								</tel:verb>
							</tel:administrator>
						</tel:staffSettings>
						<tel:uiSettings/>
						<tel:escalationSettings/>
					</tel:task>
				</redirect:write>
				<xsl:if test="fdl:staff/@autonomy='yes'">
					<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff autonomy flag in process "nnn" *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_StaffAutonomy', @name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
			</xsl:if>
			<xsl:if test="fdl:notification/@autonomy='yes'">
				<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL notification autonomy flag in process "nnn" *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_NotificationAutonomy', @name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:if>
			<xsl:if test="@administrationAutonomy='yes'">
				<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL administration autonomy flag in process "nnn" *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_AdministrationAutonomy', @name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:if>
			<!-- WSDL import -->
			<xsl:variable name="wsdlfile-local-name" select="substring-after($wsdlfile, $outputdir)"/>
			<bpel:import namespace="{$wsdlTargetNamespace}" location="{$wsdlfile-local-name}" importType="{$wsdlNamespace}"/>
			<!-- TEL import for process administrator aTask -->
			<xsl:if test="fdl:staff/fdl:processAdministrator">
				<xsl:variable name="telfile-local-name" select="concat(@name, '.itel')"/>
				<bpel:import namespace="{$telTargetNamespace}" location="{$telfile-local-name}" importType="{$telNamespace}"/>
			</xsl:if>
			<!-- TEL imports for "staff activity" pTask -->
			<xsl:apply-templates select="current()//fdl:programActivity" mode="TEL-file">
				<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
				<xsl:with-param name="valid-from" select="$time-stamp"/>
				<xsl:with-param name="process-name" select="@name"/>
			</xsl:apply-templates>
			<!-- Create comment: *** Partner links *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** Partner links *** --&gt;', $eol)" disable-output-escaping="yes"/>
			<bpel:partnerLinks>
				<!-- Create comment: Partner link used to invoke process "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Partner link used to invoke process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<xsl:choose>
					<!-- CASE: There is at least one process activity that invokes process "nnn" recursively -->
					<xsl:when test="descendant::fdl:processActivity/fdl:process/@name = @name">
						<!-- Create a "partnerLink" element for the service represented by the process -->
						<bpel:partnerLink partnerRole="{@name}{$role-suffix}" myRole="{@name}{$role-suffix}" partnerLinkType="wsdl1:{@name}{$partner-link-type-suffix}" name="{@name}{$partner-link-suffix}">
							<bpc:processResolver processTemplateName="{@name}"/>
						</bpel:partnerLink>
					</xsl:when>
					<!-- OTHERWISE: No recursive invocation of this process found -->
					<xsl:otherwise>
						<!-- Create a "partnerLink" element for the service represented by the process -->
						<bpel:partnerLink myRole="{@name}{$role-suffix}" partnerLinkType="wsdl1:{@name}{$partner-link-type-suffix}" name="{@name}{$partner-link-suffix}"/>
					</xsl:otherwise>
				</xsl:choose>
				<!-- Create "partnerLink" elements for the process activities contained in the process -->
				<xsl:apply-templates select="descendant::fdl:processActivity[ not( fdl:process/@name = current()/@name ) ]" mode="partner-links">
					<xsl:with-param name="process" select="current()"/>
				</xsl:apply-templates>
				<!-- Create "partnerLink" elements for the server definitions (UPES) referred to in the process -->
				<xsl:apply-templates select="//fdl:definitions/fdl:server
				| //fdl:definitions/fdl:create/fdl:server
				| //fdl:definitions/fdl:update/fdl:server
				| //fdl:definitions/fdl:replace/fdl:server" mode="partner-links">
					<xsl:with-param name="process" select="current()"/>
				</xsl:apply-templates>
			</bpel:partnerLinks>
			<xsl:copy-of select="$variables"/>
			<!-- Determine the activities that are contained in the process -->
			<xsl:variable name="activities-contained-in-process" select="fdl:programActivity | fdl:processActivity | fdl:block"/>
			<!-- Create a sequence: "receive" - "flow" - "reply" -->
			<bpel:sequence bpc:displayName="sequence" name="{generate-id()}">
				<!--
					Translate the SOURCE of the process to a "receive" activity
				-->
				<!-- Create comment: Receive the input data of process "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Receive the input data of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create "receive" activity -->
				<bpel:receive partnerLink="{@name}{$partner-link-suffix}" portType="wsdl1:{@name}{$port-type-suffix}" operation="{@name}{$operation-suffix}" variable="{@name}{$input-variable-suffix}" createInstance="yes" bpc:displayName="Receive the process input" name="Receive_the_process_input"/>
				<!--
						Translate the setting of data defaults to an "assign" activity.
				-->
				<xsl:if test="fdl:input/fdl:dataDefaults">
					<!--COMMENT: *** CWWBMnnnnW: No BPEL mapping is available for process input data defaults. *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_ProcessInputDataDefaults'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:if test="count($activities-contained-in-process) > 0 
					and (	fdl:output/fdl:dataDefaults 
					or descendant::fdl:programActivity/fdl:input/fdl:dataDefaults
					or descendant::fdl:programActivity/fdl:output/fdl:dataDefaults
					or descendant::fdl:processActivity/fdl:input/fdl:dataDefaults
					or descendant::fdl:processActivity/fdl:output/fdl:dataDefaults
					or descendant::fdl:block/fdl:input/fdl:dataDefaults
					or descendant::fdl:block/fdl:output/fdl:dataDefaults
					)">
					<!-- Create comment: *** Set the data default values *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- Set the data default values --&gt;', $eol)" disable-output-escaping="yes"/>
					<bpel:assign bpc:displayName="Set the data default values" name="Set_the_data_default_values">
						<!--
								Translate the setting of process output data defaults.
						-->
						<xsl:call-template name="set-data-fields">
							<xsl:with-param name="create-assign-activity" select="false()"/>
							<xsl:with-param name="data-fields" select="fdl:output/fdl:dataDefaults"/>
							<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
							<xsl:with-param name="variable-name" select="concat(@name, $output-variable-suffix)"/>
							<xsl:with-param name="node" select="current()"/>
							<xsl:with-param name="container-type" select="'output'"/>
						</xsl:call-template>
						<xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="data-defaults">
							<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
							<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
							<xsl:with-param name="create-assign-activity" select="false()"/>
						</xsl:apply-templates>
					</bpel:assign>
				</xsl:if>
				<!--
					Translate data connectors from the process data input container ("SOURCE") to "data mapping" ("assign" or "Java snippet") activities.
				-->
				<xsl:variable name="SOURCE-data-connectors" select="fdl:data[ @from = current()/fdl:input/@name and fdl:map ]"/>
				<xsl:choose>
					<xsl:when test="$SOURCE-data-connectors">
						<!-- Create comment: Distribute the input data of process "nnn" to the start activities of its implementation -->
						<xsl:value-of select="concat($eol, '&lt;!-- Distribute the input data of process &quot;', @name, '&quot; to the start activities of its implementation --&gt;', $eol)" disable-output-escaping="yes"/>
						<!-- If more than one data connector goes out from SOURCE, enclose the data flows ("data mapping" activities) with a "flow" activity -->
						<xsl:choose>
							<!-- CASE: more than one connector -->
							<xsl:when test="count($SOURCE-data-connectors) &gt; 1">
								<bpel:flow bpc:displayName="Distribute the process input data to the start activities" name="Distribute_the_process_input_data_to_the_start_activities">
									<!-- Translate data connectors with their respective data mappings "data mapping" ("assign" or "Java snippet") activities -->
									<xsl:choose>
										<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
											<xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
												<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
											</xsl:apply-templates>
										</xsl:when>
										<xsl:otherwise>
											<xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
												<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
												<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
											</xsl:apply-templates>
										</xsl:otherwise>
									</xsl:choose>
								</bpel:flow>
							</xsl:when>
							<!-- OTHERWISE: (exactly one connector) -->
							<xsl:otherwise>
								<!-- Translate data connectors with their respective data mappings by "data mapping" ("assign" or "Java snippet") activities -->
								<xsl:choose>
									<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
										<xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
											<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
										</xsl:apply-templates>
									</xsl:when>
									<xsl:otherwise>
										<xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
											<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
											<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
										</xsl:apply-templates>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<!-- OTHERWISE: no connector -->
					<xsl:otherwise>
						<!--COMMENT: *** CWWBMnnnnW: There is no data connector in process "nnn" that distributes the process input data. *** -->
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MissingInputDataConnector', @name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
					</xsl:otherwise>
				</xsl:choose>
				<!--
					Translate the activities and their respective control and data connectors contained in the process.
					Enclose the translation into a "flow" activity, if there are at least two activities.
				-->
				<xsl:if test="count($activities-contained-in-process) > 0">
					<!-- Create comment: *** Implementation of process "nnn" *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- Implementation of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:choose>
					<!-- CASE: more than one activity contained in the process -->
					<xsl:when test="count($activities-contained-in-process) > 1">
						<!-- Create a "flow" element -->
						<bpel:flow bpc:displayName="Execute activities contained in process" name="Execute_activities_contained_in_process">
							<!-- Translate the control connectors -->
							<xsl:if test="fdl:control">
								<!-- Create comment: Links that implement the internal control flow of process "nnn" -->
								<xsl:value-of select="concat($eol, '&lt;!-- Links that implement the internal control flow of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
								<bpel:links>
									<xsl:choose>
										<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
											<xsl:apply-templates select="fdl:control" mode="links">
												<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
											</xsl:apply-templates>
										</xsl:when>
										<xsl:otherwise>
											<xsl:apply-templates select="fdl:control" mode="links">
												<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
												<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
											</xsl:apply-templates>
										</xsl:otherwise>
									</xsl:choose>
								</bpel:links>
							</xsl:if>
							<!-- Translate the activities and their related data connectors -->
							<xsl:choose>
								<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
									<xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="activities">
										<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
										<xsl:with-param name="activity-contained-in-flow" select="true()"/>
										<xsl:with-param name="valid-from" select="$time-stamp"/>
									</xsl:apply-templates>
								</xsl:when>
								<xsl:otherwise>
									<xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="activities">
										<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
										<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
										<xsl:with-param name="activity-contained-in-flow" select="true()"/>
										<xsl:with-param name="valid-from" select="$time-stamp"/>
									</xsl:apply-templates>
								</xsl:otherwise>
							</xsl:choose>
						</bpel:flow>
					</xsl:when>
					<!-- OTHERWISE: one or no activity contained in the process -->
					<xsl:otherwise>
						<!--  No "flow" element necessary. Translate one activity, if there is one. -->
						<xsl:choose>
							<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
								<xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="activities">
									<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
									<xsl:with-param name="valid-from" select="$time-stamp"/>
								</xsl:apply-templates>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="fdl:programActivity | fdl:processActivity | fdl:block" mode="activities">
									<xsl:with-param name="variables" select="xalan:nodeset($variables)"/>
									<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
									<xsl:with-param name="valid-from" select="$time-stamp"/>
								</xsl:apply-templates>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
				<!-- Check whether there is any outbound data connector in the FDL -->
				<xsl:variable name="TARGET-data-connectors" select="fdl:data[ @to = current()/fdl:output/@name ]"/>
				<xsl:if test="not($TARGET-data-connectors)">
					<!--COMMENT: *** CWWBMnnnnW: There is no data connector in process "nnn" that collects the process output data. *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MissingOutputDataConnector', @name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<!--
					Translate the SINK of the process to a "reply" activity
				-->
				<!-- Create comment: Send the output data of process "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Send the output data of process &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create "repy" activity -->
				<bpel:reply partnerLink="{@name}{$partner-link-suffix}" portType="wsdl1:{@name}{$port-type-suffix}" operation="{@name}{$operation-suffix}" variable="{@name}{$output-variable-suffix}" bpc:displayName="Return the process output" name="Return_the_process_output"/>
			</bpel:sequence>
		</bpel:process>
	</xsl:template>
	<!--
		****************************************************************
		"TEL-file" template:
		
		Creates and imports TEL file referenced	by a "staff activity"
		****************************************************************
	 -->
	<xsl:template match="fdl:programActivity" mode="TEL-file">
		<xsl:param name="variables"/>
		<xsl:param name="valid-from"/>
		<xsl:param name="process-name"/>
		<!-- Check whether the program is a "staff activity" -->
		<xsl:variable name="program-activity-type">
			<xsl:call-template name="program-activity-type">
				<xsl:with-param name="activity" select="current()"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:if test="$program-activity-type = 'staff activity' or $program-activity-type = 'assumed staff activity'">
			<xsl:variable name="parent-process" select="current()/ancestor::fdl:process"/>
			<xsl:variable name="name-prefix">
				<xsl:apply-templates select="$parent-process" mode="activity-name-prefix">
					<xsl:with-param name="activity" select="current()"/>
				</xsl:apply-templates>
			</xsl:variable>
			<xsl:variable name="parent-name-prefix">
				<xsl:apply-templates select="$parent-process" mode="activity-parent-name-prefix">
					<xsl:with-param name="activity" select="current()"/>
				</xsl:apply-templates>
			</xsl:variable>
			<xsl:variable name="port-type">
				<xsl:choose>
					<xsl:when test="fdl:program/@name">
						<xsl:value-of select="concat('wsdl1:', fdl:program/@name, $port-type-suffix)"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="'null'"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="operation">
				<xsl:choose>
					<!-- 	Derive the operation name from the activity name, if the program attribute "structuresFromActivity" = "yes" -->
					<xsl:when test="//fdl:definitions/fdl:program[ @structuresFromActivity='yes' ]/@name = fdl:program/@name
				or //fdl:definitions/fdl:create/fdl:program[ @structuresFromActivity='yes' ]/@name = fdl:program/@name
				or //fdl:definitions/fdl:update/fdl:program[ @structuresFromActivity='yes' ]/@name = fdl:program/@name
				or //fdl:definitions/fdl:replace/fdl:program[ @structuresFromActivity='yes' ]/@name = fdl:program/@name">
						<xsl:value-of select="concat($name-prefix, @name, $operation-suffix)"/>
					</xsl:when>
					<!-- 	Otherwise, derive the operation name from the referenced program name. -->
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="fdl:program/@name">
								<xsl:value-of select="concat(fdl:program/@name, $operation-suffix)"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'null'"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="telfile-local-name">
				<xsl:choose>
					<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
						<xsl:value-of select="concat($process-name, '_', @name, '.itel')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="concat($name-prefix, @name, '.itel')"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="telfile-path-name" select="concat($outputdir, $telfile-local-name)"/>
			<xsl:variable name="task-name" select="concat($name-prefix, @name, $ptask-name-suffix)"/>
			<xsl:variable name="wsdlfile-local-name" select="substring-after($wsdlfile, $outputdir)"/>
			<!-- Create TEL-file import -->
			<bpel:import namespace="{$telTargetNamespace}" location="{$telfile-local-name}" importType="{$telNamespace}"/>
			<xsl:choose>
				<!-- CASE: specific staff assignments defined for activity -->
				<xsl:when test="fdl:staff">
					<xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $telfile-local-name)"/>
					<xsl:variable name="addITel" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($telfile-path-name)"/>
					<redirect:write select="concat($outputdir, $telfile-local-name)">
						<tel:task defaultLocale="{$locale}" kind="pTask" targetNamespace="{$telTargetNamespace}" name="{$task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
							<tel:import location="{$wsdlfile-local-name}" importType="{$wsdlNamespace}" namespace="{$wsdlTargetNamespace}"/>
							<tel:interface portType="{$port-type}" operation="{$operation}" kind="inbound"/>
							<tel:staffSettings>
								<tel:potentialOwner>
									<tel:verb>
										<xsl:apply-templates select="fdl:staff" mode="create-staff-query-verb">
											<xsl:with-param name="name" select="@name"/>
											<xsl:with-param name="node" select="current()"/>
											<xsl:with-param name="variables" select="$variables"/>
											<xsl:with-param name="name-prefix" select="$name-prefix"/>
											<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
											<xsl:with-param name="local-variable-name" select="concat($name-prefix, @name, $input-variable-suffix)"/>
										</xsl:apply-templates>
									</tel:verb>
								</tel:potentialOwner>
							</tel:staffSettings>
							<tel:uiSettings/>
							<tel:escalationSettings>
								<xsl:call-template name="create-escalation-chain">
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="activity" select="current()"/>
								</xsl:call-template>
							</tel:escalationSettings>
						</tel:task>
					</redirect:write>
				</xsl:when>
				<!-- CASE: take staff assignments defined for process -->
				<xsl:when test="$parent-process/fdl:staff">
					<xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $telfile-local-name)"/>
					<xsl:variable name="addITel" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($telfile-path-name)"/>
					<redirect:write select="concat($outputdir, $telfile-local-name)">
						<tel:task defaultLocale="{$locale}" kind="pTask" targetNamespace="{$telTargetNamespace}" name="{$task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
							<tel:import location="{$wsdlfile-local-name}" importType="{$wsdlNamespace}" namespace="{$wsdlTargetNamespace}"/>
							<tel:interface portType="{$port-type}" operation="{$operation}" kind="inbound"/>
							<tel:staffSettings>
								<tel:potentialOwner>
									<tel:verb>
										<xsl:apply-templates select="$parent-process/fdl:staff" mode="create-staff-query-verb">
											<xsl:with-param name="name" select="$parent-process/@name"/>
											<xsl:with-param name="node" select="$parent-process"/>
											<xsl:with-param name="variables" select="$variables"/>
											<xsl:with-param name="local-variable-name" select="concat($parent-process/@name, $input-variable-suffix)"/>
										</xsl:apply-templates>
									</tel:verb>
								</tel:potentialOwner>
							</tel:staffSettings>
							<tel:uiSettings/>
							<tel:escalationSettings>
								<xsl:call-template name="create-escalation-chain">
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="activity" select="current()"/>
								</xsl:call-template>
							</tel:escalationSettings>
						</tel:task>
					</redirect:write>
				</xsl:when>
				<!-- OTHERWISE: activity can be assigned to all people -->
				<xsl:otherwise>
					<redirect:write select="concat($outputdir, $telfile-local-name)">
						<xsl:variable name="message" select="java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'writeOutput', $telfile-local-name)"/>
						<xsl:variable name="addITel" select="java:com.ibm.bpe.fdl2bpel.converter.ITelList.add($telfile-path-name)"/>
						<tel:task defaultLocale="{$locale}" kind="pTask" targetNamespace="{$telTargetNamespace}" name="{$task-name}" xmlns_wsdl1="{$wsdlTargetNamespace}">
							<tel:import location="{$wsdlfile-local-name}" importType="{$wsdlNamespace}" namespace="{$wsdlTargetNamespace}"/>
							<tel:interface portType="{$port-type}" operation="{$operation}" kind="inbound"/>
							<tel:staffSettings>
								<tel:potentialOwner>
									<!-- Create comment: FDL staff query "All people" -->
									<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;All people&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
									<tel:verb>
										<tel:name>Everybody</tel:name>
									</tel:verb>
								</tel:potentialOwner>
							</tel:staffSettings>
							<tel:uiSettings/>
							<tel:escalationSettings>
								<xsl:call-template name="create-escalation-chain">
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="activity" select="current()"/>
								</xsl:call-template>
							</tel:escalationSettings>
						</tel:task>
					</redirect:write>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"partner-links" template:
		
		Creates a (unique) "partnerLink" for each "fdl:process that is referenced by "fdl:processActivity"
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:processActivity" mode="partner-links">
		<!--
			Create a "partnerLink" element only, if the current "processActivity" element does not point to an identical "process" element
			as a preceding "processActivity" within the same "process" (because then the "partnerLink" element is already created in a
			previous call of this template).
		-->
		<xsl:choose>
			<!-- CASE: subprocess name is specified at build time -->
			<xsl:when test="fdl:process/@name">
				<xsl:if test="fdl:process/@name and not( fdl:process/@name = preceding::fdl:processActivity[ ancestor::fdl:process/@name = current()/ancestor::fdl:process/@name ]/fdl:process/@name )">
					<!-- Create comment: Partner link used to invoke process "nnn" -->
					<xsl:value-of select="concat($eol, '&lt;!-- Partner link used to invoke process &quot;', fdl:process/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
					<bpel:partnerLink partnerRole="{fdl:process/@name}{$role-suffix}" partnerLinkType="wsdl1:{fdl:process/@name}{$partner-link-type-suffix}" name="{fdl:process/@name}{$partner-link-suffix}">
						<bpc:processResolver processTemplateName="{fdl:process/@name}"/>
					</bpel:partnerLink>
				</xsl:if>
			</xsl:when>
			<!-- CASE: subprocess name is specified at run time (taken from data container) -->
			<xsl:when test="fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
				<xsl:if test="'TRUE' = translate($enable_LI566_LateBoundSubprocess, $lower-case-characters, $upper-case-characters)">
					<!-- Use name prefix in order to have unique operation names -->
					<xsl:variable name="name-prefix">
						<xsl:apply-templates select="current()/ancestor::fdl:process" mode="activity-name-prefix">
							<xsl:with-param name="activity" select="current()"/>
						</xsl:apply-templates>
					</xsl:variable>
					<!-- Create comment: Partner link used to invoke late-bound subprocess invoke by process activity "nnn" -->
					<xsl:value-of select="concat($eol, '&lt;!-- Partner link used to invoke late-bound subprocess invoke by process activity &quot;', $name-prefix, @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
					<bpel:partnerLink partnerRole="{$name-prefix}{@name}{$role-suffix}" partnerLinkType="wsdl1:{$name-prefix}{@name}{$partner-link-type-suffix}" name="{$name-prefix}{@name}{$partner-link-suffix}"/>
				</xsl:if>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"partner-links" template:
		
		Creates a "partnerLink" for each"fdl:server" that is referred to in the process
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:server" mode="partner-links">
		<xsl:param name="process"/>
		<xsl:variable name="related-system-name" select="fdl:relatedSystem/@name"/>
		<xsl:variable name="related-group-name" select="fdl:relatedGroup/@name"/>
		<!-- Create partner link only if the server is referred to by some program activity -->
		<xsl:if test="key('program-activity-implemented-by-programExecutionUnit', concat(@name, '.', $related-system-name, '.', $related-group-name))[ @name = $process//fdl:programActivity/@name ]">
			<!-- Create comment: partner link used to invoke server "nnn" -->
			<xsl:value-of select="concat($eol, '&lt;!-- Partner link used to invoke server &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			<bpel:partnerLink partnerRole="{@name}{$role-suffix}" partnerLinkType="wsdl1:{@name}{$partner-link-type-suffix}" name="{@name}{$partner-link-suffix}"/>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"variables" template:
		
		Creates a data input and a data output "variable" for each FDL program activity.
		Creates an additional pair of UPES input/output variables for a "service invocation activity".
		Assigns qualified names to the variables using a prefix that indicates the position of the related
		activity in the process hierarchy.
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:programActivity" mode="variables">
		<xsl:param name="name-prefix" select="''"/>
		<xsl:variable name="program-activity-type">
			<xsl:call-template name="program-activity-type">
				<xsl:with-param name="activity" select="current()"/>
			</xsl:call-template>
		</xsl:variable>
		<!-- Create comment: Data input variable of activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Data input variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create BPEL variable for activity data input -->
		<bpel:variable messageType="wsdl1:{fdl:input/@type}{$message-suffix}" name="{$name-prefix}{@name}{$input-variable-suffix}"/>
		<!-- Create comment: Data output variable of activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create BPEL variable for activity data output -->
		<bpel:variable messageType="wsdl1:{fdl:output/@type}{$message-suffix}" name="{$name-prefix}{@name}{$output-variable-suffix}"/>
		<!-- Create auxiliary "status variable" that is used for loop control, if the attribute "exitCondition" is defined -->
		<xsl:if test="fdl:exitCondition or ('TRUE' = translate($enable_LI932_ActivityExpiration, $lower-case-characters, $upper-case-characters) and following-sibling::fdl:control[ @from = current()/@name ]//fdl:state/@name = '_Expired')">
			<!-- Create comment: Auxiliary status variable of activity "nnn" -->
			<xsl:value-of select="concat($eol, '&lt;!-- Auxiliary status variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			<!-- Create auxiliary BPEL variable for activity status -->
			<bpel:variable messageType="wsdl1:{$activity-status-message-name}{$message-suffix}" name="{$name-prefix}{@name}{$status-variable-suffix}"/>
		</xsl:if>
		<xsl:choose>
			<!-- CASE: staff activity -->
			<xsl:when test="($program-activity-type='staff activity' or $program-activity-type='assumed staff activity')
		                    and 'TRUE' = translate($merge_the_output_of_a_staff_activity, $lower-case-characters, $upper-case-characters)">
				<!-- Create comment: human task data output variable of activity "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- human task data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create BPEL variable for human task data output -->
				<bpel:variable messageType="wsdl1:{fdl:output/@type}{$message-suffix}" name="{$name-prefix}{@name}{$human-task-output-variable-suffix}"/>
			</xsl:when>
			<!-- CASE: service invocation activity (UPES activity) -->
			<xsl:when test="$program-activity-type = 'service invocation activity'">
				<!-- Create comment: UPES data input variable of activity "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- UPES data input variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create BPEL variable for activity UPES data input -->
				<xsl:choose>
					<!-- CASE: data structures of input and output are the same (use simple type name) -->
					<xsl:when test="fdl:input/@type = fdl:output/@type">
						<bpel:variable messageType="wsdl1:{fdl:input/@type}{$UPES-input-message-suffix}" name="{$name-prefix}{@name}{$UPES-input-variable-suffix}"/>
					</xsl:when>
					<!--
					OTHERWISE: different data structures of input and output (type name consists of
								    a combination of input and output data structures names)
				-->
					<xsl:otherwise>
						<bpel:variable messageType="wsdl1:{fdl:input/@type}_{fdl:output/@type}{$UPES-input-message-suffix}" name="{$name-prefix}{@name}{$UPES-input-variable-suffix}"/>
					</xsl:otherwise>
				</xsl:choose>
				<!-- Determine the UPES execution mode (synchronous or asynchronous) -->
				<xsl:variable name="UPES-execution-mode">
					<xsl:call-template name="UPES-execution-mode">
						<xsl:with-param name="activity" select="current()"/>
					</xsl:call-template>
				</xsl:variable>
				<!-- Add UPES data output variable for synchronous execution mode -->
				<xsl:if test="$UPES-execution-mode = 'synchronous'">
					<!-- Create comment: UPES data output variable of activity "nnn" -->
					<xsl:value-of select="concat($eol, '&lt;!-- UPES data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
					<!-- Create BPEL variable for activity UPES data output -->
					<bpel:variable messageType="wsdl1:{fdl:output/@type}{$UPES-output-message-suffix}" name="{$name-prefix}{@name}{$UPES-output-variable-suffix}"/>
				</xsl:if>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"variables" template:
		
		Creates a data input and a data output "variable" for each FDL process activity.
		Creates an additional output variable that receives the subprocess output data (which will be "merged" with any
        default data in a subsequent "Java snippet").
		Assigns qualified names to the variables using a prefix that indicates the position of the related
		activity in the process hierarchy.
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:processActivity" mode="variables">
		<xsl:param name="name-prefix" select="''"/>
		<!-- Create comment: Data input variable of activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Data input variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create BPEL variable for activity data input -->
		<bpel:variable messageType="wsdl1:{fdl:input/@type}{$message-suffix}" name="{$name-prefix}{@name}{$input-variable-suffix}"/>
		<!-- Create comment: Data output variable of activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create BPEL variable for activity data output -->
		<bpel:variable messageType="wsdl1:{fdl:output/@type}{$message-suffix}" name="{$name-prefix}{@name}{$output-variable-suffix}"/>
		<xsl:if test="'TRUE' = translate($merge_the_output_of_a_process_activity, $lower-case-characters, $upper-case-characters)">
			<!-- Create comment: subprocess data output variable of activity "nnn" -->
			<xsl:value-of select="concat($eol, '&lt;!-- subprocess data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			<!-- Create BPEL variable for subprocess data output -->
			<bpel:variable messageType="wsdl1:{fdl:output/@type}{$message-suffix}" name="{$name-prefix}{@name}{$subprocess-output-variable-suffix}"/>
		</xsl:if>
		<!-- Create auxiliary "status variable" that is used for loop control, if the attribute "exitCondition" is defined -->
		<xsl:if test="fdl:exitCondition or ('TRUE' = translate($enable_LI932_ActivityExpiration, $lower-case-characters, $upper-case-characters) and following-sibling::fdl:control[ @from = current()/@name ]//fdl:state/@name = '_Expired')">
			<!-- Create comment: Auxiliary status variable of activity "nnn" -->
			<xsl:value-of select="concat($eol, '&lt;!-- Auxiliary status variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			<!-- Create auxiliary BPEL variable for activity status -->
			<bpel:variable messageType="wsdl1:{$activity-status-message-name}{$message-suffix}" name="{$name-prefix}{@name}{$status-variable-suffix}"/>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"variables" template:
		
		Creates a data input and a data output "variable" for each FDL block activity.
		Creates variables contained in the block.
		Assigns qualified names to the variables using a prefix that indicates the position of the related
		activity in the process hierarchy.
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:block" mode="variables">
		<xsl:param name="name-prefix" select="''"/>
		<!-- Create comment: Data input variable of activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Data input variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create BPEL variable for activity data input -->
		<bpel:variable messageType="wsdl1:{fdl:input/@type}{$message-suffix}" name="{$name-prefix}{@name}{$input-variable-suffix}"/>
		<!-- Create comment: Data output variable of activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Data output variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create BPEL variable for activity data output -->
		<bpel:variable messageType="wsdl1:{fdl:output/@type}{$message-suffix}" name="{$name-prefix}{@name}{$output-variable-suffix}"/>
		<!-- Create auxiliary "status variable" that is used for loop control, if the attribute "exitCondition" is defined -->
		<xsl:if test="fdl:exitCondition or ('TRUE' = translate($enable_LI932_ActivityExpiration, $lower-case-characters, $upper-case-characters) and following-sibling::fdl:control[ @from = current()/@name ]//fdl:state/@name = '_Expired')">
			<!-- Create comment: Auxiliary status variable of activity "nnn" -->
			<xsl:value-of select="concat($eol, '&lt;!-- Auxiliary status variable of activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			<!-- Create auxiliary BPEL variable for activity status -->
			<bpel:variable messageType="wsdl1:{$activity-status-message-name}{$message-suffix}" name="{$name-prefix}{@name}{$status-variable-suffix}"/>
		</xsl:if>
		<xsl:variable name="child-name-prefix">
			<xsl:choose>
				<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
					<!-- Cascaded name prefix not required: return existing prefix -->
					<xsl:value-of select="$name-prefix"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$name-prefix = ''">
							<xsl:value-of select="concat(@name, '_')"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="concat($name-prefix, @name, '_')"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Create "variables" for data input, data output, and optionally an auxiliary "status variable" for each activity contained in the block -->
		<xsl:apply-templates select="fdl:blockImplementation/fdl:programActivity | fdl:blockImplementation/fdl:processActivity | fdl:blockImplementation/fdl:block" mode="variables">
			<xsl:with-param name="name-prefix" select="$child-name-prefix"/>
		</xsl:apply-templates>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"variables" template:
		
		Creates an xsd-typed BPEL "variable" that represents a "Global Container" (if present in the FDL file)
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:globalContainer" mode="variables">
		<xsl:param name="process-name"/>
		<xsl:variable name="global-container-type">
			<xsl:choose>
				<!-- CASE: parameter "createPredefinedDataMembers" is set to "true" -->
				<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
					<xsl:value-of select="concat('mqwf:', @type, $global-container-suffix)"/>
				</xsl:when>
				<!-- OHERWISE: It is assumed, that parameter "createPredefinedDataMembers" is set to "false" -->
				<xsl:otherwise>
					<xsl:value-of select="concat('mqwf:', @type)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Create comment: "Global Container" variable -->
		<xsl:value-of select="concat($eol, '&lt;!-- &quot;Global Container&quot; variable --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create BPEL variable for "Global Container" -->
		<bpel:variable element="{$global-container-type}" name="GLOBAL_CONTAINER">
			<!-- Verify that the referenced FDL data structure is missing or not empty -->
			<xsl:choose>
				<!-- CASE: missing data structure definition -->
				<xsl:when test="not(//fdl:structure[ @name = current()/@type ])">
					<xsl:variable name="missing-object" select="concat('data structure &quot;', current()/@type, '&quot;')"/>
					<xsl:variable name="location" select="local-name(current())"/>
					<!--COMMENT: *** CWWBMnnnnW: The data structure "nnn" is used at "nnn" of process "nnn", but is not defined in the FDL. *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'IncorrectFDL_MissingObject', $missing-object, $location, $process-name), ' *** --&gt;', $eol)" disable-output-escaping="no"/>
				</xsl:when>
				<!-- CASE: empty data structure definition -->
				<xsl:when test="//fdl:structure[ @name = current()/@type and not( fdl:member ) ]">
					<xsl:variable name="empty-data-structure" select="current()/@type"/>
					<!--COMMENT: *** CWWBMnnnnW: The global container of process "nnn" is specified with an empty data structure ("nnn"). *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'IncorrectFDL_EmptyDataStructureInGlobalContainer', $process-name, $empty-data-structure), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:when>
				<!-- OTHERWISE: create key data properties -->
				<xsl:otherwise>
					<xsl:call-template name="createKeyDataProperties">
						<xsl:with-param name="globalContainer" select="current()"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</bpel:variable>
	</xsl:template>
	<!--				
		*****************************************************************************************************************************
		"variables" template "createKeyDataProperties"
		
		Creates the key data properties of BPEL variable "GLOBAL_CONTAINER"
		*****************************************************************************************************************************
	 -->
	<xsl:template name="createKeyDataProperties">
		<xsl:param name="globalContainer"/>
		<xsl:if test="'TRUE' = translate($enable_LI354_GlobalKeyData, $lower-case-characters, $upper-case-characters)">
			<bpc:queryProperties>
				<xsl:for-each select="//fdl:structure[ @name = $globalContainer/@type ]/fdl:member">
					<xsl:variable name="type">
						<xsl:choose>
							<xsl:when test="'STRING' = translate(@type, $lower-case-characters, $upper-case-characters)">
								<xsl:text>xsd:string</xsl:text>
							</xsl:when>
							<xsl:when test="'LONG' = translate(@type, $lower-case-characters, $upper-case-characters)">
								<xsl:text>xsd:long</xsl:text>
							</xsl:when>
							<xsl:when test="'FLOAT' = translate(@type, $lower-case-characters, $upper-case-characters)">
								<xsl:text>xsd:float</xsl:text>
							</xsl:when>
							<xsl:when test="'BINARY' = translate(@type, $lower-case-characters, $upper-case-characters)">
								<xsl:text>xsd:base64Binary</xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<xsl:text>mqwf:</xsl:text>
								<xsl:value-of select="@type"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<bpc:queryProperty type="{$type}" name="{@name}">
						<bpc:query>
							<xsl:choose>
								<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
									<!-- FG added:  CDATA for query values -->
									<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
									<xsl:value-of select="concat('/_STRUCT/', @name)" disable-output-escaping="yes"/>
									<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
								</xsl:when>
								<xsl:otherwise>
									<!-- FG added:  CDATA for query values -->
									<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
									<xsl:value-of select="concat('/', @name)" disable-output-escaping="yes"/>
									<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
								</xsl:otherwise>
							</xsl:choose>
						</bpc:query>
					</bpc:queryProperty>
				</xsl:for-each>
			</bpc:queryProperties>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"links" template:
		
		Creates a "link" for each "fdl:control"
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:control" mode="links">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<!-- The control connector "from" variable should be the output variable of a local activity -->
		<xsl:variable name="from-variable-name" select="concat($name-prefix, @from, $output-variable-suffix)"/>
		<bpel:link name="{@from}-to-{@to}">
			<!-- Control connector description -->
			<xsl:if test="fdl:description">
				<xsl:variable name="display-name">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="concat(@from, ' - ', @to)"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="translated-description">
					<xsl:apply-templates select="fdl:description" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="current()"/>
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
						<xsl:with-param name="local-variable-name" select="$from-variable-name"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-description">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-description"/>
						<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:description>
					<!-- FG added:  CDATA for query values -->
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:description>
			</xsl:if>
		</bpel:link>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"activities" template:

		Translates "fdl:programActivity" and "fdl:processActivity" to "invoke" activities.
		Translates "fdl:block" to a "flow" activity that is enclosed in a "sequence" element.
		Encloses the respective "invoke" or "flow" activities in a "while" activity, if  attribute "exitCondition" is defined.
		Adds "data mapping" activities ("assign" or "Java snippet") that map the output data to the following activities.
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:programActivity | fdl:processActivity | fdl:block" mode="activities">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="valid-from"/>
		<xsl:param name="activity-contained-in-flow" select="false()"/>
		<xsl:variable name="outbound-data-connectors" select="current()/../fdl:data[ @from = current()/@name ]"/>
		<xsl:variable name="display-name">
			<xsl:choose>
				<xsl:when test="@displayName">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="@displayName"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="@name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Create comment: Activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Activity &quot;', @name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<xsl:choose>
			<!-- CASE: outbound data connectors found -->
			<xsl:when test="$outbound-data-connectors">
				<!--
					If the activity is contained in a "flow" element, then enforce the correct order of
				 	activity invocation and data flow with a "sequence" element
				 -->
				<xsl:choose>
					<xsl:when test="$activity-contained-in-flow = 'true'">
						<bpel:sequence bpc:displayName="{$display-name}" name="{generate-id()}">
							<xsl:call-template name="create-standard-elements">
								<xsl:with-param name="activity" select="current()"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							</xsl:call-template>
							<xsl:call-template name="translate-activity-with-outbound-data-connectors">
								<xsl:with-param name="activity" select="current()"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="valid-from" select="$valid-from"/>
								<xsl:with-param name="outbound-data-connectors" select="$outbound-data-connectors"/>
							</xsl:call-template>
						</bpel:sequence>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="translate-activity-with-outbound-data-connectors">
							<xsl:with-param name="activity" select="current()"/>
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							<xsl:with-param name="valid-from" select="$valid-from"/>
							<xsl:with-param name="outbound-data-connectors" select="$outbound-data-connectors"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- OTHERWISE: no outbound data connectors found -->
			<xsl:otherwise>
				<!--
					If the activity is contained in a "flow" element, then enforce the correct order of
				 	activity invocation and data flow with a "sequence" element
				 -->
				<xsl:choose>
					<xsl:when test="$activity-contained-in-flow = 'true'">
						<bpel:sequence bpc:displayName="{$display-name}" name="{generate-id()}">
							<xsl:call-template name="create-standard-elements">
								<xsl:with-param name="activity" select="current()"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							</xsl:call-template>
							<xsl:call-template name="translate-activity-without-outbound-data-connectors">
								<xsl:with-param name="activity" select="current()"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="valid-from" select="$valid-from"/>
							</xsl:call-template>
						</bpel:sequence>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="translate-activity-without-outbound-data-connectors">
							<xsl:with-param name="activity" select="current()"/>
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							<xsl:with-param name="valid-from" select="$valid-from"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "translate-activity-with-outbound-data-connectors":

		Called by an "activities" template.
		****************************************************************************************************************
	 -->
	<xsl:template name="translate-activity-with-outbound-data-connectors">
		<xsl:param name="activity"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="valid-from"/>
		<xsl:param name="outbound-data-connectors"/>
		<xsl:choose>
			<!--  Enclose activity with a "while" activity, if the attribute "exitCondition" is defined. -->
			<xsl:when test="$activity/fdl:exitCondition">
				<xsl:call-template name="translate-activity">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="valid-from" select="$valid-from"/>
					<xsl:with-param name="activity-has-exitCondition" select="true()"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="translate-activity">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="valid-from" select="$valid-from"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		<!-- Translate outbound data connectors with their respective data mappings by "data mapping" ("assign" or "Java snippet") activities -->
		<!-- If there is more than one outbound data connector, enclose the data flows ("data mapping" activities) with a "flow" activity -->
		<!--
			*******************************************************************************************************************************
			CAUTION: BUG OF THE XALAN TRANSLATOR WHILE RECURSIVE TEMPLATE INVOCATION !!!
			*******************************************************************************************************************************
			The value of variable $outbound-data-connectors is lost here, when a block (or block in a block) is processed.
			That is why another variable $outbound-data-connectors1 is used to redetermine the outbound data connectors.
			*******************************************************************************************************************************
		 -->
		<xsl:variable name="outbound-data-connectors1" select="$activity/../fdl:data[ @from = $activity/@name and fdl:map ]"/>
		<xsl:choose>
			<!-- CASE: more than one connector -->
			<!-- <xsl:when test="count($outbound-data-connectors) &gt; 1"> -->
			<xsl:when test="count($outbound-data-connectors1) &gt; 1">
				<bpel:flow bpc:displayName="Distribute the activity output data" name="{generate-id()}">
					<!-- Translate outbound data connectors with their respective data mappings by "data mapping" ("assign" or "Java snippet") activities -->
					<!-- <xsl:apply-templates select="$outbound-data-connectors" mode="data"> -->
					<xsl:apply-templates select="$outbound-data-connectors1" mode="data">
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					</xsl:apply-templates>
				</bpel:flow>
			</xsl:when>
			<!-- OTHERWISE: exactly one connector -->
			<xsl:otherwise>
				<!-- Translate outbound data connector with its respective data mappings by a "data mapping" ("assign" or "Java snippet") activity -->
				<!--	<xsl:apply-templates select="$outbound-data-connectors" mode="data">  -->
				<xsl:apply-templates select="$outbound-data-connectors1" mode="data">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "translate-activity-without-outbound-data-connectors":

		Called by an "activities" template.
		****************************************************************************************************************
	 -->
	<xsl:template name="translate-activity-without-outbound-data-connectors">
		<xsl:param name="activity"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="valid-from"/>
		<xsl:choose>
			<!-- Enclose activity with a "while" activity, if the attribute "exitCondition" is defined. -->
			<xsl:when test="$activity/fdl:exitCondition">
				<xsl:call-template name="translate-activity">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="valid-from" select="$valid-from"/>
					<xsl:with-param name="activity-has-exitCondition" select="true()"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="translate-activity">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="valid-from" select="$valid-from"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "translate-activity":

		Called by an "activities" template.
		Translates "fdl:programActivity" and "fdl:processActivity" to "invoke" activities.
		Translates "fdl:block" to a "flow" activity that is enclosed in a "sequence" element.
		****************************************************************************************************************
	 -->
	<xsl:template name="translate-activity">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="activity"/>
		<xsl:param name="valid-from"/>
		<xsl:param name="activity-has-exitCondition" select="false()"/>
		<!-- Add "data mapping" ("assign" or "Java snippet") activity that maps the input data to the output, if there is a "data default connector" -->
		<xsl:apply-templates select="$activity/../fdl:data[ @default = $activity/@name ]" mode="data">
			<xsl:with-param name="variables" select="$variables"/>
			<xsl:with-param name="name-prefix" select="$name-prefix"/>
			<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
		</xsl:apply-templates>
		<xsl:choose>
			<!--  Enclose activity with a "while" activity, if the attribute "exitCondition" is defined. -->
			<xsl:when test="$activity-has-exitCondition">
				<xsl:call-template name="create-while-activity">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="valid-from" select="$valid-from"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="'TRUE' = translate($enable_LI932_ActivityExpiration, $lower-case-characters, $upper-case-characters) and $activity/following-sibling::fdl:control[ @from = $activity/@name ]//fdl:state/@name = '_Expired'">
						<bpel:scope bpc:displayName="scope" name="generate-id()">
							<bpel:faultHandlers>
								<bpel:catch faultName="bpc:timeout">
									<xsl:call-template name="create-activity-expiration-fault-handler">
										<xsl:with-param name="variables" select="$variables"/>
										<xsl:with-param name="name-prefix" select="$name-prefix"/>
										<xsl:with-param name="activity" select="$activity"/>
									</xsl:call-template>
								</bpel:catch>
							</bpel:faultHandlers>
							<xsl:call-template name="create-activity">
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="activity" select="$activity"/>
								<xsl:with-param name="valid-from" select="$valid-from"/>
							</xsl:call-template>
						</bpel:scope>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="create-activity">
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							<xsl:with-param name="activity" select="$activity"/>
							<xsl:with-param name="valid-from" select="$valid-from"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "create-while-activity":

		Called by "translate-activity" template.
		
		Encloses activity with a "while" activity, if the attribute "exitCondition" is defined.
		Note that the "while" condition expression must be set to the negation of the original "exit" condition expression.
		Moreover, extending the "while" condition expression by a check of an "activity-started" indicator ensures that
		the activity will be executed at least once.
		****************************************************************************************************************
	 -->
	<xsl:template name="create-while-activity">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="activity"/>
		<xsl:param name="valid-from"/>
		<xsl:variable name="status-variable" select="concat($name-prefix, $activity/@name, $status-variable-suffix)"/>
		<xsl:variable name="status-variable-type" select="$variables//bpel:variable[@name = $status-variable]/@messageType"/>
		<!-- Create comment: Reset status variable of activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Reset status variable of activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create "assign" activity that resets the "activity-started" indicator -->
		<xsl:call-template name="create-assign-activity-to-set-BPEL-variable">
			<xsl:with-param name="BPEL-variable" select="$status-variable"/>
			<xsl:with-param name="BPEL-variable-value" select="' '"/>
		</xsl:call-template>
		<bpel:while bpc:displayName="while" name="{generate-id()}">
			<bpel:condition expressionLanguage="{$XPATH}">
				<!-- Create XPath expression for activity exit condition -->
				<xsl:call-template name="create-condition-xpath-expression">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="condition" select="$activity/fdl:exitCondition/fdl:condition"/>
					<xsl:with-param name="condition-applies-to-activity-exit" select="true()"/>
				</xsl:call-template>
			</bpel:condition>
			<bpel:sequence bpc:displayName="sequence" name="{generate-id()}">
				<!-- Create comment: Set status variable of activity "nnn" to "started" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Set status variable of activity &quot;', $activity/@name, '&quot; to &quot;started&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create "assign" activity that sets the "activity-started" indicator -->
				<xsl:call-template name="create-assign-activity-to-set-BPEL-variable">
					<xsl:with-param name="BPEL-variable" select="$status-variable"/>
					<xsl:with-param name="BPEL-variable-value" select="'started'"/>
				</xsl:call-template>
				<xsl:choose>
					<xsl:when test="'TRUE' = translate($enable_LI932_ActivityExpiration, $lower-case-characters, $upper-case-characters) and ($activity/fdl:exitCondition//fdl:state/@name = '_Expired' or $activity/following-sibling::fdl:control[ @from = $activity/@name ]//fdl:state/@name = '_Expired')">
						<bpel:scope bpc:displayName="scope" name="{generate-id()}">
							<bpel:faultHandlers>
								<bpel:catch faultName="bpc:timeout">
									<xsl:call-template name="create-activity-expiration-fault-handler">
										<xsl:with-param name="variables" select="$variables"/>
										<xsl:with-param name="name-prefix" select="$name-prefix"/>
										<xsl:with-param name="activity" select="$activity"/>
									</xsl:call-template>
								</bpel:catch>
							</bpel:faultHandlers>
							<xsl:call-template name="create-activity">
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="activity" select="$activity"/>
								<xsl:with-param name="valid-from" select="$valid-from"/>
							</xsl:call-template>
						</bpel:scope>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="create-activity">
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							<xsl:with-param name="activity" select="$activity"/>
							<xsl:with-param name="valid-from" select="$valid-from"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</bpel:sequence>
		</bpel:while>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "create-activity":

		Called by an "activities" template.
		Translates "fdl:programActivity" and "fdl:processActivity" to "invoke" activities.
		Translates "fdl:block" to a "flow" activity that is enclosed in a "sequence" element.
		****************************************************************************************************************
	 -->
	<xsl:template name="create-activity">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:param name="valid-from"/>
		<xsl:variable name="display-name">
			<xsl:choose>
				<xsl:when test="$activity/@displayName">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@displayName"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<!--
			 	CASE: "fdl:programActivity"
			 -->
			<xsl:when test="local-name($activity) = 'programActivity'">
				<!--
					Check whether the program activity maps to one of the following BPEL activities:
						"service invocation activity"
						"staff activity"
						"empty activity"
					If it cannot be mapped to any of them ("unclassified activity") the returned activity type is
					an "assumed staff activity" and a respective warning will be inserted as a comment.
				-->
				<xsl:variable name="program-activity-type">
					<xsl:call-template name="program-activity-type">
						<xsl:with-param name="activity" select="$activity"/>
					</xsl:call-template>
				</xsl:variable>
				<!--
					  If the unsupported option "Program execution server from container" is selected issue a warning.
				-->
				<xsl:if test="$activity/fdl:program/fdl:dataStructureMemberName">
					<!--COMMENT: *** CWWBMnnnnW: Option "Program execution server from container" of program activity "nn" cannot be mapped to BPEL. *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_ProgramExecutionServerTakenFrom', $activity/@name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<!--
					Create an "UPES activity", if the program activity type equals "service invocation activity".
					Create an "empty activity", if the program activity type equals "empty activity".
					Otherwise, create a "standard" activity.
				-->
				<xsl:choose>
					<!-- CASE: service invocation (UPES) activity -->
					<xsl:when test="$program-activity-type = 'service invocation activity'">
						<xsl:call-template name="create-UPES-activity">
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							<xsl:with-param name="activity" select="$activity"/>
						</xsl:call-template>
					</xsl:when>
					<!-- CASE: empty activity -->
					<xsl:when test="$program-activity-type = 'empty activity'">
						<xsl:call-template name="create-empty-activity">
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							<xsl:with-param name="activity" select="$activity"/>
						</xsl:call-template>
					</xsl:when>
					<!-- OTHERWISE: standard activity -->
					<xsl:otherwise>
						<xsl:call-template name="create-standard-activity">
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							<xsl:with-param name="activity" select="$activity"/>
							<xsl:with-param name="valid-from" select="$valid-from"/>
							<xsl:with-param name="program-activity-type" select="$program-activity-type"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!--
				CASE: "fdl:processActivity"
			-->
			<xsl:when test="local-name($activity) = 'processActivity'">
				<!-- Determine the value of the "portType" attribute -->
				<xsl:variable name="port-type">
					<xsl:choose>
						<xsl:when test="$activity/fdl:process/@name">
							<xsl:value-of select="concat('wsdl1:', $activity/fdl:process/@name, $port-type-suffix)"/>
						</xsl:when>
						<xsl:when test="$activity/fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
							<xsl:if test="'TRUE' = translate($enable_LI566_LateBoundSubprocess, $lower-case-characters, $upper-case-characters)">
								<xsl:value-of select="concat('wsdl1:', $name-prefix, $activity/@name, $port-type-suffix)"/>
							</xsl:if>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="'null'"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<!-- Determine the value of the "operation" attribute -->
				<xsl:variable name="operation">
					<xsl:choose>
						<xsl:when test="$activity/fdl:process/@name">
							<xsl:value-of select="concat($activity/fdl:process/@name, $operation-suffix)"/>
						</xsl:when>
						<xsl:when test="$activity/fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
							<xsl:if test="'TRUE' = translate($enable_LI566_LateBoundSubprocess, $lower-case-characters, $upper-case-characters)">
								<xsl:value-of select="concat($name-prefix, $activity/@name, $operation-suffix)"/>
							</xsl:if>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="'null'"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<!-- Determine the value of the "partnerLink" attribute -->
				<xsl:variable name="partner-link">
					<xsl:choose>
						<xsl:when test="$activity/fdl:process/@name">
							<xsl:value-of select="concat($activity/fdl:process/@name, $partner-link-suffix)"/>
						</xsl:when>
						<xsl:when test="$activity/fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
							<xsl:if test="'TRUE' = translate($enable_LI566_LateBoundSubprocess, $lower-case-characters, $upper-case-characters)">
								<xsl:value-of select="concat($name-prefix, $activity/@name, $partner-link-suffix)"/>
							</xsl:if>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="'null'"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="input-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
				<xsl:variable name="output-variable-name">
					<xsl:choose>
						<!-- CASE: process activity requires additional subprocess output variable -->
						<xsl:when test="'TRUE' = translate($merge_the_output_of_a_process_activity, $lower-case-characters, $upper-case-characters)">
							<xsl:value-of select="concat($name-prefix, $activity/@name, $subprocess-output-variable-suffix)"/>
						</xsl:when>
						<!-- OTHERWISE -->
						<xsl:otherwise>
							<xsl:value-of select="concat($name-prefix, $activity/@name, $output-variable-suffix)"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:if test="$activity/fdl:process/fdl:dataStructureMemberName/fdl:nameComponent">
					<xsl:if test="'TRUE' = translate($enable_LI566_LateBoundSubprocess, $lower-case-characters, $upper-case-characters)">
						<!-- Create comment: Assign late-bound subprocess name for process activity "nnn" -->
						<xsl:value-of select="concat($eol, '&lt;!-- Assign late-bound subprocess name for process activity &quot;', @name-prefix, $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
						<bpel:assign bpc:displayName="Assign subprocess name" name="{generate-id()}">
							<bpel:copy>
								<bpel:from>
									<bpel:expression expressionLanguage="{$XPATH}">
										<xsl:variable name="xpath-expression">
											<xsl:apply-templates select="$activity/fdl:process/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
												<xsl:with-param name="display-name" select="$display-name"/>
												<xsl:with-param name="node" select="$activity"/>
												<xsl:with-param name="variables" select="$variables"/>
												<xsl:with-param name="name-prefix" select="$name-prefix"/>
												<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
												<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
											</xsl:apply-templates>
										</xsl:variable>
										<xsl:value-of select="concat('bpc:getServiceRefForProcessTemplate(&quot;', $xpath-expression, '&quot;, &quot;', $wsdlTargetNamespace, '&quot;, &quot;', $name-prefix, $activity/@name, $partner-link-suffix, '&quot;)')"/>
									</bpel:expression>
								</bpel:from>
								<bpel:to partnerLink="{$name-prefix}{$activity/@name}{$partner-link-suffix}"/>
							</bpel:copy>
						</bpel:assign>
					</xsl:if>
				</xsl:if>
				<!-- Create comment: Invoke process activity "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Invoke process activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create "invoke" activity -->
				<bpel:invoke partnerLink="{$partner-link}" portType="{$port-type}" operation="{$operation}" outputVariable="{$output-variable-name}" inputVariable="{$name-prefix}{$activity/@name}{$input-variable-suffix}" name="{$activity/@name}">
					<!-- Add optional display name -->
					<xsl:if test="$activity/@displayName">
						<xsl:attribute name="bpc:displayName"><xsl:value-of select="$display-name"/></xsl:attribute>
					</xsl:if>
					<!-- Add optional business relevance indicator -->
					<xsl:choose>
						<xsl:when test="$activity/fdl:defaultSetting[ @auditFilterDB | @auditFilterMQ ]">
							<xsl:attribute name="bpc:businessRelevant">yes</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="bpc:businessRelevant">no</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<!-- Activity description and documentation -->
					<xsl:if test="$activity/fdl:description">
						<xsl:variable name="translated-description">
							<xsl:apply-templates select="$activity/fdl:description" mode="copy-text-fields-with-context-variables">
								<xsl:with-param name="display-name" select="$display-name"/>
								<xsl:with-param name="node" select="$activity"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
							</xsl:apply-templates>
						</xsl:variable>
						<xsl:variable name="tailored-description">
							<xsl:call-template name="tailor-description-or-documentation-text">
								<xsl:with-param name="untailored-text" select="$translated-description"/>
								<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
							</xsl:call-template>
						</xsl:variable>
						<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
							<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
							<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						</xsl:if>
						<bpc:description>
							<!-- FG added:  CDATA for query values -->
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:description>
					</xsl:if>
					<xsl:if test="$activity/fdl:documentation">
						<xsl:variable name="translated-documentation">
							<xsl:apply-templates select="$activity/fdl:documentation" mode="copy-text-fields-with-context-variables">
								<xsl:with-param name="display-name" select="$display-name"/>
								<xsl:with-param name="node" select="$activity"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
							</xsl:apply-templates>
						</xsl:variable>
						<xsl:variable name="tailored-documentation">
							<xsl:call-template name="tailor-description-or-documentation-text">
								<xsl:with-param name="untailored-text" select="$translated-documentation"/>
								<xsl:with-param name="maximum-length" select="$maxDocumentationFieldLength"/>
							</xsl:call-template>
						</xsl:variable>
						<xsl:if test="string-length($translated-documentation) &gt; $maxDocumentationFieldLength">
							<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
							<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDocumentationFieldLength, $translated-documentation), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						</xsl:if>
						<bpc:documentation>
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:value-of select="$tailored-documentation" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:documentation>
					</xsl:if>
				</bpel:invoke>
				<xsl:if test="'TRUE' = translate($merge_the_output_of_a_process_activity, $lower-case-characters, $upper-case-characters)">
					<!--
							Create "data mapping" ("assign" or "Java snippet") activity that merges the subprocess data output message with any default values in the "standard" data output.
					-->
					<xsl:call-template name="create-data-mapping-subprocess-to-standard">
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="activity" select="$activity"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:when>
			<!--
				CASE: "fdl:block"
			-->
			<xsl:when test="local-name($activity) = 'block'">
				<xsl:variable name="child-name-prefix">
					<xsl:choose>
						<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
							<!-- Cascaded name prefix not required: return existing prefix -->
							<xsl:value-of select="$name-prefix"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:choose>
								<xsl:when test="$name-prefix = ''">
									<xsl:value-of select="concat($activity/@name, '_')"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="concat($name-prefix, $activity/@name, '_')"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<!-- Translate data connectors from the block activity "SOURCE" container to "data mapping" ("assign" or "Java snippet") activities -->
				<xsl:variable name="SOURCE-data-connectors" select="$activity/fdl:blockImplementation/fdl:data[ @from = $activity/fdl:blockImplementation/fdl:input/@name and fdl:map ]"/>
				<xsl:if test="$SOURCE-data-connectors">
					<!-- Create comment: Distribute the input data of block activity "nnn" to the start activities of its implementation -->
					<xsl:value-of select="concat($eol, '&lt;!-- Distribute the input data of block activity &quot;', $activity/@name, '&quot; to the start activities of its implementation --&gt;', $eol)" disable-output-escaping="yes"/>
					<!-- If there is more than one outbound data connector at the block activity output, enclose the data flows ("data mapping" activities) with a "flow" activity -->
					<xsl:choose>
						<!-- CASE: more than one connector -->
						<xsl:when test="count($SOURCE-data-connectors) &gt; 1">
							<bpel:flow bpc:displayName="Distribute the block input data" name="{generate-id()}">
								<!-- Translate data connectors with their respective data mappings by "data mapping" ("assign" or "Java snippet") activities -->
								<xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$child-name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$name-prefix"/>
								</xsl:apply-templates>
							</bpel:flow>
						</xsl:when>
						<!-- CASE: exactly one connector -->
						<xsl:otherwise>
							<!-- Translate data connector with their respective data mappings by "data mapping" ("assign" or "Java snippet") activity -->
							<xsl:apply-templates select="$SOURCE-data-connectors" mode="data">
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$child-name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$name-prefix"/>
							</xsl:apply-templates>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
				<!-- Create comment: Implementation of block activity "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Implementation of block activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<!--	Translate the activities and their respective control and data connectors contained in the block implementation. Enclose the translation into a "flow" activity. -->
				<xsl:variable name="activities-contained-in-block" select="$activity/fdl:blockImplementation/fdl:programActivity | $activity/fdl:blockImplementation/fdl:processActivity | $activity/fdl:blockImplementation/fdl:block"/>
				<xsl:choose>
					<!-- CASE: more than one activity contained in the block -->
					<xsl:when test="count($activities-contained-in-block) > 1">
						<!-- Create a "flow" element -->
						<bpel:flow bpc:displayName="Execute activities contained in block" name="{generate-id()}">
							<!-- Translate the control connectors -->
							<xsl:if test=" $activity/fdl:blockImplementation/fdl:control">
								<!-- Create comment: Links that implement the internal control flow of process "nnn" -->
								<xsl:value-of select="concat($eol, '&lt;!-- Links that implement the internal control flow of block activity &quot;',  $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
								<bpel:links>
									<xsl:apply-templates select="$activity/fdl:blockImplementation/fdl:control" mode="links">
										<xsl:with-param name="variables" select="$variables"/>
										<xsl:with-param name="name-prefix" select="$child-name-prefix"/>
										<xsl:with-param name="parent-name-prefix" select="$name-prefix"/>
									</xsl:apply-templates>
								</bpel:links>
							</xsl:if>
							<!-- Translate the activities and their related data connectors -->
							<xsl:apply-templates select="$activity/fdl:blockImplementation/fdl:programActivity | $activity/fdl:blockImplementation/fdl:processActivity | $activity/fdl:blockImplementation/fdl:block" mode="activities">
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$child-name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$name-prefix"/>
								<xsl:with-param name="valid-from" select="$valid-from"/>
								<xsl:with-param name="activity-contained-in-flow" select="true()"/>
							</xsl:apply-templates>
						</bpel:flow>
					</xsl:when>
					<!-- OTHERWISE: one or no activity contained in the block -->
					<xsl:otherwise>
						<!--  No "flow" element necessary. Translate one activity, if there is one. -->
						<xsl:apply-templates select="$activity/fdl:blockImplementation/fdl:programActivity | $activity/fdl:blockImplementation/fdl:processActivity | $activity/fdl:blockImplementation/fdl:block" mode="activities">
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$child-name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$name-prefix"/>
							<xsl:with-param name="valid-from" select="$valid-from"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
		</xsl:choose>
		<!-- Add "data mapping" ("assign" or "Java snippet") activity that maps the output data to the input, if there is a "data loop connector" -->
		<xsl:apply-templates select="$activity/../fdl:data[ @loop = $activity/@name and fdl:map ]" mode="data">
			<xsl:with-param name="variables" select="$variables"/>
			<xsl:with-param name="name-prefix" select="$name-prefix"/>
			<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
		</xsl:apply-templates>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "create-activity-expiration-fault-handler":
		
		Sets the activity status variable to state "expired"
		****************************************************************************************************************
	 -->
	<xsl:template name="create-activity-expiration-fault-handler">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="activity"/>
		<xsl:variable name="status-variable" select="concat($name-prefix, $activity/@name, $status-variable-suffix)"/>
		<xsl:variable name="status-variable-type" select="$variables//bpel:variable[@name = $status-variable]/@messageType"/>
		<!-- Create comment: Set status variable of activity "nnn" to "expired" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Set status variable of activity &quot;', $activity/@name, '&quot; to &quot;expired&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create "assign" activity that sets the "activity-started" indicator -->
		<xsl:call-template name="create-assign-activity-to-set-BPEL-variable">
			<xsl:with-param name="BPEL-variable" select="$status-variable"/>
			<xsl:with-param name="BPEL-variable-value" select="'expired'"/>
		</xsl:call-template>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "create-empty-activity":

		Called by an "create-activity" template.
		Translates "fdl:programActivity"  to an "empty" activity.
		****************************************************************************************************************
	 -->
	<xsl:template name="create-empty-activity">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<!-- Create comment: Empty activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Empty activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<xsl:variable name="display-name">
			<xsl:choose>
				<xsl:when test="$activity/@displayName">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@displayName"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Create "empty" activity -->
		<bpel:empty name="{$activity/@name}">
			<!-- Add optional display name -->
			<xsl:if test="$activity/@displayName">
				<xsl:attribute name="bpc:displayName"><xsl:value-of select="$display-name"/></xsl:attribute>
			</xsl:if>
			<!-- Add optional business relevance indicator -->
			<xsl:choose>
				<xsl:when test="$activity/fdl:defaultSetting[ @auditFilterDB | @auditFilterMQ ]">
					<xsl:attribute name="bpc:businessRelevant">yes</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="bpc:businessRelevant">no</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<!-- Activity description and documentation -->
			<xsl:if test="$activity/fdl:description">
				<xsl:variable name="translated-description">
					<xsl:apply-templates select="$activity/fdl:description" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="$activity"/>
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
						<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-description">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-description"/>
						<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:description>
					<!-- FG added:  CDATA for query values -->
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:description>
			</xsl:if>
			<xsl:if test="$activity/fdl:documentation">
				<xsl:variable name="translated-documentation">
					<xsl:apply-templates select="$activity/fdl:documentation" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="$activity"/>
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
						<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-documentation">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-documentation"/>
						<xsl:with-param name="maximum-length" select="$maxDocumentationFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-documentation) &gt; $maxDocumentationFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDocumentationFieldLength, $translated-documentation), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:documentation>
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-documentation" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:documentation>
			</xsl:if>
			<!-- Add "expiration expression" -->
			<xsl:choose>
				<xsl:when test="$activity/fdl:expiration/@maximumDuration">
					<xsl:call-template name="create-expiration-expression">
						<xsl:with-param name="maximum-duration" select="$activity/fdl:expiration/@maximumDuration"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$activity/fdl:expiration/fdl:dataStructureMemberName">
					<!-- Create comment: ***CWWBMnnnnW: No BPEL mapping available for FDL expiration from container *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_ExpirationTakenFrom', $activity/@name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:when>
			</xsl:choose>
		</bpel:empty>
	</xsl:template>
	<!--
		*****************************************************************************************
		Template "create-standard-activity":

		Called by an "create-activity" template.
		Translates "fdl:programActivity"  to an "invoke" activity.
		*****************************************************************************************
	 -->
	<xsl:template name="create-standard-activity">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:param name="valid-from"/>
		<xsl:param name="program-activity-type"/>
		<!-- Determine the value of the "displayName" attribute -->
		<xsl:variable name="display-name">
			<xsl:choose>
				<xsl:when test="$activity/@displayName">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@displayName"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Determine the value of the "portType" attribute -->
		<xsl:variable name="port-type">
			<xsl:choose>
				<xsl:when test="$activity/fdl:program/@name">
					<xsl:value-of select="concat('wsdl1:', $activity/fdl:program/@name, $port-type-suffix)"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'null'"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Determine the value of the "operation" attribute -->
		<xsl:variable name="operation">
			<xsl:choose>
				<!-- 	Derive the operation name from the activity name, if the program attribute "structuresFromActivity" = "yes" -->
				<xsl:when test="//fdl:definitions/fdl:program[ @structuresFromActivity='yes' ]/@name = $activity/fdl:program/@name
				or //fdl:definitions/fdl:create/fdl:program[ @structuresFromActivity='yes' ]/@name = $activity/fdl:program/@name
				or //fdl:definitions/fdl:update/fdl:program[ @structuresFromActivity='yes' ]/@name = $activity/fdl:program/@name
				or //fdl:definitions/fdl:replace/fdl:program[ @structuresFromActivity='yes' ]/@name = $activity/fdl:program/@name">
					<xsl:value-of select="concat($name-prefix, $activity/@name, $operation-suffix)"/>
				</xsl:when>
				<!-- 	Otherwise, derive the operation name from the referenced program name. -->
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$activity/fdl:program/@name">
							<xsl:value-of select="concat($activity/fdl:program/@name, $operation-suffix)"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="'null'"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Determine the value of the "partnerLink" attribute for "service invocation" activities, only -->
		<xsl:variable name="partner-link">
			<xsl:choose>
				<!-- CASE: empty activity -->
				<xsl:when test="$program-activity-type='empty activity'">
					<xsl:value-of select="'null'"/>
				</xsl:when>
				<!-- CASE: staff activity -->
				<xsl:when test="$program-activity-type='staff activity' or $program-activity-type='assumed staff activity'">
					<xsl:value-of select="'null'"/>
				</xsl:when>
				<!-- CASE: service invocation activity -->
				<xsl:when test="$program-activity-type='service invocation activity'">
					<xsl:value-of select="concat($name-prefix, $activity/@name, $partner-link-suffix)"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="input-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
		<xsl:variable name="output-variable-name">
			<xsl:choose>
				<!-- CASE: staff activity requires additional "human task" output variable -->
				<xsl:when test="($program-activity-type='staff activity' or $program-activity-type='assumed staff activity')
		                    and 'TRUE' = translate($merge_the_output_of_a_staff_activity, $lower-case-characters, $upper-case-characters)">
					<xsl:value-of select="concat($name-prefix, $activity/@name, $human-task-output-variable-suffix)"/>
				</xsl:when>
				<!-- OTHERWISE -->
				<xsl:otherwise>
					<xsl:value-of select="concat($name-prefix, $activity/@name, $output-variable-suffix)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!--
                If the activity type is a human task then create a "Java snippet" that initializes the human task data input message 
                (in case that the BPEL variable is empty)
		-->
		<xsl:if test="$program-activity-type='staff activity' or $program-activity-type='assumed staff activity'">
			<xsl:call-template name="initialize-human-task-input">
				<xsl:with-param name="variable-name" select="$input-variable-name"/>
			</xsl:call-template>
		</xsl:if>
		<!-- Create comment: Invoke program activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Invoke program activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<xsl:if test="$program-activity-type='assumed staff activity'">
			<!-- Create comment: *** CWWBMnnnnW: Cannot decide whether program activity "nnn" should be mapped to a BPEL "empty activity", "staff activity", or "service invocation activity"  ("staff activity" assumed). *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'AmbiguousMapping_ProgramActivity', $activity/@name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
		</xsl:if>
		<!-- Create "invoke" activity -->
		<bpel:invoke partnerLink="{$partner-link}" portType="{$port-type}" operation="{$operation}" outputVariable="{$output-variable-name}" inputVariable="{$input-variable-name}" name="{$activity/@name}">
			<!-- Add optional display name -->
			<xsl:if test="$activity/@displayName">
				<xsl:attribute name="bpc:displayName"><xsl:value-of select="$display-name"/></xsl:attribute>
			</xsl:if>
			<!-- Add optional business relevance indicator -->
			<xsl:choose>
				<xsl:when test="$activity/fdl:defaultSetting[ @auditFilterDB | @auditFilterMQ ]">
					<xsl:attribute name="bpc:businessRelevant">yes</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="bpc:businessRelevant">no</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<!-- Activity description and documentation -->
			<xsl:if test="$activity/fdl:description">
				<xsl:variable name="translated-description">
					<xsl:apply-templates select="$activity/fdl:description" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="$activity"/>
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
						<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-description">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-description"/>
						<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:description>
					<!-- FG added:  CDATA for query values -->
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:description>
			</xsl:if>
			<xsl:if test="$activity/fdl:documentation">
				<xsl:variable name="translated-documentation">
					<xsl:apply-templates select="$activity/fdl:documentation" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="$activity"/>
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
						<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-documentation">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-documentation"/>
						<xsl:with-param name="maximum-length" select="$maxDocumentationFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-documentation) &gt; $maxDocumentationFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDocumentationFieldLength, $translated-documentation), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:documentation>
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-documentation" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:documentation>
			</xsl:if>
			<!--
					Add staff assignment (participating task), if the program activity maps to a BPEL "staff activity" .
			-->
			<xsl:if test="$program-activity-type='staff activity' or $program-activity-type='assumed staff activity'">
				<xsl:variable name="task-name" select="concat($name-prefix, $activity/@name, $ptask-name-suffix)"/>
				<!-- Create comment: staff assignment (participating task) for activity "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Staff assignment (participating task) for activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<bpc:task name="staff:{$task-name}"/>
			</xsl:if>
			<!-- Add "expiration expression" -->
			<xsl:choose>
				<xsl:when test="$activity/fdl:expiration/@maximumDuration">
					<xsl:call-template name="create-expiration-expression">
						<xsl:with-param name="maximum-duration" select="$activity/fdl:expiration/@maximumDuration"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$activity/fdl:expiration/fdl:dataStructureMemberName">
					<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL expiration from container *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_ExpirationTakenFrom', $activity/@name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:when>
			</xsl:choose>
		</bpel:invoke>
		<xsl:if test="($program-activity-type='staff activity' or $program-activity-type='assumed staff activity')
		                    and 'TRUE' = translate($merge_the_output_of_a_staff_activity, $lower-case-characters, $upper-case-characters)">
			<!--
					Create "data mapping" ("assign" or "Java snippet") activity that merges the human task data output message with any default values in the "standard" data output.
			-->
			<xsl:call-template name="create-data-mapping-human-task-to-standard">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="activity" select="$activity"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************
		Template "create-UPES-activity"

		Called by an "create-activity" template.
		Translates "fdl:programActivity"  to an "invoke" activity
		that refers to an "UPES" port type
		*****************************************************************************************
	 -->
	<xsl:template name="create-UPES-activity">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<!-- Determine the value of the "displayName" attribute -->
		<xsl:variable name="display-name">
			<xsl:choose>
				<xsl:when test="$activity/@displayName">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@displayName"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Check whether the server definition exists -->
		<xsl:variable name="server-name" select="substring-before($activity/fdl:program/@programExecutionUnit, '.')"/>
		<xsl:if test="not(//fdl:definitions/fdl:server[ @name = $server-name ]
				or //fdl:definitions/fdl:create/fdl:server[ @name = $server-name ]
				or //fdl:definitions/fdl:update/fdl:server[ @name = $server-name ]
				or //fdl:definitions/fdl:replace/fdl:server[ @name = $server-name ])">
			<!--COMMENT: *** CWWBMnnnnE: The required program execution server definition nnn (UPES) was not found at activity nnn. *** -->
			<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'MissingUPES', $server-name, $activity/@displayName), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
		</xsl:if>
		<!-- Determine the value of the "portType" attribute -->
		<xsl:variable name="port-type">
			<xsl:value-of select="concat('wsdl1:', $server-name, $port-type-suffix)"/>
		</xsl:variable>
		<!-- Determine the UPES execution mode (synchronous or asynchronous) -->
		<xsl:variable name="UPES-execution-mode">
			<xsl:call-template name="UPES-execution-mode">
				<xsl:with-param name="activity" select="$activity"/>
			</xsl:call-template>
		</xsl:variable>
		<!-- Determine the value of the "operation" attribute -->
		<xsl:variable name="operation">
			<xsl:choose>
				<!-- CASE: asynchronous execution -->
				<xsl:when test="$UPES-execution-mode = 'asynchronous'">
					<xsl:value-of select="concat($name-prefix, $activity/@name, $UPES-asynchronous-operation-suffix)"/>
				</xsl:when>
				<!-- OTHERWISE: synchronous execution assumed-->
				<xsl:otherwise>
					<xsl:value-of select="concat($name-prefix, $activity/@name, $UPES-synchronous-operation-suffix)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!-- Determine the value of the "partnerLink" attribute for "service invocation" activities, only -->
		<xsl:variable name="partner-link" select="concat($server-name, $partner-link-suffix)"/>
		<!-- Create activity that maps the data input message into another one which conforms to the UPES interoperability convention. -->
		<xsl:call-template name="create-data-mapping-standard-to-UPES">
			<xsl:with-param name="variables" select="$variables"/>
			<xsl:with-param name="name-prefix" select="$name-prefix"/>
			<xsl:with-param name="activity" select="$activity"/>
		</xsl:call-template>
		<!-- Create activity that complete the data format conversion ("standard" to UPES) by mapping the output data defaults to UPES input message  -->
		<xsl:if test="$activity/fdl:output/fdl:dataDefaults 
						or $activity/../fdl:data[ @default = $activity/@name ]
						or 'TRUE' = translate($initializePredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
			<xsl:call-template name="create-UPES-default-container-mapping">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="activity" select="$activity"/>
			</xsl:call-template>
		</xsl:if>
		<!-- Prepare initial values for the UPES message context -->
		<xsl:variable name="initial-context-data-for-UPES">
			<xsl:if test="'FALSE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
				<fdl:field type="string" value="{$activity/@name}">
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_ACTIVITY"/>
					</fdl:dataStructureMemberName>
				</fdl:field>
				<fdl:field type="string" value="{$activity/ancestor::fdl:process/@name}">
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_PROCESS_MODEL"/>
					</fdl:dataStructureMemberName>
				</fdl:field>
			</xsl:if>
			<xsl:choose>
				<!-- CASE: asynchronous execution -->
				<xsl:when test="$UPES-execution-mode = 'asynchronous'">
					<fdl:field type="string" value="'No'">
						<fdl:dataStructureMemberName>
							<fdl:nameComponent name="MessageContext"/>
							<fdl:nameComponent name="ResponseRequired"/>
						</fdl:dataStructureMemberName>
					</fdl:field>
				</xsl:when>
				<!-- OTHERWISE: synchronous execution assumed-->
				<xsl:otherwise>
					<fdl:field type="string" value="'Yes'">
						<fdl:dataStructureMemberName>
							<fdl:nameComponent name="MessageContext"/>
							<fdl:nameComponent name="ResponseRequired"/>
						</fdl:dataStructureMemberName>
					</fdl:field>
				</xsl:otherwise>
			</xsl:choose>
			<fdl:field type="string" value="{$ActivityImplInvoke}">
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="MessageContext"/>
					<fdl:nameComponent name="MessageType"/>
				</fdl:dataStructureMemberName>
			</fdl:field>
			<fdl:field type="function" value="IdHelper.newPIID(true, OID.OBJECT_META_TYPE_B).toString()">
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="MessageContext"/>
					<fdl:nameComponent name="ActImplCorrelID"/>
				</fdl:dataStructureMemberName>
			</fdl:field>
		</xsl:variable>
		<!-- Create the initial context data for UPES using a "Java snippet" -->
		<xsl:call-template name="set-initial-context-data-for-UPES">
			<xsl:with-param name="variable-name" select="concat($name-prefix, $activity/@name, $UPES-input-variable-suffix)"/>
			<xsl:with-param name="UPES-execution-mode" select="$UPES-execution-mode"/>
			<xsl:with-param name="program-name" select="$activity/fdl:program/@name"/>
		</xsl:call-template>
		<!-- Create comment: Invoke UPES program activity "nnn" -->
		<xsl:value-of select="concat($eol, '&lt;!-- Invoke UPES program activity &quot;', $activity/@name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<!-- Create "invoke" activity -->
		<bpel:invoke partnerLink="{$partner-link}" portType="{$port-type}" operation="{$operation}" inputVariable="{$name-prefix}{$activity/@name}{$UPES-input-variable-suffix}" name="{$activity/@name}">
			<!-- Add attribute "outputVariable" for synchronous execution mode -->
			<xsl:if test="$UPES-execution-mode = 'synchronous'">
				<xsl:attribute name="outputVariable"><xsl:value-of select="concat($name-prefix, $activity/@name, $UPES-output-variable-suffix)"/></xsl:attribute>
			</xsl:if>
			<!-- Add optional display name -->
			<xsl:if test="$activity/@displayName">
				<xsl:attribute name="bpc:displayName"><xsl:value-of select="$display-name"/></xsl:attribute>
			</xsl:if>
			<!-- Add optional business relevance indicator -->
			<xsl:choose>
				<xsl:when test="$activity/fdl:defaultSetting[ @auditFilterDB | @auditFilterMQ ]">
					<xsl:attribute name="bpc:businessRelevant">yes</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="bpc:businessRelevant">no</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<!-- Activity description and documentation -->
			<xsl:if test="$activity/fdl:description">
				<xsl:variable name="translated-description">
					<xsl:apply-templates select="$activity/fdl:description" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="$activity"/>
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
						<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-description">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-description"/>
						<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:description>
					<!-- FG added:  CDATA for query values -->
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:description>
			</xsl:if>
			<xsl:if test="$activity/fdl:documentation">
				<xsl:variable name="translated-documentation">
					<xsl:apply-templates select="$activity/fdl:documentation" mode="copy-text-fields-with-context-variables">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="node" select="$activity"/>
						<xsl:with-param name="variables" select="$variables"/>
						<xsl:with-param name="name-prefix" select="$name-prefix"/>
						<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
						<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
					</xsl:apply-templates>
				</xsl:variable>
				<xsl:variable name="tailored-documentation">
					<xsl:call-template name="tailor-description-or-documentation-text">
						<xsl:with-param name="untailored-text" select="$translated-documentation"/>
						<xsl:with-param name="maximum-length" select="$maxDocumentationFieldLength"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($translated-documentation) &gt; $maxDocumentationFieldLength">
					<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDocumentationFieldLength, $translated-documentation), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<bpc:documentation>
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="$tailored-documentation" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:documentation>
			</xsl:if>
			<!-- Add "expiration expression" -->
			<xsl:choose>
				<xsl:when test="$activity/fdl:expiration/@maximumDuration">
					<xsl:call-template name="create-expiration-expression">
						<xsl:with-param name="maximum-duration" select="$activity/fdl:expiration/@maximumDuration"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$activity/fdl:expiration/fdl:dataStructureMemberName">
					<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL expiration from container *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_ExpirationTakenFrom', $activity/@name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:when>
			</xsl:choose>
		</bpel:invoke>
		<xsl:if test="$UPES-execution-mode = 'synchronous'">
			<!--
					Create "data mapping" ("assign" or "Java snippet") activity that maps the UPES data output message back to the "standard" data message format.
			-->
			<xsl:call-template name="create-data-mapping-UPES-to-standard">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="activity" select="$activity"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************
		"set-initial-context-data-for-UPES" template:
		
		Creates a Java snippet that sets the initial context data
		required for a UPES invocation.
		*****************************************************************************************
	 -->
	<xsl:template name="set-initial-context-data-for-UPES">
		<xsl:param name="variable-name"/>
		<xsl:param name="UPES-execution-mode"/>
		<xsl:param name="program-name"/>
		<xsl:variable name="response-required">
			<xsl:choose>
				<!-- CASE: asynchronous execution mode -->
				<xsl:when test="$UPES-execution-mode = 'asynchronous'">
					<xsl:value-of select="'No'"/>
				</xsl:when>
				<!-- OTHERWISE: synchronous execution assumed-->
				<xsl:otherwise>
					<xsl:value-of select="'Yes'"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<bpel:invoke name="Set_UPES_context" bpc:displayName="Set UPES context" operation="null" partnerLink="null" portType="bpc:null">
			<bpc:script>
				<bpc:javaCode>
					<xsl:value-of select="concat($eol, '&lt;![CDATA[')" disable-output-escaping="yes"/>
					<!-- Initialize business object -->
					<xsl:value-of select="concat($eol, 
					                                'if (',
													$variable-name, 
					                                ' == null) {',
					                                $eol,
					                                '    BOFactory boFactory = (BOFactory)ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
					                                $eol,
					                                '    ',
													$variable-name, 
					                                ' = boFactory.createByType(getVariableType(&quot;',
													$variable-name, 
													'&quot;));',
					                                $eol,
					                                '}')" disable-output-escaping="yes"/>
					<!-- Get UPES message context -->
					<xsl:value-of select="concat($eol, 
					                                'DataObject messageContext = ',
													$variable-name, 
													'.getDataObject(&quot;MessageContext&quot;);',
					                                $eol,
					                                'if (messageContext == null) {',
					                                $eol,
					                                '    messageContext = ',
													$variable-name, 
													'.createDataObject(&quot;MessageContext&quot;);',
					                                $eol,
					                                '}')" disable-output-escaping="yes"/>
					<xsl:value-of select="concat($eol, 'messageContext.set(&quot;ResponseRequired&quot;, &quot;', $response-required, '&quot;);')" disable-output-escaping="yes"/>
					<xsl:value-of select="concat($eol, 'messageContext.set(&quot;ActImplCorrelID&quot;, ', 'WMQWFHelper.createCorrelationID());')" disable-output-escaping="yes"/>
					<xsl:value-of select="concat($eol, 'messageContext.set(&quot;Starter&quot;, processInstance().getStarter().toString());')" disable-output-escaping="yes"/>
					<xsl:value-of select="concat($eol, 'messageContext.set(&quot;ProcTemplID&quot;, processInstance().getProcessTemplateID().toString());')" disable-output-escaping="yes"/>
					<xsl:value-of select="concat($eol, 'messageContext.set(&quot;ProgramName&quot;, &quot;', $program-name, '&quot;);')" disable-output-escaping="yes"/>
					<xsl:value-of select="concat($eol, ']]&gt;', $eol)" disable-output-escaping="yes"/>
				</bpc:javaCode>
			</bpc:script>
		</bpel:invoke>
	</xsl:template>
	<!--
		*****************************************************************************************
		"create-standard-elements" template:
		
		Creates the standard activity elements  "bpc:joinCondition" , "source", "target".
        Add "description" and "documentation" elements if required.
		*****************************************************************************************
	 -->
	<xsl:template name="create-standard-elements">
		<xsl:param name="activity"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<!--
				Activity description and documentation
		-->
		<xsl:variable name="display-name">
			<xsl:choose>
				<xsl:when test="$activity/@displayName">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@displayName"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$activity/@name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$activity/fdl:description">
			<xsl:variable name="translated-description">
				<xsl:apply-templates select="$activity/fdl:description" mode="copy-text-fields-with-context-variables">
					<xsl:with-param name="display-name" select="$display-name"/>
					<xsl:with-param name="node" select="$activity"/>
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
				</xsl:apply-templates>
			</xsl:variable>
			<xsl:variable name="tailored-description">
				<xsl:call-template name="tailor-description-or-documentation-text">
					<xsl:with-param name="untailored-text" select="$translated-description"/>
					<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
				<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:if>
			<bpc:description>
				<!-- FG added:  CDATA for query values -->
				<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
				<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
				<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
			</bpc:description>
		</xsl:if>
		<xsl:if test="$activity/fdl:documentation">
			<xsl:variable name="translated-documentation">
				<xsl:apply-templates select="$activity/fdl:documentation" mode="copy-text-fields-with-context-variables">
					<xsl:with-param name="display-name" select="$display-name"/>
					<xsl:with-param name="node" select="$activity"/>
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
				</xsl:apply-templates>
			</xsl:variable>
			<xsl:variable name="tailored-documentation">
				<xsl:call-template name="tailor-description-or-documentation-text">
					<xsl:with-param name="untailored-text" select="$translated-documentation"/>
					<xsl:with-param name="maximum-length" select="$maxDocumentationFieldLength"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:if test="string-length($translated-documentation) &gt; $maxDocumentationFieldLength">
				<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDocumentationFieldLength, $translated-documentation), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:if>
			<bpc:documentation>
				<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
				<xsl:value-of select="$tailored-documentation" disable-output-escaping="yes"/>
				<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
			</bpc:documentation>
		</xsl:if>
		<!--
				Link source and target elements
		-->
		<xsl:variable name="link-sources" select="$activity/../fdl:control[ @from = $activity/@name ]"/>
		<xsl:variable name="link-targets" select="$activity/../fdl:control[ @to = $activity/@name ]"/>
		<!-- Add the "target" elements for "links" that end at this activity -->
		<xsl:if test="$link-targets">
			<bpel:targets>
				<!-- Add the "bpc:joinCondition" element" -->
				<xsl:apply-templates select="$activity/fdl:join" mode="join-condition"/>
				<xsl:apply-templates select="$link-targets" mode="link-targets"/>
			</bpel:targets>
		</xsl:if>
		<!-- Add the "source" elements for "links" that start from this activity -->
		<xsl:if test="$link-sources">
			<bpel:sources>
				<xsl:apply-templates select="$link-sources" mode="link-sources">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				</xsl:apply-templates>
			</bpel:sources>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************
		Template "create-expiration-expression"
	
		Called by a "create-standard-activity", "create-empty-activity",
		and "create-UPES-activity" templates.
		Creates expression for "invoke" activity expiration.
		
		ASSUMPTION: Usage of the "SIMPLE Arithmetic Calendar" of the
		WebSphere Scheduler.
		The interval is calculated using a simple java.util.Calendar based scheme.
		Each term has the form "NNNNNtype", where "NNNN is an integer and "type"
		indicates one of the following values:
			seconds
			minutes
			hours
			days
			months
			years
		*****************************************************************************************
	 -->
	<xsl:template name="create-expiration-expression">
		<xsl:param name="maximum-duration"/>
		<!-- Select the duration in seconds "nnn" from an expression of format: "PTnnnS" -->
		<xsl:variable name="maximum-duration-formatted-as-SIMPLE-time-interval">
			<xsl:call-template name="create-SIMPLE-time-format">
				<xsl:with-param name="XFDL-time-format" select="$maximum-duration"/>
			</xsl:call-template>
		</xsl:variable>
		<bpc:expiration>
			<bpc:timeout duration="{$maximum-duration-formatted-as-SIMPLE-time-interval}"/>
		</bpc:expiration>
	</xsl:template>
	<!--
		*****************************************************************************************
		Template "create-SIMPLE-time-format"
		
		ASSUMPTION: Usage of the "SIMPLE Arithmetic Calendar" of the
		WebSphere Scheduler.
		The interval is formatted using a simple java.util.Calendar based scheme.
		Each term has the form "NNNNNtype", where "NNNN is an integer and "type"
		indicates one of the following values:
			seconds
			minutes
			hours
			days
			weeks
			months
			years
		The corresponding XFDL time format has the form "pnnnu", where
			"p" is a prefix:
			 	"PT" for seconds, minutes, hours, days
			 	"P" for weeks, months, and years
			"nnn" is an integer.
			"u" indicates the time units, as follows:
			If the prefix is "PT", then
				S means seconds,
				M means minutes,
				H means hours,
				D means days,
			If the prefix is "P", then
				W means weeks,
				M means months,
				Y means years
		*****************************************************************************************
	 -->
	<xsl:template name="create-SIMPLE-time-format">
		<xsl:param name="XFDL-time-format"/>
		<!-- ASSERT PRECONDITION -->
		<xsl:if test="not($XFDL-time-format)">
			<xsl:variable name="error-message" select="'PRECONDITION FAILED in template create-SIMPLE-time-format: parameter XFDL-time-format not set'"/>
			<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** ')" disable-output-escaping="no"/>
		</xsl:if>
		<!-- ASSERT PRECONDITION -->
		<xsl:if test="not(substring($XFDL-time-format, 1, 1) = 'P' or substring($XFDL-time-format, 1, 2) = 'PT')">
			<xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template create-SIMPLE-time-format: parameter XFDL-time-format is incorrect value', substring($XFDL-time-format, 1, 2))"/>
			<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** ')" disable-output-escaping="no"/>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="substring($XFDL-time-format, 1, 2) = 'PT'">
				<xsl:choose>
					<!-- CASE: Interval type = "seconds" -->
					<xsl:when test="substring( $XFDL-time-format, string-length( $XFDL-time-format ) ) = 'S'">
						<xsl:value-of select="concat(substring-after(substring-before($XFDL-time-format, 'S'), 'PT'), 'seconds')"/>
					</xsl:when>
					<!-- CASE: Interval type = "minutes" -->
					<xsl:when test="substring( $XFDL-time-format, string-length( $XFDL-time-format ) ) = 'M'">
						<xsl:value-of select="concat(substring-after(substring-before($XFDL-time-format, 'M'), 'PT'), 'minutes')"/>
					</xsl:when>
					<!-- CASE: Interval type = "hours" -->
					<xsl:when test="substring( $XFDL-time-format, string-length( $XFDL-time-format ) ) = 'H'">
						<xsl:value-of select="concat(substring-after(substring-before($XFDL-time-format, 'H'), 'PT'), 'hours')"/>
					</xsl:when>
					<xsl:otherwise>
						<!-- ERROR -->
						<xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template create-SIMPLE-time-format: Cannot derive SIMPLE time format from ', $XFDL-time-format)"/>
						<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** ')" disable-output-escaping="no"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<!-- CASE: Interval type = "days" -->
					<xsl:when test="substring( $XFDL-time-format, string-length( $XFDL-time-format ) ) = 'D'">
						<xsl:value-of select="concat(substring-after(substring-before($XFDL-time-format, 'D'), 'P'), 'days')"/>
					</xsl:when>
					<!-- CASE: Interval type = "weeks" -->
					<xsl:when test="substring( $XFDL-time-format, string-length( $XFDL-time-format ) ) = 'W'">
						<xsl:value-of select="concat(substring-after(substring-before($XFDL-time-format, 'W'), 'P'), 'weeks')"/>
					</xsl:when>
					<!-- CASE: Interval type = "months" -->
					<xsl:when test="substring( $XFDL-time-format, string-length( $XFDL-time-format ) ) = 'M'">
						<xsl:value-of select="concat(substring-after(substring-before($XFDL-time-format, 'M'), 'P'), 'months')"/>
					</xsl:when>
					<!-- CASE: Interval type = "years" -->
					<xsl:when test="substring( $XFDL-time-format, string-length( $XFDL-time-format ) ) = 'Y'">
						<xsl:value-of select="concat(substring-after(substring-before($XFDL-time-format, 'Y'), 'P'), 'years')"/>
					</xsl:when>
					<xsl:otherwise>
						<!-- ERROR -->
						<xsl:variable name="error-message" select="concat('PRECONDITION FAILED in template create-SIMPLE-time-format: Cannot derive SIMPLE time format from ', $XFDL-time-format)"/>
						<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.writeAssertion($error-message), ' *** ')" disable-output-escaping="no"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************
		"create-staff-query-verb" template:
		
		Creates a staff query verb.
		*****************************************************************************************
	 -->
	<xsl:template match="fdl:staff" mode="create-staff-query-verb">
		<xsl:param name="name"/>
		<xsl:param name="node"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="local-variable-name"/>
		<xsl:param name="staff-resolution-target-is-an-activity" select="true()"/>
		<xsl:variable name="display-name">
			<xsl:choose>
				<xsl:when test="$node/@displayName">
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$node/@displayName"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="tailor-display-name">
						<xsl:with-param name="untailored-display-name" select="$node/@name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="staff-query-type">
			<xsl:apply-templates select="current()" mode="find-staff-query-type">
				<xsl:with-param name="node" select="$node"/>
				<xsl:with-param name="staff-resolution-target-is-an-activity" select="$staff-resolution-target-is-an-activity"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:choose>
			<!--
				Static staff queries
			-->
			<!-- CASE: All people -->
			<xsl:when test="$staff-query-type = 'All people'">
				<!-- Create comment: FDL staff query "All people" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;All people&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Everybody</tel:name>
			</xsl:when>
			<xsl:when test="$staff-query-type = 'Staff from predefined members'">
				<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "Staff from predefined members" *** -->
				<xsl:choose>
					<xsl:when test="local-name($node) = 'process'">
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_StaffFromPredefinedMembers1', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						<!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						<tel:name>Everybody</tel:name>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_StaffFromPredefinedMembers2', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						<!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						<tel:name>Everybody</tel:name>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="$staff-query-type = 'Coordinator of role'">
				<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "Coordinator of role" *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_RoleCoordinator', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Everybody</tel:name>
			</xsl:when>
			<xsl:when test="$staff-query-type = 'Manager of organization'">
				<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "Manager of organization" *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_OrganizationManager', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Everybody</tel:name>
			</xsl:when>
			<!-- CASE: People -->
			<xsl:when test="$staff-query-type = 'People'">
				<!-- Create comment: FDL staff query "People" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;People&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Users by user ID</tel:name>
				<xsl:if test="fdl:person[1]">
					<xsl:choose>
						<xsl:when test="fdl:person[1]/@name">
							<tel:parameter id="UserID">
								<xsl:value-of select="fdl:person[1]/@name"/>
							</tel:parameter>
						</xsl:when>
						<xsl:when test="fdl:person[1]/fdl:dataStructureMemberName">
							<tel:parameter id="UserID">
								<xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
								<xsl:apply-templates select="fdl:person[1]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
									<xsl:with-param name="display-name" select="$display-name"/>
									<xsl:with-param name="node" select="$node"/>
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
								</xsl:apply-templates>
								<xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
							</tel:parameter>
						</xsl:when>
					</xsl:choose>
				</xsl:if>
				<xsl:if test="fdl:person[2]">
					<xsl:choose>
						<xsl:when test="fdl:person[2]/@name">
							<tel:parameter id="AlternativeID1">
								<xsl:value-of select="fdl:person[2]/@name"/>
							</tel:parameter>
						</xsl:when>
						<xsl:when test="fdl:person[2]/fdl:dataStructureMemberName">
							<tel:parameter id="AlternativeID1">
								<xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
								<xsl:apply-templates select="fdl:person[2]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
									<xsl:with-param name="display-name" select="$display-name"/>
									<xsl:with-param name="node" select="$node"/>
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
								</xsl:apply-templates>
								<xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
							</tel:parameter>
						</xsl:when>
					</xsl:choose>
				</xsl:if>
				<xsl:if test="fdl:person[3]">
					<xsl:choose>
						<xsl:when test="fdl:person[3]/@name">
							<tel:parameter id="AlternativeID2">
								<xsl:value-of select="fdl:person[3]/@name"/>
							</tel:parameter>
						</xsl:when>
						<xsl:when test="fdl:person[3]/fdl:dataStructureMemberName">
							<tel:parameter id="AlternativeID2">
								<xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
								<xsl:apply-templates select="fdl:person[3]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
									<xsl:with-param name="display-name" select="$display-name"/>
									<xsl:with-param name="node" select="$node"/>
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
								</xsl:apply-templates>
								<xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
							</tel:parameter>
						</xsl:when>
					</xsl:choose>
				</xsl:if>
				<xsl:if test="fdl:person[4]">
					<!-- Create comment: *** CWWBMnnnnW: BPEL mapping for FDL staff query type "People" does not consider more than three persons *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_People', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
			</xsl:when>
			<!-- CASE: Process administrator -->
			<xsl:when test="$staff-query-type = 'Process administrator'">
				<!-- Create comment: FDL staff query "Process administrator" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Process administrator&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Users by user ID</tel:name>
				<xsl:choose>
					<xsl:when test="fdl:processAdministrator/@name">
						<tel:parameter id="UserID">
							<xsl:value-of select="fdl:processAdministrator/@name"/>
						</tel:parameter>
					</xsl:when>
					<xsl:when test="fdl:processAdministrator/fdl:dataStructureMemberName">
						<tel:parameter id="UserID">
							<xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
							<xsl:apply-templates select="fdl:processAdministrator/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
								<xsl:with-param name="display-name" select="$display-name"/>
								<xsl:with-param name="node" select="$node"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
							</xsl:apply-templates>
							<xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
						</tel:parameter>
					</xsl:when>
					<xsl:otherwise>
						<tel:parameter id="UserID">%wf:process.administrators%</tel:parameter>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- CASE: Process starter -->
			<xsl:when test="$staff-query-type = 'Process starter'">
				<!-- Create comment: FDL staff query "Process starter" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Process starter&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Users by user ID</tel:name>
				<tel:parameter id="UserID">%wf:process.starter%</tel:parameter>
			</xsl:when>
			<!-- CASE: Manager of process starter -->
			<xsl:when test="$staff-query-type = 'Manager of process starter'">
				<!-- Create comment: FDL staff query "ManagerOfProcessStarter" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Manager of process starter&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Manager of Employee by user ID</tel:name>
				<tel:parameter id="EmployeeUserID">%wf:process.starter%</tel:parameter>
			</xsl:when>
			<!-- CASE: Starter of activity -->
			<xsl:when test="$staff-query-type = 'Starter of activity'">
				<!-- Create comment: FDL staff query "Starter of activity" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Starter of activity&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Users by user ID</tel:name>
				<tel:parameter id="UserID">%wf:activity(<xsl:value-of select="fdl:starterOfActivity/@activity"/>).owner%</tel:parameter>
			</xsl:when>
			<!-- CASE: Manager of starter of activity -->
			<xsl:when test="$staff-query-type = 'Manager of starter of activity'">
				<!-- Create comment: FDL staff query "Manager of starter of activity" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Manager of starter of activity&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Manager of Employee by user ID</tel:name>
				<tel:parameter id="EmployeeUserID">%wf:activity(<xsl:value-of select="fdl:manager/fdl:starterOfActivity/@activity"/>).owner%</tel:parameter>
			</xsl:when>
			<xsl:when test="$staff-query-type = 'Exclude starter of activity'">
				<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "Exclude starter of activity" *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_ExcludeActivityStarter', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				<!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Everybody</tel:name>
			</xsl:when>
			<!--
				Dynamic staff queries
			-->
			<!-- CASE: Members of roles -->
			<xsl:when test="$staff-query-type = 'Members of roles'">
				<!-- Create comment: FDL staff query "Members of roles" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Members of roles&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Group Members</tel:name>
				<xsl:if test="fdl:role[1]">
					<xsl:choose>
						<xsl:when test="fdl:role[1]/@name">
							<tel:parameter id="GroupName">
								<xsl:value-of select="fdl:role[1]/@name"/>
							</tel:parameter>
						</xsl:when>
						<xsl:when test="fdl:role[1]/@roleName">
							<tel:parameter id="GroupName">
								<xsl:value-of select="fdl:role[1]/@roleName"/>
							</tel:parameter>
						</xsl:when>
						<xsl:when test="fdl:role[1]/fdl:dataStructureMemberName">
							<tel:parameter id="GroupName">
								<xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
								<xsl:apply-templates select="fdl:role[1]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
									<xsl:with-param name="display-name" select="$display-name"/>
									<xsl:with-param name="node" select="$node"/>
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
								</xsl:apply-templates>
								<xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
							</tel:parameter>
						</xsl:when>
					</xsl:choose>
				</xsl:if>
				<tel:parameter id="IncludeSubgroups">
					<xsl:value-of select="false()"/>
				</tel:parameter>
				<xsl:if test="fdl:role[2]">
					<xsl:choose>
						<xsl:when test="fdl:role[2]/@name">
							<tel:parameter id="AlternativeGroupName1">
								<xsl:value-of select="fdl:role[2]/@name"/>
							</tel:parameter>
						</xsl:when>
						<xsl:when test="fdl:role[2]/fdl:dataStructureMemberName">
							<tel:parameter id="AlternativeGroupName1">
								<xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
								<xsl:apply-templates select="fdl:role[2]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
									<xsl:with-param name="display-name" select="$display-name"/>
									<xsl:with-param name="node" select="$node"/>
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
								</xsl:apply-templates>
								<xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
							</tel:parameter>
						</xsl:when>
					</xsl:choose>
				</xsl:if>
				<xsl:if test="fdl:role[3]">
					<xsl:choose>
						<xsl:when test="fdl:role[3]/@name">
							<tel:parameter id="AlternativeGroupName2">
								<xsl:value-of select="fdl:role[3]/@name"/>
							</tel:parameter>
						</xsl:when>
						<xsl:when test="fdl:role[3]/fdl:dataStructureMemberName">
							<tel:parameter id="AlternativeGroupName2">
								<xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
								<xsl:apply-templates select="fdl:role[3]/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
									<xsl:with-param name="display-name" select="$display-name"/>
									<xsl:with-param name="node" select="$node"/>
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
								</xsl:apply-templates>
								<xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
							</tel:parameter>
						</xsl:when>
					</xsl:choose>
				</xsl:if>
				<xsl:if test="fdl:role[4]">
					<!-- Create comment: *** CWWBMnnnnW: BPEL mapping for FDL staff query type "Members of roles" does not consider more than three persons *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MappingLimitation_RoleMembers', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:if test="fdl:level">
					<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "Level" *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_Level', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
			</xsl:when>
			<!-- CASE: Organization -->
			<xsl:when test="$staff-query-type = 'Organization'">
				<!-- Create comment: FDL staff query "Organization" -->
				<xsl:value-of select="concat($eol, '&lt;!-- FDL staff query &quot;Organization&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
				<tel:name>Group Members</tel:name>
				<tel:parameter id="GroupName">
					<xsl:choose>
						<xsl:when test="fdl:organization/@organization">
							<xsl:value-of select="fdl:organization/@organization"/>
						</xsl:when>
						<xsl:when test="fdl:organization/@organizationName">
							<xsl:value-of select="fdl:organization/@organizationName"/>
						</xsl:when>
						<xsl:when test="fdl:organization/fdl:dataStructureMemberName">
							<xsl:value-of select="'&lt;![CDATA['" disable-output-escaping="yes"/>
							<xsl:apply-templates select="fdl:organization/fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
								<xsl:with-param name="display-name" select="$display-name"/>
								<xsl:with-param name="node" select="$node"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
							</xsl:apply-templates>
							<xsl:value-of select="']]&gt;'" disable-output-escaping="yes"/>
						</xsl:when>
					</xsl:choose>
				</tel:parameter>
				<tel:parameter id="IncludeSubGroups">
					<xsl:choose>
						<xsl:when test="fdl:organization/@includeChildOrganizations ='yes'">
							<xsl:value-of select="true()"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="false()"/>
						</xsl:otherwise>
					</xsl:choose>
				</tel:parameter>
				<xsl:if test="fdl:organization/@includeReportingManagers='yes'">
					<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "IncludeReportingManagers" *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_IncludeReportingManagers', $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
			</xsl:when>
			<!-- OTHERWISE: No BPEL mapping available for FDL staff query type -->
			<xsl:otherwise>
				<!-- Create comment: *** CWWBMnnnnW: No BPEL mapping available for FDL staff query type "nnn" *** -->
				<xsl:choose>
					<xsl:when test="local-name($node) = 'process'">
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_StaffQueryType1', $staff-query-type, $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						<!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						<tel:name>Everybody</tel:name>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_StaffQueryType2', $staff-query-type, $name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						<!-- Create comment: *** CWWBMnnnnW: Default staff verb "Everybody" used *** -->
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Information, 'DefaultStaffVerbEverybodyUsed'), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						<tel:name>Everybody</tel:name>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************
		"find-staff-query-type" template:
		
		Determines an FDL staff query type.
		*****************************************************************************************
	 -->
	<xsl:template match="fdl:staff" mode="find-staff-query-type">
		<xsl:param name="node"/>
		<xsl:param name="staff-resolution-target-is-an-activity" select="true()"/>
		<xsl:choose>
			<!--
				Static staff queries (properties page "Staff1"
			-->
			<!-- CASE: Staff from predefined members -->
			<xsl:when test="fdl:staffDefinedInInputContainer | fdl:dataFromInputContainer">
				<xsl:value-of select="'Staff from predefined members'"/>
			</xsl:when>
			<!-- CASE: Coordinator of role -->
			<xsl:when test="fdl:coordinator">
				<xsl:value-of select="'Coordinator of role'"/>
			</xsl:when>
			<!-- CASE: Manager of starter of activity -->
			<xsl:when test="fdl:manager/fdl:starterOfActivity/@activity">
				<xsl:value-of select="'Manager of starter of activity'"/>
			</xsl:when>
			<!-- CASE: Manager of process starter -->
			<xsl:when test="fdl:manager/@ofProcessStarter = 'yes'">
				<xsl:value-of select="'Manager of process starter'"/>
			</xsl:when>
			<!-- CASE: Manager of organization -->
			<xsl:when test="fdl:manager/fdl:organization/@name">
				<xsl:value-of select="'Manager of organization'"/>
			</xsl:when>
			<!-- CASE: People -->
			<xsl:when test="fdl:person">
				<xsl:value-of select="'People'"/>
			</xsl:when>
			<!-- CASE: Process administrator (staff resolution target is an FDL Program Activity and the current node is not the FDL Process) -->
			<xsl:when test="fdl:processAdministrator and $staff-resolution-target-is-an-activity and not(local-name($node) = 'process')">
				<xsl:value-of select="'Process administrator'"/>
			</xsl:when>
			<!-- CASE: Process administrator (staff resolution target as well as the current node is the FDL Process) -->
			<xsl:when test="fdl:processAdministrator and not($staff-resolution-target-is-an-activity) and local-name($node) = 'process'">
				<xsl:value-of select="'Process administrator'"/>
			</xsl:when>
			<!-- CASE: Process starter -->
			<xsl:when test="fdl:processStarter">
				<xsl:value-of select="'Process starter'"/>
			</xsl:when>
			<!-- CASE: Starter of activity -->
			<xsl:when test="fdl:starterOfActivity/@activity">
				<xsl:value-of select="'Starter of activity'"/>
			</xsl:when>
			<!-- CASE: Exclude starter of activity -->
			<xsl:when test="fdl:excludeStarterOfActivity">
				<xsl:value-of select="'Exclude starter of activity'"/>
			</xsl:when>
			<!--
				Dynamic staff queries (properties page "Staff2"
			-->
			<!-- CASE: Members of roles -->
			<xsl:when test="fdl:role">
				<xsl:value-of select="'Members of roles'"/>
			</xsl:when>
			<!-- CASE: Organization -->
			<xsl:when test="fdl:organization">
				<xsl:value-of select="'Organization'"/>
			</xsl:when>
			<!-- OTHERWISE: All people -->
			<xsl:otherwise>
				<xsl:value-of select="'All people'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************
		Template "create-escalation-chain"

		Called by an "create-standard-activity" template.
		Translates FDL "notifications"  to an "escalation chain" of TEL task definition.
		*****************************************************************************************
	 -->
	<xsl:template name="create-escalation-chain">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:variable name="firstNotification" select="$activity/fdl:notification[ @type='1st' and fdl:staff ]"/>
		<xsl:variable name="secondNotification" select="$activity/fdl:notification[ @type='2nd']"/>
		<xsl:if test="$firstNotification">
			<tel:escalationChain activationState="ready">
				<!-- Select the maximum duration (SIMPLE time format assumed) -->
				<xsl:if test="$firstNotification/fdl:dataStructureMemberName">
					<!-- Create comment: ***CWWBMnnnnW: No BPEL mapping available for FDL notification from container *** -->
					<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_NotificationTakenFrom', $activity/@name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
				</xsl:if>
				<xsl:variable name="durationUntilFirstEscalation">
					<xsl:if test="$firstNotification/@maximumDuration">
						<xsl:call-template name="create-SIMPLE-time-format">
							<xsl:with-param name="XFDL-time-format" select="$firstNotification/@maximumDuration"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:variable>
				<tel:escalation atLeastExpectedState="ended" durationUntilEscalation="{$durationUntilFirstEscalation}" escalationAction="workItem" name="Notification1">
					<tel:escalationReceiver>
						<tel:verb>
							<xsl:apply-templates select="$firstNotification/fdl:staff" mode="create-staff-query-verb">
								<xsl:with-param name="name" select="$activity/@name"/>
								<xsl:with-param name="node" select="$activity"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
							</xsl:apply-templates>
						</tel:verb>
					</tel:escalationReceiver>
				</tel:escalation>
				<xsl:if test="$secondNotification">
					<!-- Select the maximum duration (SIMPLE time format assumed) -->
					<xsl:if test="$secondNotification/fdl:dataStructureMemberName">
						<!-- Create comment: ***CWWBMnnnnW: No BPEL mapping available for FDL notification from container *** -->
						<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'NoMappingAvailable_NotificationTakenFrom', $activity/@name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
					</xsl:if>
					<xsl:variable name="durationUntilSecondEscalation">
						<xsl:if test="$secondNotification/@maximumDuration">
							<xsl:call-template name="create-SIMPLE-time-format">
								<xsl:with-param name="XFDL-time-format" select="$secondNotification/@maximumDuration"/>
							</xsl:call-template>
						</xsl:if>
					</xsl:variable>
					<tel:escalation atLeastExpectedState="ended" durationUntilEscalation="{$durationUntilSecondEscalation}" escalationAction="workItem" name="Notification2">
						<tel:escalationReceiver>
							<tel:verb>
								<!-- Provide XFDL staff definition for process administrator who will receive the second notification -->
								<xsl:variable name="process-admin">
									<fdl:staff>
										<fdl:processAdministrator/>
									</fdl:staff>
								</xsl:variable>
								<xsl:apply-templates select="xalan:nodeset($process-admin)/fdl:staff" mode="create-staff-query-verb">
									<xsl:with-param name="name" select="$activity/@name"/>
									<xsl:with-param name="node" select="$activity"/>
									<xsl:with-param name="variables" select="$variables"/>
									<xsl:with-param name="name-prefix" select="$name-prefix"/>
									<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
									<xsl:with-param name="local-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
								</xsl:apply-templates>
							</tel:verb>
						</tel:escalationReceiver>
					</tel:escalation>
				</xsl:if>
			</tel:escalationChain>
		</xsl:if>
	</xsl:template>
	<!--
		********************************************
		"join condition" template:
		
		Creates a "bpc:joinCondition" element
		********************************************
	 -->
	<xsl:template match="fdl:join" mode="join-condition">
		<!--
			Create "bpc:joinCondition" element, if FDL start condition = "All incoming connectors true".
			Otherwise the default join condition (<bpc:any>) applies.
		-->
		<xsl:choose>
			<xsl:when test="@condition = 'all'">
				<bpel:joinCondition expressionLanguage="{$BUILTIN}">
					<bpc:all/>
				</bpel:joinCondition>
			</xsl:when>
			<xsl:otherwise>
				<bpel:joinCondition expressionLanguage="{$BUILTIN}">
					<bpc:any/>
				</bpel:joinCondition>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		********************************************
		"link sources" template:
		
		Creates a "source" for each "fdl:control"
		********************************************
	 -->
	<xsl:template match="fdl:control" mode="link-sources">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<bpel:source linkName="{@from}-to-{@to}">
			<xsl:choose>
				<!-- CASE: Assign a transition condition, if defined. -->
				<xsl:when test="fdl:condition[ * and not( @transitionCondition='true' or @transitionCondition='otherwise' ) ]">
					<!-- Create "xpath" condition -->
					<xsl:variable name="activity" select="../*[ ( local-name() = 'programActivity' or local-name() = 'processActivity' or local-name() = 'block' ) and current()/@from = @name ][1]"/>
					<bpel:transitionCondition expressionLanguage="{$XPATH}">
						<xsl:call-template name="create-condition-xpath-expression">
							<xsl:with-param name="variables" select="$variables"/>
							<xsl:with-param name="name-prefix" select="$name-prefix"/>
							<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
							<xsl:with-param name="activity" select="$activity"/>
							<xsl:with-param name="condition" select="fdl:condition"/>
							<xsl:with-param name="condition-applies-to-activity-exit" select="false()"/>
						</xsl:call-template>
					</bpel:transitionCondition>
				</xsl:when>
				<!-- CASE: "default connector" -->
				<xsl:when test="@transitionCondition='otherwise'">
					<bpel:transitionCondition expressionLanguage="{$BUILTIN}">
						<bpc:otherwise/>
					</bpel:transitionCondition>
				</xsl:when>
				<xsl:otherwise>
					<bpel:transitionCondition expressionLanguage="{$BUILTIN}">
						<bpc:true/>
					</bpel:transitionCondition>
				</xsl:otherwise>
			</xsl:choose>
		</bpel:source>
	</xsl:template>
	<!--
		********************************************
		"link targets" template:
		
		Creates a "target" for each "fdl:control"
		********************************************
	 -->
	<xsl:template match="fdl:control" mode="link-targets">
		<bpel:target linkName="{@from}-to-{@to}"/>
	</xsl:template>
	<!--
		********************************************
		"data-defaults" template:
		
		Creates data defaults for process
		and or activity input/output containers
		********************************************
	 -->
	<xsl:template match="fdl:programActivity | fdl:processActivity | fdl:block" mode="data-defaults">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="create-assign-activity" select="true()"/>
		<!-- Translate the setting of activity input data defaults to "assign" activities. -->
		<xsl:call-template name="set-data-fields">
			<xsl:with-param name="create-assign-activity" select="$create-assign-activity"/>
			<xsl:with-param name="data-fields" select="current()/fdl:input/fdl:dataDefaults"/>
			<xsl:with-param name="variables" select="$variables"/>
			<xsl:with-param name="variable-name" select="concat($name-prefix, current()/@name, $input-variable-suffix)"/>
			<xsl:with-param name="node" select="current()"/>
			<xsl:with-param name="container-type" select="'input'"/>
		</xsl:call-template>
		<!-- Translate the setting of activity output data defaults to "assign" activities. -->
		<xsl:call-template name="set-data-fields">
			<xsl:with-param name="create-assign-activity" select="$create-assign-activity"/>
			<xsl:with-param name="data-fields" select="current()/fdl:output/fdl:dataDefaults"/>
			<xsl:with-param name="variables" select="$variables"/>
			<xsl:with-param name="variable-name" select="concat($name-prefix, current()/@name, $output-variable-suffix)"/>
			<xsl:with-param name="node" select="current()"/>
			<xsl:with-param name="container-type" select="'output'"/>
		</xsl:call-template>
		<!-- Create the data defaults of activities contained in a block -->
		<xsl:if test="local-name() = 'block'">
			<xsl:variable name="child-name-prefix">
				<xsl:choose>
					<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
						<!-- Cascaded name prefix not required: return existing prefix -->
						<xsl:value-of select="$name-prefix"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$name-prefix = ''">
								<xsl:value-of select="concat(@name, '_')"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="concat($name-prefix, @name, '_')"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:apply-templates select="fdl:blockImplementation/fdl:programActivity | fdl:blockImplementation/fdl:processActivity | fdl:blockImplementation/fdl:block" mode="data-defaults">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$child-name-prefix"/>
				<xsl:with-param name="create-assign-activity" select="$create-assign-activity"/>
			</xsl:apply-templates>
		</xsl:if>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		Template "set-data-fields":

		Creates an "assign" activity which sets the data defaults.
		*****************************************************************************************************************************
	 -->
	<xsl:template name="set-data-fields">
		<xsl:param name="create-assign-activity" select="true()"/>
		<xsl:param name="data-fields"/>
		<xsl:param name="variables"/>
		<xsl:param name="variable-name"/>
		<xsl:param name="node"/>
		<xsl:param name="container-type"/>
		<xsl:if test="('TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)
				    and 'TRUE' = translate($initializePredefinedDataMembers, $lower-case-characters, $upper-case-characters) )
		 		    or $data-fields">
			<!-- Create comment: Set input/output/UPES data defaults of process/activity "nnn" -->
			<xsl:value-of select="concat($eol, '&lt;!-- Set ', $container-type, ' data defaults of ', local-name($node), ' &quot;', $node/@displayName, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			<xsl:variable name="message-type" select="$variables//bpel:variable[@name = $variable-name]/@messageType"/>
			<xsl:variable name="xsd-type" select="$variables//bpel:variable[@name = $variable-name]/@element"/>
			<xsl:variable name="display-name">
				<xsl:choose>
					<xsl:when test="$container-type = 'UPES'">
						<xsl:value-of select="concat('Set ', $container-type, ' context')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="local-name($node) = 'process'">
								<xsl:value-of select="concat('Set process ', $container-type, ' defaults')"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="concat('Set ', $container-type, ' defaults')"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<!-- "all data fields" may include default values from predefined data members -->
			<xsl:variable name="all-data-fields">
				<xsl:choose>
					<xsl:when test="not( $container-type = 'UPES')
										 and 'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)
										 and 'TRUE' = translate($initializePredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
						<xsl:variable name="predefined-data-member-values">
							<xsl:choose>
								<!-- CASE: node is a process -->
								<xsl:when test="local-name($node) = 'process'">
									<fdl:field type="string" value="{$node/@name}">
										<fdl:dataStructureMemberName>
											<fdl:nameComponent name="_PROCESS_MODEL"/>
										</fdl:dataStructureMemberName>
									</fdl:field>
								</xsl:when>
								<!-- OTHERWISE: assume that node is an activity -->
								<xsl:otherwise>
									<fdl:field type="string" value="{$node/@name}">
										<fdl:dataStructureMemberName>
											<fdl:nameComponent name="_ACTIVITY"/>
										</fdl:dataStructureMemberName>
									</fdl:field>
									<fdl:field type="string" value="{$node/ancestor::fdl:process/@name}">
										<fdl:dataStructureMemberName>
											<fdl:nameComponent name="_PROCESS_MODEL"/>
										</fdl:dataStructureMemberName>
									</fdl:field>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<xsl:copy-of select="$data-fields/fdl:field | xalan:nodeset($predefined-data-member-values)/fdl:field"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="$data-fields/fdl:field"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="wsdl-message-part" select="document($wsdlfile)//wsdl:message[ concat('wsdl1:', @name) = $message-type ]/wsdl:part"/>
			<xsl:variable name="wsdl-message-part-type" select="$wsdl-message-part/@type"/>
			<xsl:variable name="wsdl-message-part-name" select="$wsdl-message-part/@name"/>
			<xsl:choose>
				<xsl:when test="$create-assign-activity">
					<!-- Create "assign" activity -->
					<bpel:assign bpc:displayName="{$display-name}" name="{generate-id()}">
						<!--
								Create data default copy elements
						-->
						<xsl:call-template name="create-data-field-copy-elements">
							<xsl:with-param name="all-data-fields" select="$all-data-fields"/>
							<xsl:with-param name="xsd-type" select="$xsd-type"/>
							<xsl:with-param name="wsdl-message-part-type" select="$wsdl-message-part-type"/>
							<xsl:with-param name="wsdl-message-part-name" select="$wsdl-message-part-name"/>
							<xsl:with-param name="display-name" select="$display-name"/>
							<xsl:with-param name="variable-name" select="$variable-name"/>
						</xsl:call-template>
					</bpel:assign>
				</xsl:when>
				<xsl:otherwise>
					<!--
							Create data default copy elements
					-->
					<xsl:call-template name="create-data-field-copy-elements">
						<xsl:with-param name="all-data-fields" select="$all-data-fields"/>
						<xsl:with-param name="xsd-type" select="$xsd-type"/>
						<xsl:with-param name="wsdl-message-part-type" select="$wsdl-message-part-type"/>
						<xsl:with-param name="wsdl-message-part-name" select="$wsdl-message-part-name"/>
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="variable-name" select="$variable-name"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:template>
	<!--
		************************************************************************************************
		"create-data-field-copy-elements" template
		
		Called by template "set-data-fields"
		************************************************************************************************
	-->
	<xsl:template name="create-data-field-copy-elements">
		<xsl:param name="all-data-fields"/>
		<xsl:param name="xsd-type"/>
		<xsl:param name="wsdl-message-part-type"/>
		<xsl:param name="wsdl-message-part-name"/>
		<xsl:param name="display-name"/>
		<xsl:param name="variable-name"/>
		<xsl:for-each select="xalan:nodeset($all-data-fields)/fdl:field">
			<xsl:variable name="first">
				<xsl:choose>
					<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
						<xsl:value-of select="1"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="2"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="dataStructureMemberName" select="current()/fdl:dataStructureMemberName[$first]"/>
			<xsl:variable name="xml-schema-type">
				<xsl:choose>
					<xsl:when test="$xsd-type">
						<xsl:value-of select="$xsd-type"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$wsdl-message-part-type"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="part-name">
				<xsl:if test="not($xsd-type)">
					<xsl:value-of select="$wsdl-message-part-name"/>
				</xsl:if>
			</xsl:variable>
			<xsl:call-template name="set-data-field-copy-element">
				<xsl:with-param name="display-name" select="$display-name"/>
				<xsl:with-param name="variable-name" select="$variable-name"/>
				<xsl:with-param name="dataStructureMemberName" select="$dataStructureMemberName"/>
				<xsl:with-param name="value" select="current()/@value"/>
				<xsl:with-param name="XMLSchemaType" select="$xml-schema-type"/>
				<xsl:with-param name="part-name" select="$part-name"/>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:template>
	<!--
		************************************************************************************************
		"set-data-field-copy-element" template
		
		Called by template "create-process-data-defaults" or "create-activity-data-defaults"
		************************************************************************************************
	-->
	<xsl:template name="set-data-field-copy-element">
		<xsl:param name="display-name"/>
		<xsl:param name="variable-name"/>
		<xsl:param name="dataStructureMemberName"/>
		<xsl:param name="value"/>
		<xsl:param name="XMLSchemaType"/>
		<xsl:param name="part-name"/>
		<xsl:variable name="first">
			<xsl:choose>
				<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
					<xsl:value-of select="1"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$dataStructureMemberName/fdl:nameComponent[1]/@name = '_STRUCT'">
							<xsl:value-of select="2"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="1"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="value-type">
			<xsl:call-template name="find-data-field-type">
				<xsl:with-param name="XMLSchemaType" select="$XMLSchemaType"/>
				<xsl:with-param name="nameComponent" select="$dataStructureMemberName/fdl:nameComponent[ position() = $first ]"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="to-query-string">
			<xsl:call-template name="translate-dataStructureMemberName-to-XPath">
				<xsl:with-param name="display-name" select="$display-name"/>
				<xsl:with-param name="XMLSchemaType" select="$XMLSchemaType"/>
				<xsl:with-param name="nameComponent" select="$dataStructureMemberName/fdl:nameComponent[ position() = $first ]"/>
			</xsl:call-template>
		</xsl:variable>
		<!-- Create data copy element -->
		<bpel:copy>
			<bpel:from>
				<!-- DEPRECATED:	<bpc:literal type="{$value-type}"> -->
				<xsl:value-of select="concat('&lt;![CDATA[', $value, ']]&gt;')" disable-output-escaping="yes"/>
				<!-- DEPRECATED:	</bpc:literal> -->
			</bpel:from>
			<bpel:to variable="{$variable-name}">
				<xsl:if test="$part-name">
					<xsl:attribute name="part"><xsl:value-of select="$part-name"/></xsl:attribute>
				</xsl:if>
				<bpel:query>
					<!-- FG added:  CDATA for query values -->
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<xsl:value-of select="xalan:nodeset($to-query-string)/*" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpel:query>
			</bpel:to>
		</bpel:copy>
	</xsl:template>
	<!--
		***************************************************************************************************************************************************
		"find-data-field-type" template
		
		Called by "set-data-field-copy-element"
		***************************************************************************************************************************************************
	-->
	<xsl:template name="find-data-field-type">
		<xsl:param name="XMLSchemaType"/>
		<xsl:param name="nameComponent"/>
		<xsl:variable name="XMLSchemaTypeDef" select="document($xsdfile)//xsd:complexType[concat('mqwf:', @name) = $XMLSchemaType]"/>
		<xsl:variable name="element-name" select="$nameComponent/@name"/>
		<xsl:variable name="XMLSchemaTypeDef-Element" select="$XMLSchemaTypeDef/xsd:sequence/xsd:element[@name = $element-name]"/>
		<xsl:choose>
			<xsl:when test="substring($XMLSchemaTypeDef-Element/@type, 1,4) = 'mqwf'">
				<xsl:variable name="element-type" select="substring-after($XMLSchemaTypeDef-Element/@type, 'mqwf:')"/>
				<xsl:variable name="following-nameComponent" select="$nameComponent/following-sibling::fdl:nameComponent[1]"/>
				<xsl:choose>
					<xsl:when test="$following-nameComponent">
						<xsl:call-template name="find-data-field-type">
							<xsl:with-param name="XMLSchemaType" select="concat('mqwf:', $element-type)"/>
							<xsl:with-param name="nameComponent" select="$following-nameComponent"/>
						</xsl:call-template>
					</xsl:when>
					<!-- data default type error -->
					<xsl:otherwise>
						<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'IllegalDataType', $element-type), ' ***')"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<!-- Return value type -->
				<xsl:value-of select="$XMLSchemaTypeDef-Element/@type"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "create-data-mapping-standard-to-UPES":
		
		Called by template "create-UPES-activity".
		Creates a "data mapping" ("assign" or "Java snippet") activity that maps the data input message into another one
		which conforms to the UPES interoperability convention.
		*****************************************************************************************************
	-->
	<xsl:template name="create-data-mapping-standard-to-UPES">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:variable name="standard-variable-name" select="concat($name-prefix, $activity/@name, $input-variable-suffix)"/>
		<xsl:variable name="standard-message-type" select="$variables//bpel:variable[@name = $standard-variable-name]/@messageType"/>
		<xsl:variable name="standard-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $standard-message-type]/wsdl:part"/>
		<xsl:variable name="standard-message-part-name" select="$standard-message-part/@name"/>
		<xsl:variable name="standard-message-part-type" select="$standard-message-part/@type"/>
		<xsl:variable name="standard-message-part-type-local-name" select="substring-after($standard-message-part-type, 'mqwf:')"/>
		<xsl:variable name="UPES-variable-name" select="concat($name-prefix, $activity/@name, $UPES-input-variable-suffix)"/>
		<xsl:variable name="UPES-message-type" select="$variables//bpel:variable[@name = $UPES-variable-name]/@messageType"/>
		<xsl:variable name="UPES-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $UPES-message-type]/wsdl:part"/>
		<xsl:variable name="UPES-message-part-name" select="$UPES-message-part/@name"/>
		<xsl:variable name="UPES-message-part-type" select="$UPES-message-part/@type"/>
		<xsl:variable name="UPES-message-part-type-local-name" select="substring-after($UPES-message-part-type, 'mqwf:')"/>
		<xsl:variable name="standard-to-UPES-mappings">
			<xsl:call-template name="standard-to-UPES-mappings"/>
		</xsl:variable>
		<!-- Create comment: Data format conversion ("standard" to UPES) from variable "nnn" to variable "nnn"-->
		<xsl:value-of select="concat($eol, '&lt;!--  Data format conversion (&quot;standard&quot; to UPES) from variable  &quot;', $standard-variable-name, '&quot; to variable &quot;', $UPES-variable-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<xsl:choose>
			<!-- CASE: create "Java snippet" activity -->
			<xsl:when test="'TRUE' = translate($create_Java_Snippets, $lower-case-characters, $upper-case-characters)">
				<bpel:invoke portType="bpc:null" partnerLink="null" operation="null" name="{generate-id()}" bpc:displayName="Encode UPES input">
					<bpc:script>
						<bpc:javaCode>
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:apply-templates select="xalan:nodeset($standard-to-UPES-mappings)/fdl:map" mode="data">
								<xsl:with-param name="display-name" select="'Encode UPES input'"/>
								<xsl:with-param name="from-variable-name" select="$standard-variable-name"/>
								<xsl:with-param name="to-variable-name" select="$UPES-variable-name"/>
								<xsl:with-param name="source-wsdl-message-part-type" select="$standard-message-part-type"/>
								<xsl:with-param name="source-wsdl-message-part-name" select="$standard-message-part-name"/>
								<xsl:with-param name="target-wsdl-message-part-type" select="$UPES-message-part-type"/>
								<xsl:with-param name="target-wsdl-message-part-name" select="$UPES-message-part-name"/>
							</xsl:apply-templates>
							<!-- Initialize business object -->
							<xsl:value-of select="concat($eol, 
					                                'if (',
													$UPES-variable-name, 
					                                ' == null) {',
					                                $eol,
					                                '    BOFactory boFactory = (BOFactory)ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
					                                $eol,
					                                '    ',
													$UPES-variable-name, 
					                                ' = boFactory.createByType(getVariableType(&quot;',
													$UPES-variable-name, 
													'&quot;));',
					                                $eol,
					                                '}')" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:javaCode>
					</bpc:script>
				</bpel:invoke>
			</xsl:when>
			<!-- OTHERWISE: create "assign" activity -->
			<xsl:otherwise>
				<bpel:assign name="{generate-id()}" bpc:displayName="Encode UPES input">
					<!-- Create data mappings -->
					<xsl:apply-templates select="xalan:nodeset($standard-to-UPES-mappings)/fdl:map" mode="data">
						<xsl:with-param name="display-name" select="'Encode UPES input'"/>
						<xsl:with-param name="from-variable-name" select="$standard-variable-name"/>
						<xsl:with-param name="to-variable-name" select="$UPES-variable-name"/>
						<xsl:with-param name="source-wsdl-message-part-type" select="$standard-message-part-type"/>
						<xsl:with-param name="source-wsdl-message-part-name" select="$standard-message-part-name"/>
						<xsl:with-param name="target-wsdl-message-part-type" select="$UPES-message-part-type"/>
						<xsl:with-param name="target-wsdl-message-part-name" select="$UPES-message-part-name"/>
					</xsl:apply-templates>
				</bpel:assign>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "create-UPES-default-container-mapping":
		
		Called by template "create-UPES-activity".
		Creates a "data mapping" ("assign" or "Java snippet") activity that maps the data output message into the
		"MessageDefaultContainer" element of another message which conforms to the UPES
		interoperability convention.
		*****************************************************************************************************
	-->
	<xsl:template name="create-UPES-default-container-mapping">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:variable name="standard-variable-name" select="concat($name-prefix, $activity/@name, $output-variable-suffix)"/>
		<xsl:variable name="standard-message-type" select="$variables//bpel:variable[@name = $standard-variable-name]/@messageType"/>
		<xsl:variable name="standard-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $standard-message-type]/wsdl:part"/>
		<xsl:variable name="standard-message-part-name" select="$standard-message-part/@name"/>
		<xsl:variable name="standard-message-part-type" select="$standard-message-part/@type"/>
		<xsl:variable name="standard-message-part-type-local-name" select="substring-after($standard-message-part-type, 'mqwf:')"/>
		<xsl:variable name="UPES-variable-name" select="concat($name-prefix, $activity/@name, $UPES-input-variable-suffix)"/>
		<xsl:variable name="UPES-message-type" select="$variables//bpel:variable[@name = $UPES-variable-name]/@messageType"/>
		<xsl:variable name="UPES-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $UPES-message-type]/wsdl:part"/>
		<xsl:variable name="UPES-message-part-name" select="$UPES-message-part/@name"/>
		<xsl:variable name="UPES-message-part-type" select="$UPES-message-part/@type"/>
		<xsl:variable name="UPES-message-part-type-local-name" select="substring-after($UPES-message-part-type, 'mqwf:')"/>
		<xsl:variable name="UPES-default-container-mapping">
			<xsl:call-template name="UPES-default-container-mapping"/>
		</xsl:variable>
		<!-- Create comment: Complete the data format conversion ("standard" to UPES) by mapping the output data defaults from variable "nnn" to variable "nnn"-->
		<xsl:value-of select="concat($eol, '&lt;!--  Complete the data format conversion (&quot;standard&quot; to UPES) by mapping the output data defaults from variable  &quot;', $standard-variable-name, '&quot; to variable &quot;', $UPES-variable-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<xsl:choose>
			<!-- CASE: create "Java snippet" activity -->
			<xsl:when test="'TRUE' = translate($create_Java_Snippets, $lower-case-characters, $upper-case-characters)">
				<bpel:invoke portType="bpc:null" partnerLink="null" operation="null" name="{generate-id()}" bpc:displayName="Encode UPES output defaults">
					<bpc:script>
						<bpc:javaCode>
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:apply-templates select="xalan:nodeset($UPES-default-container-mapping)/fdl:map" mode="data">
								<xsl:with-param name="display-name" select="'Encode UPES output defaults'"/>
								<xsl:with-param name="from-variable-name" select="$standard-variable-name"/>
								<xsl:with-param name="to-variable-name" select="$UPES-variable-name"/>
								<xsl:with-param name="source-wsdl-message-part-type" select="$standard-message-part-type"/>
								<xsl:with-param name="source-wsdl-message-part-name" select="$standard-message-part-name"/>
								<xsl:with-param name="target-wsdl-message-part-type" select="$UPES-message-part-type"/>
								<xsl:with-param name="target-wsdl-message-part-name" select="$UPES-message-part-name"/>
							</xsl:apply-templates>
							<!-- Initialize business object -->
							<xsl:value-of select="concat($eol, 
					                                'if (',
													$UPES-variable-name, 
					                                ' == null) {',
					                                $eol,
					                                '    BOFactory boFactory = (BOFactory)ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
					                                $eol,
					                                '    ',
													$UPES-variable-name, 
					                                ' = boFactory.createByType(getVariableType(&quot;',
													$UPES-variable-name, 
													'&quot;));',
					                                $eol,
					                                '}',
													$eol)" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:javaCode>
					</bpc:script>
				</bpel:invoke>
			</xsl:when>
			<!-- OTHERWISE: create "assign" activity -->
			<xsl:otherwise>
				<bpel:assign name="{generate-id()}" bpc:displayName="Encode UPES output defaults">
					<!-- Create data mappings -->
					<xsl:apply-templates select="xalan:nodeset($UPES-default-container-mapping)/fdl:map" mode="data">
						<xsl:with-param name="display-name" select="'Encode UPES output defaults'"/>
						<xsl:with-param name="from-variable-name" select="$standard-variable-name"/>
						<xsl:with-param name="to-variable-name" select="$UPES-variable-name"/>
						<xsl:with-param name="source-wsdl-message-part-type" select="$standard-message-part-type"/>
						<xsl:with-param name="source-wsdl-message-part-name" select="$standard-message-part-name"/>
						<xsl:with-param name="target-wsdl-message-part-type" select="$UPES-message-part-type"/>
						<xsl:with-param name="target-wsdl-message-part-name" select="$UPES-message-part-name"/>
					</xsl:apply-templates>
				</bpel:assign>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "create-data-mapping-UPES-to-standard":
		
		Called by template "create-UPES-activity".
		Creates a "data mapping" ("assign" or "Java snippet") activity that maps the UPES data output message back to the
		"standard" data message format.
		*****************************************************************************************************
	-->
	<xsl:template name="create-data-mapping-UPES-to-standard">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:variable name="UPES-variable-name" select="concat($name-prefix, $activity/@name, $UPES-output-variable-suffix)"/>
		<xsl:variable name="UPES-message-type" select="$variables//bpel:variable[@name = $UPES-variable-name]/@messageType"/>
		<xsl:variable name="UPES-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $UPES-message-type]/wsdl:part"/>
		<xsl:variable name="UPES-message-part-name" select="$UPES-message-part/@name"/>
		<xsl:variable name="UPES-message-part-type" select="$UPES-message-part/@type"/>
		<xsl:variable name="UPES-message-part-type-local-name" select="substring-after($UPES-message-part-type, 'mqwf:')"/>
		<xsl:variable name="standard-variable-name" select="concat($name-prefix, $activity/@name, $output-variable-suffix)"/>
		<xsl:variable name="standard-message-type" select="$variables//bpel:variable[@name = $standard-variable-name]/@messageType"/>
		<xsl:variable name="standard-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $standard-message-type]/wsdl:part"/>
		<xsl:variable name="standard-message-part-name" select="$standard-message-part/@name"/>
		<xsl:variable name="standard-message-part-type" select="$standard-message-part/@type"/>
		<xsl:variable name="standard-message-part-type-local-name" select="substring-after($standard-message-part-type, 'mqwf:')"/>
		<!-- Create comment: Data format conversion (UPES to "standard") from variable "nnn" to variable "nnn"-->
		<xsl:value-of select="concat($eol, '&lt;!--  Data format conversion (UPES to &quot;standard&quot;) from variable  &quot;', $UPES-variable-name, '&quot; to variable &quot;', $standard-variable-name, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
		<xsl:variable name="UPES-to-standard-mappings">
			<xsl:call-template name="UPES-to-standard-mappings"/>
		</xsl:variable>
		<xsl:choose>
			<!-- CASE: create "Java snippet" activity -->
			<xsl:when test="'TRUE' = translate($create_Java_Snippets, $lower-case-characters, $upper-case-characters)">
				<bpel:invoke portType="bpc:null" partnerLink="null" operation="null" name="{generate-id()}" bpc:displayName="Decode UPES output">
					<bpc:script>
						<bpc:javaCode>
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
									<xsl:value-of select="concat($eol, 
															'BOCopy copyService = (BOCopy)ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOCopy&quot;);')" disable-output-escaping="yes"/>
							<xsl:choose>
								<!-- CASE: parameter "createPredefinedDataMembers" is set to "true" -->
								<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
									<!-- Initialize business object -->
									<xsl:value-of select="concat($eol, 
															'if (',
															$standard-variable-name, 
															' == null) {',
															$eol,
															'    BOFactory boFactory = (BOFactory)ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
															$eol,
															'    ',
															$standard-variable-name, 
															' = boFactory.createByType(getVariableType(&quot;',
															$standard-variable-name, 
															'&quot;));',
															$eol,
															'}')" disable-output-escaping="yes"/>
									<!-- Execute decoding data mappings -->
									<xsl:value-of select="concat($eol, 
															$standard-variable-name, 
															'.set(&quot;_PROCESS&quot;, ',
															$UPES-variable-name,
															'.get(&quot;/MessageContext/_PROCESS&quot;));')" disable-output-escaping="yes"/>
									<xsl:value-of select="concat($eol, 
															$standard-variable-name, 
															'.set(&quot;_PROCESS_MODEL&quot;, ',
															$UPES-variable-name,
															'.get(&quot;/MessageContext/_PROCESS_MODEL&quot;));')" disable-output-escaping="yes"/>
									<xsl:value-of select="concat($eol, 
															$standard-variable-name, 
															'.set(&quot;_ACTIVITY&quot;, ',
															$UPES-variable-name,
															'.get(&quot;/MessageContext/_ACTIVITY&quot;));')" disable-output-escaping="yes"/>
									<xsl:value-of select="concat($eol, 
															$standard-variable-name, 
															'.set(&quot;_PROCESS_INFO&quot;, copyService.copy(',
															$UPES-variable-name,
															'.getDataObject(&quot;/MessageContext/_PROCESS_INFO&quot;)));')" disable-output-escaping="yes"/>
									<xsl:value-of select="concat($eol, 
															$standard-variable-name, 
															'.set(&quot;_ACTIVITY_INFO&quot;, copyService.copy(',
															$UPES-variable-name,
															'.getDataObject(&quot;/MessageContext/_ACTIVITY_INFO&quot;)));')" disable-output-escaping="yes"/>
									<xsl:value-of select="concat($eol, 
															$standard-variable-name, 
															'.set(&quot;_STRUCT&quot;, ',
															$UPES-variable-name,
															'.get(&quot;/MessageContainer&quot;));')" disable-output-escaping="yes"/>
								</xsl:when>
								<!-- OHERWISE: It is assumed, that parameter "createPredefinedDataMembers" is set to "false" -->
								<xsl:otherwise>
									<xsl:value-of select="concat($eol, 
															$standard-variable-name, 
															' = copyService.copy(',
															$UPES-variable-name,
															'.getDataObject(&quot;/MessageContainer&quot;));')" disable-output-escaping="yes"/>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:javaCode>
					</bpc:script>
				</bpel:invoke>
			</xsl:when>
			<!-- OTHERWISE: create "assign" activity -->
			<xsl:otherwise>
				<bpel:assign name="{generate-id()}" bpc:displayName="Decode UPES output">
					<!-- Create data mappings -->
					<xsl:apply-templates select="xalan:nodeset($UPES-to-standard-mappings)/fdl:map" mode="data">
						<xsl:with-param name="display-name" select="'Decode UPES output'"/>
						<xsl:with-param name="from-variable-name" select="$UPES-variable-name"/>
						<xsl:with-param name="to-variable-name" select="$standard-variable-name"/>
						<xsl:with-param name="source-wsdl-message-part-type" select="$UPES-message-part-type"/>
						<xsl:with-param name="source-wsdl-message-part-name" select="$UPES-message-part-name"/>
						<xsl:with-param name="target-wsdl-message-part-type" select="$standard-message-part-type"/>
						<xsl:with-param name="target-wsdl-message-part-name" select="$standard-message-part-name"/>
					</xsl:apply-templates>
				</bpel:assign>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "standard-to-UPES-mappings":
		
		Returns the "fdl:map" elements that are needed to create
		"standard-to-UPES-mapping" expressions
		*****************************************************************************************************
	-->
	<xsl:template name="standard-to-UPES-mappings">
		<xsl:if test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_RC"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_RC"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_PROCESS"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_PROCESS"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_PROCESS_MODEL"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_PROCESS_MODEL"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_ACTIVITY"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_ACTIVITY"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_PROCESS_INFO"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_PROCESS_INFO"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_ACTIVITY_INFO"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_ACTIVITY_INFO"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
		</xsl:if>
		<fdl:map>
			<fdl:sourceMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="_STRUCT"/>
				</fdl:dataStructureMemberName>
			</fdl:sourceMember>
			<fdl:targetMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="MessageContainer"/>
				</fdl:dataStructureMemberName>
			</fdl:targetMember>
		</fdl:map>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "UPES-default-container-mapping":
		
		Returns the "fdl:map" element that is needed to create the
		"UPES-default-container-mapping" expression
		*****************************************************************************************************
	-->
	<xsl:template name="UPES-default-container-mapping">
		<fdl:map>
			<fdl:sourceMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="_STRUCT"/>
				</fdl:dataStructureMemberName>
			</fdl:sourceMember>
			<fdl:targetMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="MessageDefaultContainer"/>
				</fdl:dataStructureMemberName>
			</fdl:targetMember>
		</fdl:map>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "UPES-to-standard-mappings":
		
		Returns the "fdl:map" elements that are needed to create
		"UPES-to-standard-mapping" expressions
		*****************************************************************************************************
	-->
	<xsl:template name="UPES-to-standard-mappings">
		<xsl:if test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_RC"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_RC"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_PROCESS"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_PROCESS"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_PROCESS_MODEL"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_PROCESS_MODEL"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_ACTIVITY"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_ACTIVITY"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_PROCESS_INFO"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_PROCESS_INFO"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
			<fdl:map>
				<fdl:sourceMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="MessageContext"/>
						<fdl:nameComponent name="_ACTIVITY_INFO"/>
					</fdl:dataStructureMemberName>
				</fdl:sourceMember>
				<fdl:targetMember>
					<fdl:dataStructureMemberName>
						<fdl:nameComponent name="_ACTIVITY_INFO"/>
					</fdl:dataStructureMemberName>
				</fdl:targetMember>
			</fdl:map>
		</xsl:if>
		<fdl:map>
			<fdl:sourceMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="MessageContainer"/>
				</fdl:dataStructureMemberName>
			</fdl:sourceMember>
			<fdl:targetMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="_STRUCT"/>
				</fdl:dataStructureMemberName>
			</fdl:targetMember>
		</fdl:map>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "initialize-human-task-input":
		
		Called by template "create-standard-activity".
		Creates a "Java snippet" that initializes the input variable of a human task
        in case that it is not set with data from an inbound data flow.
		*****************************************************************************************************
	-->
	<xsl:template name="initialize-human-task-input">
		<xsl:param name="variable-name"/>
		<bpel:invoke portType="bpc:null" partnerLink="null" operation="null" name="{generate-id()}" bpc:displayName="Initialize human task input">
			<bpc:script>
				<bpc:javaCode>
					<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
					<!-- Initialize business object -->
					<xsl:value-of select="concat($eol, 
					                                'if (',
													$variable-name, 
					                                ' == null) {',
					                                $eol,
					                                '    BOFactory boFactory = (BOFactory)ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
					                                $eol,
					                                '    ',
													$variable-name, 
					                                ' = boFactory.createByType(getVariableType(&quot;',
													$variable-name, 
													'&quot;));',
					                                $eol,
					                                '}',
													$eol)" disable-output-escaping="yes"/>
					<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
				</bpc:javaCode>
			</bpc:script>
		</bpel:invoke>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "create-data-mapping-human-task-to-standard":
		
		Called by template "create-standard-activity".
		Creates a "data mapping" ("assign" or "Java snippet") activity that merges the human task
        data output message to the "standard" data output of a "staff activity".
		*****************************************************************************************************
	-->
	<xsl:template name="create-data-mapping-human-task-to-standard">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:variable name="human-task-variable-name" select="concat($name-prefix, $activity/@name, $human-task-output-variable-suffix)"/>
		<xsl:variable name="human-task-message-type" select="$variables//bpel:variable[@name = $human-task-variable-name]/@messageType"/>
		<xsl:variable name="human-task-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $human-task-message-type]/wsdl:part"/>
		<xsl:variable name="human-task-message-part-name" select="$human-task-message-part/@name"/>
		<xsl:variable name="human-task-message-part-type" select="$human-task-message-part/@type"/>
		<xsl:variable name="human-task-message-part-type-local-name" select="substring-after($human-task-message-part-type, 'mqwf:')"/>
		<xsl:variable name="standard-variable-name" select="concat($name-prefix, $activity/@name, $output-variable-suffix)"/>
		<xsl:variable name="standard-message-type" select="$variables//bpel:variable[@name = $standard-variable-name]/@messageType"/>
		<xsl:variable name="standard-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $standard-message-type]/wsdl:part"/>
		<xsl:variable name="standard-message-part-name" select="$standard-message-part/@name"/>
		<xsl:variable name="standard-message-part-type" select="$standard-message-part/@type"/>
		<xsl:variable name="standard-message-part-type-local-name" select="substring-after($standard-message-part-type, 'mqwf:')"/>
		<!-- Create comment: Copy the human task output from variable "nnn" to variable "nnn" by merging any default values -->
		<xsl:value-of select="concat($eol, '&lt;!--  Copy the human task output  from variable &quot;', $human-task-variable-name, '&quot; to variable &quot;', $standard-variable-name, '&quot; by merging any default values --&gt;', $eol)" disable-output-escaping="yes"/>
		<xsl:variable name="human-task-to-standard-mappings">
			<xsl:call-template name="human-task-to-standard-mappings"/>
		</xsl:variable>
		<xsl:choose>
			<!-- CASE: create "Java snippet" activity -->
			<xsl:when test="'TRUE' = translate($create_Java_Snippets, $lower-case-characters, $upper-case-characters)">
				<bpel:invoke portType="bpc:null" partnerLink="null" operation="null" name="{generate-id()}" bpc:displayName="Merge human task output">
					<bpc:script>
						<bpc:javaCode>
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:apply-templates select="xalan:nodeset($human-task-to-standard-mappings)/fdl:map" mode="data">
								<xsl:with-param name="display-name" select="'Merge human task output'"/>
								<xsl:with-param name="from-variable-name" select="$human-task-variable-name"/>
								<xsl:with-param name="to-variable-name" select="$standard-variable-name"/>
								<xsl:with-param name="source-wsdl-message-part-type" select="$human-task-message-part-type"/>
								<xsl:with-param name="source-wsdl-message-part-name" select="$human-task-message-part-name"/>
								<xsl:with-param name="target-wsdl-message-part-type" select="$standard-message-part-type"/>
								<xsl:with-param name="target-wsdl-message-part-name" select="$standard-message-part-name"/>
							</xsl:apply-templates>
							<!-- Initialize business object -->
							<xsl:value-of select="concat($eol, 
					                                'if (',
													$standard-variable-name, 
					                                ' == null) {',
					                                $eol,
					                                '    BOFactory boFactory = (BOFactory)ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
					                                $eol,
					                                '    ',
													$standard-variable-name, 
					                                ' = boFactory.createByType(getVariableType(&quot;',
													$standard-variable-name, 
													'&quot;));',
					                                $eol,
					                                '}',
													$eol)" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:javaCode>
					</bpc:script>
				</bpel:invoke>
			</xsl:when>
			<!-- OTHERWISE: create "assign" activity -->
			<xsl:otherwise>
				<bpel:assign name="{generate-id()}" bpc:displayName="Merge human task output">
					<!-- Create data mappings -->
					<xsl:apply-templates select="xalan:nodeset($human-task-to-standard-mappings)/fdl:map" mode="data">
						<xsl:with-param name="display-name" select="'Merge human task output'"/>
						<xsl:with-param name="from-variable-name" select="$human-task-variable-name"/>
						<xsl:with-param name="to-variable-name" select="$standard-variable-name"/>
						<xsl:with-param name="source-wsdl-message-part-type" select="$human-task-message-part-type"/>
						<xsl:with-param name="source-wsdl-message-part-name" select="$human-task-message-part-name"/>
						<xsl:with-param name="target-wsdl-message-part-type" select="$standard-message-part-type"/>
						<xsl:with-param name="target-wsdl-message-part-name" select="$standard-message-part-name"/>
					</xsl:apply-templates>
				</bpel:assign>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "human-task-to-standard-mappings":
		
		Returns the "fdl:map" elements that are needed to create
		"human-task-to-standard-mapping" expressions
		*****************************************************************************************************
	-->
	<xsl:template name="human-task-to-standard-mappings">
		<fdl:map>
			<fdl:sourceMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="_STRUCT"/>
				</fdl:dataStructureMemberName>
			</fdl:sourceMember>
			<fdl:targetMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="_STRUCT"/>
				</fdl:dataStructureMemberName>
			</fdl:targetMember>
		</fdl:map>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "create-data-mapping-subprocess-to-standard":
		
		Called by template "create-activity".
		Creates a "data mapping" ("assign" or "Java snippet") activity that merges the subprocess
        data output message to the "standard" data output of a "process activity".
		*****************************************************************************************************
	-->
	<xsl:template name="create-data-mapping-subprocess-to-standard">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:variable name="subprocess-variable-name" select="concat($name-prefix, $activity/@name, $subprocess-output-variable-suffix)"/>
		<xsl:variable name="subprocess-message-type" select="$variables//bpel:variable[@name = $subprocess-variable-name]/@messageType"/>
		<xsl:variable name="subprocess-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $subprocess-message-type]/wsdl:part"/>
		<xsl:variable name="subprocess-message-part-name" select="$subprocess-message-part/@name"/>
		<xsl:variable name="subprocess-message-part-type" select="$subprocess-message-part/@type"/>
		<xsl:variable name="subprocess-message-part-type-local-name" select="substring-after($subprocess-message-part-type, 'mqwf:')"/>
		<xsl:variable name="standard-variable-name" select="concat($name-prefix, $activity/@name, $output-variable-suffix)"/>
		<xsl:variable name="standard-message-type" select="$variables//bpel:variable[@name = $standard-variable-name]/@messageType"/>
		<xsl:variable name="standard-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $standard-message-type]/wsdl:part"/>
		<xsl:variable name="standard-message-part-name" select="$standard-message-part/@name"/>
		<xsl:variable name="standard-message-part-type" select="$standard-message-part/@type"/>
		<xsl:variable name="standard-message-part-type-local-name" select="substring-after($standard-message-part-type, 'mqwf:')"/>
		<!-- Create comment: Copy the subprocess output from variable "nnn" to variable "nnn" by merging any default values -->
		<xsl:value-of select="concat($eol, '&lt;!--  Copy the subprocess output  from variable &quot;', $subprocess-variable-name, '&quot; to variable &quot;', $standard-variable-name, '&quot; by merging any default values --&gt;', $eol)" disable-output-escaping="yes"/>
		<xsl:variable name="subprocess-to-standard-mappings">
			<xsl:call-template name="subprocess-to-standard-mappings"/>
		</xsl:variable>
		<xsl:choose>
			<!-- CASE: create "Java snippet" activity -->
			<xsl:when test="'TRUE' = translate($create_Java_Snippets, $lower-case-characters, $upper-case-characters)">
				<bpel:invoke portType="bpc:null" partnerLink="null" operation="null" name="{generate-id()}" bpc:displayName="Merge subprocess output">
					<bpc:script>
						<bpc:javaCode>
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:apply-templates select="xalan:nodeset($subprocess-to-standard-mappings)/fdl:map" mode="data">
								<xsl:with-param name="display-name" select="'Merge subprocess output'"/>
								<xsl:with-param name="from-variable-name" select="$subprocess-variable-name"/>
								<xsl:with-param name="to-variable-name" select="$standard-variable-name"/>
								<xsl:with-param name="source-wsdl-message-part-type" select="$subprocess-message-part-type"/>
								<xsl:with-param name="source-wsdl-message-part-name" select="$subprocess-message-part-name"/>
								<xsl:with-param name="target-wsdl-message-part-type" select="$standard-message-part-type"/>
								<xsl:with-param name="target-wsdl-message-part-name" select="$standard-message-part-name"/>
							</xsl:apply-templates>
							<!-- Initialize business object -->
							<xsl:value-of select="concat($eol, 
					                                'if (',
													$standard-variable-name, 
					                                ' == null) {',
					                                $eol,
					                                '    BOFactory boFactory = (BOFactory)ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
					                                $eol,
					                                '    ',
													$standard-variable-name, 
					                                ' = boFactory.createByType(getVariableType(&quot;',
													$standard-variable-name, 
													'&quot;));',
					                                $eol,
					                                '}',
													$eol)" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:javaCode>
					</bpc:script>
				</bpel:invoke>
			</xsl:when>
			<!-- OTHERWISE: create "assign" activity -->
			<xsl:otherwise>
				<bpel:assign name="{generate-id()}" bpc:displayName="Merge human task output">
					<!-- Create data mappings -->
					<xsl:apply-templates select="xalan:nodeset($subprocess-to-standard-mappings)/fdl:map" mode="data">
						<xsl:with-param name="display-name" select="'Merge human task output'"/>
						<xsl:with-param name="from-variable-name" select="$subprocess-variable-name"/>
						<xsl:with-param name="to-variable-name" select="$standard-variable-name"/>
						<xsl:with-param name="source-wsdl-message-part-type" select="$subprocess-message-part-type"/>
						<xsl:with-param name="source-wsdl-message-part-name" select="$subprocess-message-part-name"/>
						<xsl:with-param name="target-wsdl-message-part-type" select="$standard-message-part-type"/>
						<xsl:with-param name="target-wsdl-message-part-name" select="$standard-message-part-name"/>
					</xsl:apply-templates>
				</bpel:assign>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************
		Template "subprocess-to-standard-mappings":
		
		Returns the "fdl:map" elements that are needed to create
		"subprocess-to-standard-mapping" expressions
		*****************************************************************************************************
	-->
	<xsl:template name="subprocess-to-standard-mappings">
		<fdl:map>
			<fdl:sourceMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="_STRUCT"/>
				</fdl:dataStructureMemberName>
			</fdl:sourceMember>
			<fdl:targetMember>
				<fdl:dataStructureMemberName>
					<fdl:nameComponent name="_STRUCT"/>
				</fdl:dataStructureMemberName>
			</fdl:targetMember>
		</fdl:map>
	</xsl:template>
	<!--
		*****************************************************************************************************
		"data" template matching "fdl:data":

		Creates a data mapping activity ("assign" or "Java snippet") for each "fdl:data" element 
        (data connector). Translates each "fdl:map"-element (data mapping) to a respective 
        "copy" element or Java statement.
		*****************************************************************************************************
	-->
	<xsl:template match="fdl:data" mode="data">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:variable name="parent-name">
			<xsl:choose>
				<!-- CASE: Parent is the current process -->
				<xsl:when test="local-name(..) = 'process'">
					<xsl:value-of select="../@name"/>
				</xsl:when>
				<!-- OTHERWISE: Parent is a block activity -->
				<xsl:otherwise>
					<xsl:value-of select="../../@name"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="from-variable-name">
			<xsl:choose>
				<!-- 	CASE: If the data connector is a default connector,  choose the name of the input variable of the activity specified in attribute "default" -->
				<xsl:when test="@default">
					<xsl:value-of select="concat($name-prefix, @default, $input-variable-suffix)"/>
				</xsl:when>
				<!-- CASE: 	If the data connector is a loop connector,  choose the name of the output variable of the activity specified in attribute "loop" -->
				<xsl:when test="@loop">
					<xsl:value-of select="concat($name-prefix, @loop, $output-variable-suffix)"/>
				</xsl:when>
				<!-- 	CASE: If the data connector source is "SOURCE", choose the name of the input variable of the current process or block 	-->
				<xsl:when test="../fdl:input/@name = @from">
					<xsl:value-of select="concat($parent-name-prefix, $parent-name, $input-variable-suffix)"/>
				</xsl:when>
				<!-- OTHERWISE: The data connector source should be the output variable of a local activity -->
				<xsl:otherwise>
					<xsl:value-of select="concat($name-prefix, @from, $output-variable-suffix)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="to-variable-name">
			<xsl:choose>
				<!-- CASE: If the data connector is a default connector,  choose the name of the output variable of the activity specified in attribute "default" -->
				<xsl:when test="@default">
					<xsl:value-of select="concat($name-prefix, @default, $output-variable-suffix)"/>
				</xsl:when>
				<!-- 	CASE: If the data connector is a loop connector,  choose the name of the input variable of the activity specified in attribute "loop" -->
				<xsl:when test="@loop">
					<xsl:value-of select="concat($name-prefix, @loop, $input-variable-suffix)"/>
				</xsl:when>
				<!-- 	CASE: If the data connector target is "SINK", choose the name of the output variable of the current process or block -->
				<xsl:when test="../fdl:output/@name = @to">
					<xsl:value-of select="concat($parent-name-prefix, $parent-name, $output-variable-suffix)"/>
				</xsl:when>
				<!-- 	CASE: If the data connector target is "GLOBAL_CONTAINER", choose the "GLOBAL_CONTAINER" variable -->
				<xsl:when test="@to = 'GLOBAL_CONTAINER'">
					<xsl:value-of select="'GLOBAL_CONTAINER'"/>
				</xsl:when>
				<!-- OTHERWISE: The data connector sink should be the input variable of a local activity -->
				<xsl:otherwise>
					<xsl:value-of select="concat($name-prefix, @to, $input-variable-suffix)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="from-variable-display-name">
			<xsl:choose>
				<!-- 	CASE: If the data connector is a default connector,  choose the name of the input variable of the activity specified in attribute "default" -->
				<xsl:when test="@default">
					<xsl:value-of select="concat(@default, $input-variable-suffix)"/>
				</xsl:when>
				<!-- CASE: 	If the data connector is a loop connector,  choose the name of the output variable of the activity specified in attribute "loop" -->
				<xsl:when test="@loop">
					<xsl:value-of select="concat(@loop, $output-variable-suffix)"/>
				</xsl:when>
				<!-- 	CASE: If the data connector source is "SOURCE", choose the name of the input variable of the current process or block 	-->
				<xsl:when test="../fdl:input/@name = @from">
					<xsl:value-of select="concat($parent-name, $input-variable-suffix)"/>
				</xsl:when>
				<!-- OTHERWISE: The data connector source should be the output variable of a local activity -->
				<xsl:otherwise>
					<xsl:value-of select="concat(@from, $output-variable-suffix)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="to-variable-display-name">
			<xsl:choose>
				<!-- CASE: If the data connector is a default connector,  choose the name of the output variable of the activity specified in attribute "default" -->
				<xsl:when test="@default">
					<xsl:value-of select="concat(@default, $output-variable-suffix)"/>
				</xsl:when>
				<!-- 	CASE: If the data connector is a loop connector,  choose the name of the input variable of the activity specified in attribute "loop" -->
				<xsl:when test="@loop">
					<xsl:value-of select="concat(@loop, $input-variable-suffix)"/>
				</xsl:when>
				<!-- 	CASE: If the data connector target is "SINK", choose the name of the output variable of the current process or block -->
				<xsl:when test="../fdl:output/@name = @to">
					<xsl:value-of select="concat($parent-name, $output-variable-suffix)"/>
				</xsl:when>
				<!-- 	CASE: If the data connector target is "GLOBAL_CONTAINER", choose the "GLOBAL_CONTAINER" variable -->
				<xsl:when test="@to = 'GLOBAL_CONTAINER'">
					<xsl:value-of select="'GLOBAL_CONTAINER'"/>
				</xsl:when>
				<!-- OTHERWISE: The data connector sink should be the input variable of a local activity -->
				<xsl:otherwise>
					<xsl:value-of select="concat(@to, $input-variable-suffix)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="from-message-type" select="$variables//bpel:variable[@name = $from-variable-name]/@messageType"/>
		<xsl:variable name="from-xsd-type" select="$variables//bpel:variable[@name = $from-variable-name]/@element"/>
		<xsl:variable name="to-message-type" select="$variables//bpel:variable[@name = $to-variable-name]/@messageType"/>
		<xsl:variable name="to-xsd-type" select="$variables//bpel:variable[@name = $to-variable-name]/@element"/>
		<xsl:choose>
			<xsl:when test="@default">
				<!-- Create comment: Default data flow from the input variable to the output variable of activity "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Default data flow from the input variable to the output variable of activity &quot;', @default, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:when>
			<xsl:when test="@loop">
				<!-- Create comment: Data flow loop from the output variable to the input variable of activity "nnn" -->
				<xsl:value-of select="concat($eol, '&lt;!-- Data flow loop from the output variable to the input variable of activity &quot;', @loop, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:when>
			<xsl:otherwise>
				<!-- Create comment: Data flow from "nnn" to "nnn"-->
				<xsl:value-of select="concat($eol, '&lt;!-- Data flow from &quot;', @from, '&quot; to &quot;', @to, '&quot; --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="fdl:map">
				<!-- Create a data mapping activity ("assign" or "Java snippet") -->
				<xsl:call-template name="create-data-mapping-activity">
					<xsl:with-param name="data" select="current()"/>
					<xsl:with-param name="from-variable-name" select="$from-variable-name"/>
					<xsl:with-param name="to-variable-name" select="$to-variable-name"/>
					<xsl:with-param name="from-variable-display-name" select="$from-variable-display-name"/>
					<xsl:with-param name="to-variable-display-name" select="$to-variable-display-name"/>
					<xsl:with-param name="from-message-type" select="$from-message-type"/>
					<xsl:with-param name="from-xsd-type" select="$from-xsd-type"/>
					<xsl:with-param name="to-message-type" select="$to-message-type"/>
					<xsl:with-param name="to-xsd-type" select="$to-xsd-type"/>
					<xsl:with-param name="description" select="fdl:description"/>
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<!-- Create comment: *** CWWBMnnnnW: No data mappings found for the data flow from ''nnn'' to ''nnn'' *** -->
				<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MissingDataMaps', $from-variable-display-name, $to-variable-display-name), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************
		"map" template matching "fdl:map":

		Creates a data mapping expression ("copy" element or "Java statement"
		*****************************************************************************************************
	-->
	<xsl:template match="fdl:map" mode="data">
		<xsl:param name="display-name"/>
		<xsl:param name="from-variable-name"/>
		<xsl:param name="to-variable-name"/>
		<xsl:param name="source-wsdl-message-part-type"/>
		<xsl:param name="source-wsdl-message-part-name"/>
		<xsl:param name="source-xsd-type"/>
		<xsl:param name="target-wsdl-message-part-type"/>
		<xsl:param name="target-wsdl-message-part-name"/>
		<xsl:param name="target-xsd-type"/>
		<xsl:variable name="source-dataStructureMemberName" select="fdl:sourceMember/fdl:dataStructureMemberName"/>
		<xsl:variable name="target-dataStructureMemberName" select="fdl:targetMember/fdl:dataStructureMemberName"/>
		<!-- Create data mappings as part of a "data mapping" ("assign" or "Java snippet") activity -->
		<xsl:variable name="source-first">
			<xsl:choose>
				<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
					<xsl:value-of select="1"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$source-dataStructureMemberName/fdl:nameComponent[1]/@name = '_STRUCT'">
							<xsl:value-of select="2"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="1"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="target-first">
			<xsl:choose>
				<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
					<xsl:value-of select="1"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$target-dataStructureMemberName/fdl:nameComponent[1]/@name = '_STRUCT'">
							<xsl:value-of select="2"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="1"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="source-xml-schema-type">
			<xsl:choose>
				<xsl:when test="$source-xsd-type">
					<xsl:value-of select="$source-xsd-type"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$source-wsdl-message-part-type"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="from-query-string">
			<xsl:call-template name="translate-dataStructureMemberName-to-XPath">
				<xsl:with-param name="display-name" select="$display-name"/>
				<xsl:with-param name="XMLSchemaType" select="$source-xml-schema-type"/>
				<xsl:with-param name="nameComponent" select="$source-dataStructureMemberName/fdl:nameComponent[ position() = $source-first ]"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="target-xml-schema-type">
			<xsl:choose>
				<xsl:when test="$target-xsd-type">
					<xsl:value-of select="$target-xsd-type"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$target-wsdl-message-part-type"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="to-query-string">
			<xsl:call-template name="translate-dataStructureMemberName-to-XPath">
				<xsl:with-param name="display-name" select="$display-name"/>
				<xsl:with-param name="XMLSchemaType" select="$target-xml-schema-type"/>
				<xsl:with-param name="nameComponent" select="$target-dataStructureMemberName/fdl:nameComponent[ position() = $target-first ]"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<!-- CASE: Create "Java statement" -->
			<xsl:when test="'TRUE' = translate($create_Java_Snippets, $lower-case-characters, $upper-case-characters)">
				<xsl:value-of select="concat($eol, 
													$to-variable-name, 
													' = WMQWFHelper.merge(', 
													$from-variable-name, 
													', &quot;',
													xalan:nodeset($from-query-string)/*, 
													'&quot;, ',
													$to-variable-name,
													', &quot;',
													xalan:nodeset($to-query-string)/*, 
													'&quot;, getVariableType(&quot;',
													$to-variable-name,
													'&quot;));'
													)" disable-output-escaping="yes"/>
			</xsl:when>
			<!-- OTHERWISE: Create "copy" element -->
			<xsl:otherwise>
				<bpel:copy>
					<bpel:from variable="{$from-variable-name}">
						<!-- Add "part" attribute, if the variable is not xsd-typed -->
						<xsl:if test="not($source-xsd-type)">
							<xsl:attribute name="part"><xsl:value-of select="$source-wsdl-message-part-name"/></xsl:attribute>
						</xsl:if>
						<bpel:query>
							<!-- FG added:  CDATA for query values -->
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:value-of select="xalan:nodeset($from-query-string)/*" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpel:query>
					</bpel:from>
					<bpel:to variable="{$to-variable-name}">
						<!-- Add "part" attribute, if the variable is not xsd-typed -->
						<xsl:if test="not($target-xsd-type)">
							<xsl:attribute name="part"><xsl:value-of select="$target-wsdl-message-part-name"/></xsl:attribute>
						</xsl:if>
						<bpel:query>
							<!-- FG added:  CDATA for query values -->
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:value-of select="xalan:nodeset($to-query-string)/*" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpel:query>
					</bpel:to>
				</bpel:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		********************************************************************
		"create-assign-activity-to-set-BPEL-variable" template
		********************************************************************
	-->
	<xsl:template name="create-assign-activity-to-set-BPEL-variable">
		<xsl:param name="BPEL-variable"/>
		<xsl:param name="BPEL-variable-value"/>
		<xsl:variable name="display-name">
			<xsl:call-template name="tailor-display-name">
				<xsl:with-param name="untailored-display-name" select="concat('Set ', $BPEL-variable, ' to ', $BPEL-variable-value)"/>
			</xsl:call-template>
		</xsl:variable>
		<bpel:assign bpc:displayName="{$display-name}" name="{generate-id()}">
			<bpel:copy>
				<bpel:from>
					<!-- DEPRECATED:	<bpc:literal type="xsd:string"> -->
					<xsl:value-of select="concat('&lt;![CDATA[', $BPEL-variable-value, ']]&gt;')" disable-output-escaping="yes"/>
					<!-- DEPRECATED:	</bpc:literal> -->
				</bpel:from>
				<bpel:to part="{$activity-status-part-name}" variable="{$BPEL-variable}"/>
			</bpel:copy>
		</bpel:assign>
	</xsl:template>
	<!--
		************************************************************************************************
		"create-data-mapping-activity" template
		************************************************************************************************
	-->
	<xsl:template name="create-data-mapping-activity">
		<xsl:param name="data"/>
		<xsl:param name="from-variable-name"/>
		<xsl:param name="to-variable-name"/>
		<xsl:param name="from-variable-display-name"/>
		<xsl:param name="to-variable-display-name"/>
		<xsl:param name="from-message-type"/>
		<xsl:param name="from-xsd-type"/>
		<xsl:param name="to-message-type"/>
		<xsl:param name="to-xsd-type"/>
		<xsl:param name="description"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:variable name="source-wsdl-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $from-message-type]/wsdl:part"/>
		<xsl:variable name="target-wsdl-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $to-message-type]/wsdl:part"/>
		<xsl:variable name="source-wsdl-message-part-type" select="$source-wsdl-message-part/@type"/>
		<xsl:variable name="target-wsdl-message-part-type" select="$target-wsdl-message-part/@type"/>
		<xsl:variable name="source-wsdl-message-part-name" select="$source-wsdl-message-part/@name"/>
		<xsl:variable name="target-wsdl-message-part-name" select="$target-wsdl-message-part/@name"/>
		<xsl:variable name="source-wsdl-message-part-type-local-name" select="substring-after($source-wsdl-message-part-type, 'mqwf:')"/>
		<xsl:variable name="target-wsdl-message-part-type-local-name" select="substring-after($target-wsdl-message-part-type, 'mqwf:')"/>
		<xsl:variable name="display-name">
			<xsl:call-template name="tailor-display-name">
				<xsl:with-param name="untailored-display-name" select="concat($from-variable-display-name, ' - ', $to-variable-display-name)"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<!-- CASE: create "Java snippet" activity -->
			<xsl:when test="'TRUE' = translate($create_Java_Snippets, $lower-case-characters, $upper-case-characters)">
				<bpel:invoke portType="bpc:null" partnerLink="null" operation="null" name="{generate-id()}" bpc:displayName="{$display-name}">
					<!-- Data connector description -->
					<xsl:if test="$description">
						<xsl:variable name="translated-description">
							<xsl:apply-templates select="$description" mode="copy-text-fields-with-context-variables">
								<xsl:with-param name="display-name" select="$display-name"/>
								<xsl:with-param name="node" select="$data"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="local-variable-name" select="$from-variable-name"/>
							</xsl:apply-templates>
						</xsl:variable>
						<xsl:variable name="tailored-description">
							<xsl:call-template name="tailor-description-or-documentation-text">
								<xsl:with-param name="untailored-text" select="$translated-description"/>
								<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
							</xsl:call-template>
						</xsl:variable>
						<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
							<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
							<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						</xsl:if>
						<bpc:description>
							<!-- FG added:  CDATA for query values -->
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:description>
					</xsl:if>
					<!--
							Create data mappings.
					-->
					<bpc:script>
						<bpc:javaCode>
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:apply-templates select="$data/fdl:map" mode="data">
								<xsl:with-param name="display-name" select="$display-name"/>
								<xsl:with-param name="from-variable-name" select="$from-variable-name"/>
								<xsl:with-param name="to-variable-name" select="$to-variable-name"/>
								<xsl:with-param name="source-wsdl-message-part-type" select="$source-wsdl-message-part-type"/>
								<xsl:with-param name="source-wsdl-message-part-name" select="$source-wsdl-message-part-name"/>
								<xsl:with-param name="source-xsd-type" select="$from-xsd-type"/>
								<xsl:with-param name="target-wsdl-message-part-type" select="$target-wsdl-message-part-type"/>
								<xsl:with-param name="target-wsdl-message-part-name" select="$target-wsdl-message-part-name"/>
								<xsl:with-param name="target-xsd-type" select="$to-xsd-type"/>
							</xsl:apply-templates>
							<!-- Initialize target business object -->
							<xsl:value-of select="concat($eol, 
															'if (',
															$to-variable-name, 
															' == null) {',
															$eol,
															'    BOFactory boFactory = (BOFactory) ServiceManager.INSTANCE.locateService(&quot;com/ibm/websphere/bo/BOFactory&quot;);',
															$eol,
															'    ',
															$to-variable-name, 
															' = boFactory.createByType(getVariableType(&quot;',
															$to-variable-name, 
															'&quot;));',
															$eol,
															'}',
															$eol)" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:javaCode>
					</bpc:script>
				</bpel:invoke>
			</xsl:when>
			<!-- OTHERWISE: create "assign" activity -->
			<xsl:otherwise>
				<bpel:assign bpc:displayName="{$display-name}" name="{generate-id()}">
					<!-- Data connector description -->
					<xsl:if test="$description">
						<xsl:variable name="translated-description">
							<xsl:apply-templates select="$description" mode="copy-text-fields-with-context-variables">
								<xsl:with-param name="display-name" select="$display-name"/>
								<xsl:with-param name="node" select="$data"/>
								<xsl:with-param name="variables" select="$variables"/>
								<xsl:with-param name="name-prefix" select="$name-prefix"/>
								<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
								<xsl:with-param name="local-variable-name" select="$from-variable-name"/>
							</xsl:apply-templates>
						</xsl:variable>
						<xsl:variable name="tailored-description">
							<xsl:call-template name="tailor-description-or-documentation-text">
								<xsl:with-param name="untailored-text" select="$translated-description"/>
								<xsl:with-param name="maximum-length" select="$maxDescriptionFieldLength"/>
							</xsl:call-template>
						</xsl:variable>
						<xsl:if test="string-length($translated-description) &gt; $maxDescriptionFieldLength">
							<!--COMMENT: *** CWWBMnnnnW: The following description or documentation text exceeds the maximum field length ..." *** -->
							<xsl:value-of select="concat($eol, '&lt;!-- *** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Warning, 'MaximumFieldLengthExceeded', $maxDescriptionFieldLength, $translated-description), ' *** --&gt;', $eol)" disable-output-escaping="yes"/>
						</xsl:if>
						<bpc:description>
							<!-- FG added:  CDATA for query values -->
							<xsl:value-of select="concat('&lt;','![CDATA[')" disable-output-escaping="yes"/>
							<xsl:value-of select="$tailored-description" disable-output-escaping="yes"/>
							<xsl:value-of select="concat(']]','&gt;')" disable-output-escaping="yes"/>
						</bpc:description>
					</xsl:if>
					<!--
							Create data mappings.
					-->
					<xsl:apply-templates select="$data/fdl:map" mode="data">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="from-variable-name" select="$from-variable-name"/>
						<xsl:with-param name="to-variable-name" select="$to-variable-name"/>
						<xsl:with-param name="source-wsdl-message-part-type" select="$source-wsdl-message-part-type"/>
						<xsl:with-param name="source-wsdl-message-part-name" select="$source-wsdl-message-part-name"/>
						<xsl:with-param name="source-xsd-type" select="$from-xsd-type"/>
						<xsl:with-param name="target-wsdl-message-part-type" select="$target-wsdl-message-part-type"/>
						<xsl:with-param name="target-wsdl-message-part-name" select="$target-wsdl-message-part-name"/>
						<xsl:with-param name="target-xsd-type" select="$to-xsd-type"/>
					</xsl:apply-templates>
				</bpel:assign>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		************************************************************************************************
		"create-condition-xpath-expression" template
		************************************************************************************************
	-->
	<xsl:template name="create-condition-xpath-expression">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:param name="condition"/>
		<xsl:param name="condition-applies-to-activity-exit"/>
		<xsl:variable name="local-variable-name" select="concat($name-prefix, $activity/@name, $output-variable-suffix)"/>
		<xsl:variable name="local-message-type" select="$variables//bpel:variable[@name = $local-variable-name]/@messageType"/>
		<xsl:variable name="local-xsd-type" select="$variables//bpel:variable[@name = $local-variable-name]/@element"/>
		<xsl:variable name="scope-set">
			<xsl:apply-templates select="$condition//fdl:dataStructureMemberName" mode="scope"/>
		</xsl:variable>
		<!--
				Translate boolean expression
			-->
		<xsl:variable name="xpath-condition">
			<xsl:apply-templates select="$condition/fdl:operator | $condition/fdl:unaryOperator" mode="condition">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				<xsl:with-param name="activity" select="$activity"/>
				<xsl:with-param name="local-message-type" select="$local-message-type"/>
				<xsl:with-param name="scope-set" select="xalan:nodeset($scope-set)"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="activity-status-variable-name" select="concat($name-prefix, $activity/@name, $status-variable-suffix)"/>
		<xsl:choose>
			<!-- CASE: exit condition -->
			<xsl:when test="$condition-applies-to-activity-exit">
				<xsl:value-of select="concat('not( ', $xpath-condition, ' ) or not( ', 'bpel:getVariableData(&quot;',  $activity-status-variable-name, '&quot;, &quot;', $activity-status-part-name, '&quot;) = &quot;', $activity-started-indicator, '&quot; )' )"/>
			</xsl:when>
			<!-- OTHERWISE: transition condition -->
			<xsl:otherwise>
				<xsl:value-of select="$xpath-condition"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		************************************************************************************************
		"condition" template:
		
		"fdl:operator" found
		************************************************************************************************
	-->
	<xsl:template match="fdl:operator" mode="condition">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:param name="local-message-type"/>
		<xsl:param name="scope-set"/>
		<!-- Create "xpath" code -->
		<!--
				Translate operator
		-->
		<xsl:variable name="xpath-operator">
			<xsl:choose>
				<xsl:when test="@type = 'and'">
					<xsl:value-of select="'and'"/>
				</xsl:when>
				<xsl:when test="@type = 'or'">
					<xsl:value-of select="'or'"/>
				</xsl:when>
				<xsl:when test="@type = 'equal'">
					<xsl:value-of select="'='"/>
				</xsl:when>
				<xsl:when test="@type = 'notEqual'">
					<xsl:value-of select="'!='"/>
				</xsl:when>
				<xsl:when test="@type = 'greater'">
					<xsl:value-of select="'&gt;'"/>
				</xsl:when>
				<xsl:when test="@type = 'greaterEqual'">
					<xsl:value-of select="'&gt;='"/>
				</xsl:when>
				<xsl:when test="@type = 'smaller'">
					<xsl:value-of select="'&lt;'"/>
				</xsl:when>
				<xsl:when test="@type = 'smallerEqual'">
					<xsl:value-of select="'&lt;='"/>
				</xsl:when>
				<xsl:when test="@type = 'plus'">
					<xsl:value-of select="'+'"/>
				</xsl:when>
				<xsl:when test="@type = 'minus'">
					<xsl:value-of select="'-'"/>
				</xsl:when>
				<xsl:when test="@type = 'mult'">
					<xsl:value-of select="'*'"/>
				</xsl:when>
				<xsl:when test="@type = 'div'">
					<xsl:value-of select="'div'"/>
				</xsl:when>
				<xsl:when test="@type = 'mod'">
					<xsl:value-of select="'mod'"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'&quot;unknown operator&quot;'"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!--
				Translate left operand
		-->
		<xsl:variable name="left-xpath-operand">
			<xsl:apply-templates select="*[1]" mode="condition">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				<xsl:with-param name="activity" select="$activity"/>
				<xsl:with-param name="local-message-type" select="$local-message-type"/>
				<xsl:with-param name="scope-set" select="$scope-set"/>
			</xsl:apply-templates>
		</xsl:variable>
		<!--
				Translate right operand
		-->
		<xsl:variable name="right-xpath-operand">
			<xsl:apply-templates select="*[2]" mode="condition">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				<xsl:with-param name="activity" select="$activity"/>
				<xsl:with-param name="local-message-type" select="$local-message-type"/>
				<xsl:with-param name="scope-set" select="$scope-set"/>
			</xsl:apply-templates>
		</xsl:variable>
		<!--
				Convert result tree fragments to node-sets
		-->
		<xsl:variable name="left-xpath-operand1" select="xalan:nodeset($left-xpath-operand)/*"/>
		<xsl:variable name="right-xpath-operand1" select="xalan:nodeset($right-xpath-operand)/*"/>
		<!--
				Assemble XPath expression
		-->
		<xsl:variable name="xpath-expression">
			<xsl:choose>
				<xsl:when test="$right-xpath-operand1/@isNull = 'true'">
					<xsl:choose>
						<xsl:when test="@type = 'equal'">
							<xsl:value-of select="concat('not( ', $left-xpath-operand1, ' )')"/>
						</xsl:when>
						<xsl:when test="@type = 'notEqual'">
							<xsl:value-of select="$left-xpath-operand1"/>
						</xsl:when>
						<xsl:otherwise>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat('( ', $left-xpath-operand1, ' ', $xpath-operator, ' ', $right-xpath-operand1, ' )')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<!--
				Return XPath expression to caller
		-->
		<xsl:choose>
			<xsl:when test="@type = 'plus' or @type = 'minus' or @type = 'mult' or @type = 'div' or @type = 'mod'">
				<operator type="numerical">
					<xsl:value-of select="$xpath-expression"/>
				</operator>
			</xsl:when>
			<xsl:otherwise>
				<operator type="boolean">
					<xsl:value-of select="$xpath-expression"/>
				</operator>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		************************************************************************************************
		"condition" template:
		
		"fdl:unaryOperator" found
		************************************************************************************************
	-->
	<xsl:template match="fdl:unaryOperator" mode="condition">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:param name="local-message-type"/>
		<xsl:param name="scope-set"/>
		<!-- Create "xpath" code -->
		<!--
				Translate operand
		-->
		<xsl:variable name="xpath-operand">
			<xsl:apply-templates select="*[1]" mode="condition">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				<xsl:with-param name="activity" select="$activity"/>
				<xsl:with-param name="local-message-type" select="$local-message-type"/>
				<xsl:with-param name="scope-set" select="$scope-set"/>
			</xsl:apply-templates>
		</xsl:variable>
		<!--
				Convert result tree fragments to node-sets
		-->
		<xsl:variable name="xpath-operand1" select="xalan:nodeset($xpath-operand)/*"/>
		<!--
				Return XPath expession to caller
		-->
		<xsl:choose>
			<xsl:when test="@type = 'minus'">
				<unaryOperator type="numerical">
					<xsl:value-of select="concat('-', $xpath-operand1)"/>
				</unaryOperator>
			</xsl:when>
			<xsl:when test="@type = 'not'">
				<unaryOperator type="boolean">
					<xsl:value-of select="concat('not( ', $xpath-operand1, ' )')"/>
				</unaryOperator>
			</xsl:when>
			<xsl:otherwise>
				<unaryOperator type="boolean">
					<xsl:value-of select="concat('&quot;unknown operator&quot;', $xpath-operand1)"/>
				</unaryOperator>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		************************************************************************************************
		"condition" template:
		
		"fdl:function" found
		************************************************************************************************
	-->
	<xsl:template match="fdl:function" mode="condition">
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:param name="local-message-type"/>
		<xsl:param name="scope-set"/>
		<!-- Create "xpath" code -->
		<!--
				Translate operator
		-->
		<!--
				Translate function arguments
		-->
		<xsl:variable name="first-argument">
			<xsl:apply-templates select="*[1]" mode="condition">
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				<xsl:with-param name="activity" select="$activity"/>
				<xsl:with-param name="local-message-type" select="$local-message-type"/>
				<xsl:with-param name="scope-set" select="$scope-set"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="first-argument1" select="xalan:nodeset($first-argument)/*"/>
		<xsl:variable name="second-argument">
			<xsl:if test="*[2]">
				<xsl:apply-templates select="*[2]" mode="condition">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="local-message-type" select="$local-message-type"/>
					<xsl:with-param name="scope-set" select="$scope-set"/>
				</xsl:apply-templates>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="second-argument1" select="xalan:nodeset($second-argument)/*"/>
		<xsl:variable name="third-argument">
			<xsl:if test="*[3]">
				<xsl:apply-templates select="*[3]" mode="condition">
					<xsl:with-param name="variables" select="$variables"/>
					<xsl:with-param name="name-prefix" select="$name-prefix"/>
					<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="local-message-type" select="$local-message-type"/>
					<xsl:with-param name="scope-set" select="$scope-set"/>
				</xsl:apply-templates>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="third-argument1" select="xalan:nodeset($third-argument)/*"/>
		<!--
				Assemble and return XPath expession to caller
		-->
		<xsl:choose>
			<xsl:when test="@type = 'lower'">
				<function type="string">
					<xsl:value-of select="concat('translate(', $first-argument1, ', &quot;',  $upper-case-characters,  '&quot;, &quot;',  $lower-case-characters,  '&quot;)')"/>
				</function>
			</xsl:when>
			<xsl:when test="@type = 'upper'">
				<function type="string">
					<xsl:value-of select="concat('translate(', $first-argument1, ', &quot;',  $lower-case-characters,  '&quot;, &quot;',  $upper-case-characters,  '&quot;)')"/>
				</function>
			</xsl:when>
			<xsl:when test="@type = 'substr'">
				<function type="string">
					<xsl:choose>
						<xsl:when test="$third-argument1">
							<xsl:value-of select="concat('substring(', $first-argument1, ', ',  $second-argument1,  ', ',  $second-argument1,  ' + ', $third-argument1, ')')"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="concat('substring(', $first-argument1, ', ',  $second-argument1, ')')"/>
						</xsl:otherwise>
					</xsl:choose>
				</function>
			</xsl:when>
			<xsl:when test="@type = 'value'">
				<function type="numeric">
					<xsl:value-of select="concat('number(', $first-argument1, ')')"/>
				</function>
			</xsl:when>
			<xsl:when test="'TRUE' = translate($enable_LI932_ActivityExpiration, $lower-case-characters, $upper-case-characters) and @type = '_State'">
				<xsl:variable name="activity-status-variable-name" select="concat($name-prefix, $activity/@name, $status-variable-suffix)"/>
				<function type="string">
					<xsl:value-of select="concat('bpel:getVariableData(&quot;',  $activity-status-variable-name, '&quot;, &quot;', $activity-status-part-name, '&quot;)')"/>
				</function>
			</xsl:when>
			<xsl:otherwise>
				<function type="string">
					<xsl:value-of select="concat('&quot;***unknown function***&quot;', '(', $first-argument1, ')')"/>
				</function>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		************************************************************************************************
		"condition" template:
		
		"fdl:dataStructureMemberName" found
		************************************************************************************************
	-->
	<xsl:template match="fdl:dataStructureMemberName" mode="condition">
		<xsl:param name="display-name"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix"/>
		<xsl:param name="parent-name-prefix"/>
		<xsl:param name="activity"/>
		<xsl:param name="local-message-type"/>
		<xsl:param name="scope-set"/>
		<xsl:variable name="message-type">
			<xsl:choose>
				<xsl:when test="@scope">
					<xsl:choose>
						<xsl:when test="@scope = '_BLOCK'">
							<xsl:variable name="scope-activity-name">
								<xsl:choose>
									<!-- CASE: Parent is a "block" -->
									<xsl:when test="local-name($activity/..) = 'blockImplementation'">
										<xsl:value-of select="$activity/../../@name"/>
									</xsl:when>
									<!-- OTHERWISE: Assume that parent is a "process" -->
									<xsl:otherwise>
										<xsl:value-of select="$activity/../@name"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:variable>
							<xsl:variable name="from-variable-name" select="concat($parent-name-prefix, $scope-activity-name, $input-variable-suffix)"/>
							<xsl:value-of select="$variables//bpel:variable[@name = $from-variable-name]/@messageType"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:variable name="scope-activity-name" select="$activity/../*[ ( local-name() = 'programActivity' or  local-name() = 'processActivity' or  local-name() =  'block' ) and current()/@scope = @name ][1]/@name"/>
							<xsl:variable name="from-variable-name" select="concat($name-prefix, $scope-activity-name, $output-variable-suffix)"/>
							<xsl:value-of select="$variables//bpel:variable[@name = $from-variable-name]/@messageType"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$local-message-type"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="variable-name">
			<xsl:choose>
				<xsl:when test="@scope">
					<xsl:choose>
						<xsl:when test="@scope = '_BLOCK'">
							<xsl:variable name="scope-activity-name">
								<xsl:choose>
									<!-- CASE: Parent is a "block" -->
									<xsl:when test="local-name($activity/..) = 'blockImplementation'">
										<xsl:value-of select="$activity/../../@name"/>
									</xsl:when>
									<!-- OTHERWISE: Assume that parent is a "process" -->
									<xsl:otherwise>
										<xsl:value-of select="$activity/../@name"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:variable>
							<xsl:value-of select="concat($parent-name-prefix, $scope-activity-name, $input-variable-suffix)"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:variable name="scope-activity-name" select="$activity/../*[ ( local-name() = 'programActivity' or local-name() = 'processActivity' or local-name() = 'block' ) and current()/@scope = @name ][1]/@name"/>
							<xsl:value-of select="concat($name-prefix, $scope-activity-name, $output-variable-suffix)"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat($name-prefix, $activity/@name, $output-variable-suffix)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="wsdl-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $message-type]/wsdl:part"/>
		<xsl:variable name="wsdl-message-part-type" select="$wsdl-message-part/@type"/>
		<!-- Get the first name component element of the "dotted" data structure name -->
		<xsl:variable name="first">
			<xsl:choose>
				<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
					<xsl:value-of select="1"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="fdl:nameComponent[ position() = 1 and @name = '_STRUCT' ]">
							<xsl:value-of select="2"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="1"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="nameComponent" select="fdl:nameComponent[ position() = $first ]"/>
		<xsl:choose>
			<xsl:when test="$nameComponent">
				<xsl:variable name="translated-dataStructureMemberName">
					<!-- Create "xpath" code -->
					<xsl:call-template name="translate-dataStructureMemberName-to-XPath">
						<xsl:with-param name="display-name" select="$display-name"/>
						<xsl:with-param name="XMLSchemaType" select="$wsdl-message-part-type"/>
						<xsl:with-param name="nameComponent" select="$nameComponent"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="dataStructureMemberType" select="xalan:nodeset($translated-dataStructureMemberName)/bpel:dataStructureMemberName/@type"/>
				<dataStructureMemberName type="{$dataStructureMemberType}">
					<xsl:copy-of select="concat('bpel:getVariableData(&quot;', $variable-name, '&quot;, &quot;', $message-part-name, '&quot;, &quot;', $translated-dataStructureMemberName, '&quot;)')"/>
				</dataStructureMemberName>
			</xsl:when>
			<xsl:otherwise>
				<dataStructureMemberName type="unknown">
					<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'UnknownDataStructureMemberName'), ' ***')"/>
				</dataStructureMemberName>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		************************************************************************************************
		"condition" template:
		
		"fdl:literal" found
		************************************************************************************************
	-->
	<xsl:template match="fdl:literal" mode="condition">
		<xsl:choose>
			<xsl:when test="@isNull = 'true'">
				<literal isNull="{@isNull}"/>
			</xsl:when>
			<xsl:otherwise>
				<literal type="{@type}">
					<xsl:choose>
						<xsl:when test="@type = 'string'">
							<xsl:value-of select="concat('&quot;', @value, '&quot;')" disable-output-escaping="yes"/>
						</xsl:when>
						<!-- *** Don't really know what to do with base64Binary *** -->
						<xsl:when test="@type = 'binary'">
							<xsl:value-of select="@value" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="@value" disable-output-escaping="yes"/>
						</xsl:otherwise>
					</xsl:choose>
				</literal>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		************************************************************************************************
		"condition" template:
		
		"fdl:state" found
		************************************************************************************************
	-->
	<xsl:template match="fdl:state" mode="condition">
		<state>
			<xsl:choose>
				<xsl:when test="@name ='_Finished' or @name ='_ForceFinished'">
					<xsl:value-of select="'ActivityInstanceRWData.STATE_FINISHED'" disable-output-escaping="yes"/>
				</xsl:when>
				<xsl:when test="@name ='_Skipped'">
					<xsl:value-of select="'ActivityInstanceRWData.STATE_SKIPPED'" disable-output-escaping="yes"/>
				</xsl:when>
				<xsl:when test="@name ='_Expired'">
					<xsl:choose>
						<xsl:when test="'TRUE' = translate($enable_LI932_ActivityExpiration, $lower-case-characters, $upper-case-characters)">
							<xsl:value-of select="'&quot;expired&quot;'" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'UnsupportedActivityState', @name), ' ***')"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'UnsupportedActivityState', @name), ' ***')"/>
				</xsl:otherwise>
			</xsl:choose>
		</state>
	</xsl:template>
	<!--
		***************************************************************************************************************************************************
		"translate-dataStructureMemberName-to-XPath" template
		
		Translates "fdl:dataStructureMemberName" to XPath location path.
		
		Parameter "current-location-path":	XPath location path expression recursively extended during each call of the template
													(see explanation of example below)
		Parameter "XMLSchemaType":			XMLSchema type of current class member
		Parameter "nameComponent"			The current name component while recursively stepping through the dotted member name.		
		
		Example:
		Assume a "dotted" FDL data structure member name:  'B1.C1[3].D1'
		Then the generated XPath location path will look like the following: '/B1/C1[4]/D1'
		(Note that an xpath array begins with 1, other than FDL arrays!)
		***************************************************************************************************************************************************
	-->
	<xsl:template name="translate-dataStructureMemberName-to-XPath">
		<xsl:param name="display-name"/>
		<xsl:param name="current-location-path" select="''"/>
		<xsl:param name="XMLSchemaType"/>
		<xsl:param name="nameComponent"/>
		<xsl:variable name="XMLSchemaTypeDef" select="document($xsdfile)//xsd:complexType[concat('mqwf:', @name) = $XMLSchemaType]"/>
		<xsl:variable name="element-name" select="$nameComponent/@name"/>
		<xsl:variable name="XMLSchemaTypeDef-Element" select="$XMLSchemaTypeDef/xsd:sequence/xsd:element[ @name = $element-name ]"/>
		<xsl:choose>
			<!-- CASE: $nameComponent not empty -->
			<xsl:when test="$nameComponent">
				<xsl:variable name="element-index" select="$nameComponent/@index+1"/>
				<xsl:variable name="index-expression">
					<xsl:if test="$element-index">
						<xsl:value-of select="concat('[', $element-index, ']')"/>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="location-step">
					<xsl:choose>
						<xsl:when test="$XMLSchemaTypeDef-Element">
							<xsl:value-of select="concat('/', $XMLSchemaTypeDef-Element/@name, $index-expression)"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="concat('*** ', java:com.ibm.bpe.fdl2bpel.converter.CEnv.write($Error, 'IllegalDataPath', $element-name, $display-name), ' ***')"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="next-location-path" select="concat($current-location-path, $location-step)"/>
				<xsl:choose>
					<xsl:when test="substring($XMLSchemaTypeDef-Element/@type, 1,4) = 'mqwf'">
						<xsl:variable name="element-type" select="substring-after($XMLSchemaTypeDef-Element/@type, 'mqwf:')"/>
						<xsl:variable name="following-nameComponent" select="$nameComponent/following-sibling::fdl:nameComponent[1]"/>
						<xsl:choose>
							<xsl:when test="$following-nameComponent">
								<xsl:variable name="translated-xpath-dataStructureMemberName">
									<xsl:call-template name="translate-dataStructureMemberName-to-XPath">
										<xsl:with-param name="display-name" select="$display-name"/>
										<xsl:with-param name="current-location-path" select="$next-location-path"/>
										<xsl:with-param name="XMLSchemaType" select="concat('mqwf:', $element-type)"/>
										<xsl:with-param name="nameComponent" select="$following-nameComponent"/>
									</xsl:call-template>
								</xsl:variable>
								<!-- Return translated "dataStructureMemberName" to caller -->
								<xsl:copy-of select="xalan:nodeset($translated-xpath-dataStructureMemberName)/*"/>
							</xsl:when>
							<xsl:otherwise>
								<!-- Return translated "dataStructureMemberName" to caller -->
								<dataStructureMemberName type="{$element-type}">
									<xsl:value-of select="$next-location-path"/>
								</dataStructureMemberName>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<!-- Return translated "dataStructureMemberName" to caller -->
						<xsl:variable name="element-type" select="substring-after($XMLSchemaTypeDef-Element/@type, 'xsd:')"/>
						<dataStructureMemberName type="{$element-type}">
							<xsl:value-of select="$next-location-path"/>
						</dataStructureMemberName>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- OTHERWISE: $nameComponent empty -->
			<xsl:otherwise>
				<!-- Determine element type -->
				<xsl:variable name="element-type">
					<xsl:choose>
						<xsl:when test="substring($XMLSchemaTypeDef-Element/@type, 1,4) = 'mqwf'">
							<xsl:value-of select="substring-after($XMLSchemaTypeDef-Element/@type, 'mqwf:')"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="substring-after($XMLSchemaTypeDef-Element/@type, 'xsd:')"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<!-- Return translated "dataStructureMemberName" to caller -->
				<dataStructureMemberName type="{$element-type}">
					<xsl:value-of select="'/'"/>
				</dataStructureMemberName>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		***************************************************************************************************************************************************
		"copy-text-fields-with-context-variables" template:
		
		Copies the content of the description fields of an FDL activity, data or control connector to the output.
		Translates contained "context variables".
		***************************************************************************************************************************************************
	 -->
	<!--
	 	Initial template for the text copy operation
	 -->
	<xsl:template match="fdl:description | fdl:documentation" mode="copy-text-fields-with-context-variables">
		<xsl:param name="display-name"/>
		<xsl:param name="node"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="local-variable-name"/>
		<xsl:apply-templates mode="copy-text-fields-with-context-variables">
			<xsl:with-param name="display-name" select="$display-name"/>
			<xsl:with-param name="node" select="$node"/>
			<xsl:with-param name="variables" select="$variables"/>
			<xsl:with-param name="name-prefix" select="$name-prefix"/>
			<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
			<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
		</xsl:apply-templates>
	</xsl:template>
	<!--
		This template copies any node to the output except for those that require "context variable" translation before.
		 The template that matches a "context variable" follows below and executes with higher priority.
 	-->
	<xsl:template match="node()" mode="copy-text-fields-with-context-variables">
		<xsl:param name="display-name"/>
		<xsl:param name="node"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="local-variable-name"/>
		<xsl:copy>
			<xsl:apply-templates mode="copy-text-fields-with-context-variables">
				<xsl:with-param name="display-name" select="$display-name"/>
				<xsl:with-param name="node" select="$node"/>
				<xsl:with-param name="variables" select="$variables"/>
				<xsl:with-param name="name-prefix" select="$name-prefix"/>
				<xsl:with-param name="parent-name-prefix" select="$parent-name-prefix"/>
				<xsl:with-param name="local-variable-name" select="$local-variable-name"/>
			</xsl:apply-templates>
		</xsl:copy>
	</xsl:template>
	<!--
	 	Template that matches a "context variable" (represented by "fdl:dataStructureMemberName")
	 -->
	<xsl:template match="fdl:dataStructureMemberName" mode="copy-text-fields-with-context-variables">
		<xsl:param name="display-name"/>
		<xsl:param name="node"/>
		<xsl:param name="variables"/>
		<xsl:param name="name-prefix" select="''"/>
		<xsl:param name="parent-name-prefix" select="''"/>
		<xsl:param name="local-variable-name"/>
		<xsl:variable name="local-message-type" select="$variables//bpel:variable[@name = $local-variable-name]/@messageType"/>
		<xsl:variable name="message-type">
			<xsl:choose>
				<xsl:when test="@scope">
					<xsl:choose>
						<xsl:when test="@scope = '_BLOCK'">
							<xsl:variable name="scope-activity-name">
								<xsl:choose>
									<!-- CASE: Parent is a "block" -->
									<xsl:when test="local-name($node/..) = 'blockImplementation'">
										<xsl:value-of select="$node/../../@name"/>
									</xsl:when>
									<!-- OTHERWISE: Assume that parent is a "process" -->
									<xsl:otherwise>
										<xsl:value-of select="$node/../@name"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:variable>
							<xsl:variable name="from-variable-name" select="concat($parent-name-prefix, $scope-activity-name, $input-variable-suffix)"/>
							<xsl:value-of select="$variables//bpel:variable[@name = $from-variable-name]/@messageType"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:variable name="scope-activity-name" select="$node/../*[ ( local-name() = 'programActivity' or local-name() = 'processActivity' or local-name() = 'block' ) and current()/@scope = @name ][1]/@name"/>
							<xsl:variable name="from-variable-name" select="concat($name-prefix, $scope-activity-name, $output-variable-suffix)"/>
							<xsl:value-of select="$variables//bpel:variable[@name = $from-variable-name]/@messageType"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$local-message-type"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="variable-name">
			<xsl:choose>
				<xsl:when test="@scope">
					<xsl:choose>
						<xsl:when test="@scope = '_BLOCK'">
							<xsl:variable name="scope-activity-name">
								<xsl:choose>
									<!-- CASE: Parent is a "block" -->
									<xsl:when test="local-name($node/..) = 'blockImplementation'">
										<xsl:value-of select="$node/../../@name"/>
									</xsl:when>
									<!-- OTHERWISE: Assume that parent is a "process" -->
									<xsl:otherwise>
										<xsl:value-of select="$node/../@name"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:variable>
							<xsl:value-of select="concat($parent-name-prefix, $scope-activity-name, $input-variable-suffix)"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:variable name="scope-activity-name" select="$node/../*[ ( local-name() = 'programActivity' or local-name() = 'processActivity' or local-name() = 'block' ) and current()/@scope = @name ][1]/@name"/>
							<xsl:value-of select="concat($name-prefix, $scope-activity-name, $output-variable-suffix)"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$local-variable-name"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="wsdl-message-part" select="document($wsdlfile)//wsdl:message[concat('wsdl1:', @name) = $message-type]/wsdl:part"/>
		<xsl:variable name="wsdl-message-part-name" select="$wsdl-message-part/@name"/>
		<xsl:variable name="wsdl-message-part-type" select="$wsdl-message-part/@type"/>
		<xsl:variable name="first">
			<xsl:choose>
				<xsl:when test="'TRUE' = translate($createPredefinedDataMembers, $lower-case-characters, $upper-case-characters)">
					<xsl:value-of select="1"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="current()/fdl:nameComponent[1]/@name = '_STRUCT'">
							<xsl:value-of select="2"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="1"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="translated-dataStructureMemberName">
			<xsl:call-template name="translate-dataStructureMemberName-to-XPath">
				<xsl:with-param name="display-name" select="$display-name"/>
				<xsl:with-param name="XMLSchemaType" select="$wsdl-message-part-type"/>
				<xsl:with-param name="nameComponent" select="fdl:nameComponent[$first]"/>
			</xsl:call-template>
		</xsl:variable>
		<!-- Ensure that the XPath expression has no leading forward slash (not allowed in context variables) -->
		<xsl:variable name="translated-dataStructureMemberName_without_leading_forward_slash">
			<xsl:choose>
				<xsl:when test="substring(xalan:nodeset($translated-dataStructureMemberName)/*, 1, 1) = '/'">
					<xsl:value-of select="substring-after(xalan:nodeset($translated-dataStructureMemberName)/*, '/')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="xalan:nodeset($translated-dataStructureMemberName)/*"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:value-of select="concat('%', $variable-name, '\', $message-part-name, '\', $translated-dataStructureMemberName_without_leading_forward_slash, '%')"/>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
 		"tailor-display-name" template:
 		
		Tailors the display-name to a predefined maximum length:
		When the "untailored diplay name" does not exceed the limitation then the unchanged name is returned,
		otherwise the name is cut-off and appended by dot characters "..."
		*****************************************************************************************************************************
	-->
	<xsl:template name="tailor-display-name">
		<xsl:param name="untailored-display-name"/>
		<xsl:choose>
			<xsl:when test="string-length($untailored-display-name) &gt; $maxDisplayNameLength">
				<xsl:value-of select="concat(substring($untailored-display-name, 1, $maxDisplayNameLength - 3), '...')"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$untailored-display-name"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
 		"tailor-description-or-documentation-text" template:
 		
		Tailors the text of a description or documentation to a predefined maximum length:
		When the "untailored text" does not exceed the limitation then the unchanged text is returned,
		otherwise the text is cut-off and appended by dot characters "...".
		Moreover, a warning is issued.
		*****************************************************************************************************************************
	-->
	<xsl:template name="tailor-description-or-documentation-text">
		<xsl:param name="untailored-text"/>
		<xsl:param name="maximum-length"/>
		<xsl:choose>
			<xsl:when test="string-length($untailored-text) &gt; $maximum-length">
				<xsl:value-of select="concat(substring($untailored-text, 1, $maximum-length - 3), '...')"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$untailored-text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
 		"formatAsByteArray" template:
 		
		Formats a base64Binary value as a Byte array.
		Example: "6162630d0a" becomes "0x61, 0x62, 0x63, 0x0d, 0x0a"
		If the binary value has an unequal number of characters then add a "0" prefix
		before formatting (normalized binary value).
		Note that the binary value as well as the formatted Byte array are passed as string objects.
		*****************************************************************************************************************************
	-->
	<xsl:template name="formatAsByteArray">
		<xsl:param name="binary-value"/>
		<xsl:variable name="normalized-binary-value">
			<xsl:choose>
				<!-- CASE: binary value has an unequal number of digits -->
				<xsl:when test="string-length($binary-value) mod 2 = 1">
					<!-- add "0" prefix -->
					<xsl:value-of select="concat('0', $binary-value)"/>
				</xsl:when>
				<!-- OTHERWISE: binary value has an equal number of digits -->
				<xsl:otherwise>
					<!-- binary value is already normalized -->
					<xsl:value-of select="$binary-value"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="formattedByteArray">
			<xsl:call-template name="do-tailor-display-name">
				<xsl:with-param name="remainingBinaryDigits" select="$normalized-binary-value"/>
			</xsl:call-template>
		</xsl:variable>
		<!-- Return translated "dataStructureMemberName" to caller -->
		<xsl:value-of select="$formattedByteArray"/>
	</xsl:template>
	<xsl:template name="do-tailor-display-name">
		<xsl:param name="remainingBinaryDigits"/>
		<xsl:choose>
			<!-- CASE: more than one pair of digits remaining -->
			<xsl:when test="string-length($remainingBinaryDigits) &gt; 2">
				<!-- Return leading digit pair as byte expression -->
				<xsl:variable name="byte-expression" select="concat('0x', substring($remainingBinaryDigits, 1, 2))"/>
				<!-- Do the formatting for the remaining digits -->
				<xsl:variable name="remaining-byte-expressions">
					<xsl:call-template name="do-tailor-display-name">
						<xsl:with-param name="remainingBinaryDigits" select="substring($remainingBinaryDigits, 3)"/>
					</xsl:call-template>
				</xsl:variable>
				<!-- Return the byte expressions as a comma separated list -->
				<xsl:value-of select="concat($byte-expression, ', ', $remaining-byte-expressions)"/>
			</xsl:when>
			<xsl:otherwise>
				<!-- OTHERWISE: Return last byte expression to caller -->
				<xsl:value-of select="concat('0x', $remainingBinaryDigits)"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "UPES-execution-mode":

		Determines the execution mode of an "UPES" program activity.
		Selects from types "synchronous", "asynchronous"
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_WSDL.XSL"!)
		****************************************************************************************************************
	 -->
	<xsl:template name="UPES-execution-mode">
		<xsl:param name="activity"/>
		<xsl:choose>
			<!--
				CASE: "synchronous invocation"
			-->
			<xsl:when test="$activity/fdl:program/@synchronization = 'nested'">
				<xsl:value-of select="'synchronous'"/>
			</xsl:when>
			<!--
				CASE: "asynchronous invocation"
			-->
			<xsl:when test="$activity/fdl:program/@synchronization = 'chained'">
				<xsl:value-of select="'asynchronous'"/>
			</xsl:when>
			<!--
				OTHERWISE: "*** not defined ***"
			-->
			<xsl:otherwise>
				<xsl:value-of select="'*** not defined ***'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		*****************************************************************************************************************************
		"activity-name-prefix" template:
		
		Determines name prefix of a given FDL program activity.
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_WSDL.XSL" and "XFDLBPEL_SCDL.XSL"!)
		*****************************************************************************************************************************
	 -->
	<xsl:template match="fdl:process" mode="activity-name-prefix">
		<xsl:param name="activity"/>
		<xsl:choose>
			<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
				<!-- Name prefix not required: return empty string -->
				<xsl:value-of select="''"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="fdl:programActivity[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:when test="fdl:processActivity[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:when test="fdl:block[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="concat(@name, '_')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="fdl:block" mode="activity-name-prefix">
							<xsl:with-param name="activity" select="$activity"/>
							<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="fdl:block" mode="activity-name-prefix">
		<xsl:param name="activity"/>
		<xsl:param name="name-prefix"/>
		<xsl:variable name="next-name-prefix" select="concat($name-prefix,  @name, '_')"/>
		<xsl:choose>
			<xsl:when test="fdl:blockImplementation/fdl:programActivity[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:when test="fdl:blockImplementation/fdl:processActivity[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:when test="fdl:blockImplementation/fdl:block[ generate-id() = generate-id($activity) ]">
				<xsl:value-of select="$next-name-prefix"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="fdl:blockImplementation/fdl:block" mode="activity-name-prefix">
					<xsl:with-param name="activity" select="$activity"/>
					<xsl:with-param name="name-prefix" select="$next-name-prefix"/>
				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		****************************************************************************************************************
		"activity-parent-name-prefix" template:
		
		Determines parent name prefix of a given FDL program activity.
		****************************************************************************************************************
	 -->
	<xsl:template match="fdl:process" mode="activity-parent-name-prefix">
		<xsl:param name="activity"/>
		<xsl:choose>
			<xsl:when test="'TRUE' = translate($enable_LI976_Eliminate_long_names, $lower-case-characters, $upper-case-characters)">
				<!-- Name prefix not required: return empty string -->
				<xsl:value-of select="''"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="fdl:programActivity[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="''"/>
					</xsl:when>
					<xsl:when test="fdl:processActivity[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="''"/>
					</xsl:when>
					<xsl:when test="fdl:block[ generate-id() = generate-id($activity) ]">
						<xsl:value-of select="''"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="fdl:block" mode="activity-name-prefix">
							<xsl:with-param name="activity" select="$activity"/>
							<xsl:with-param name="name-prefix" select="concat(@name, '_')"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- 
		*****************************************************************************************************************************
		"process-contains-UPES-activities" template:
		
		Returns true, if the process contains activity of type "service invocation activity" (UPES)
		*****************************************************************************************************************************
	 -->
	<xsl:template name="process-contains-UPES-activities">
		<xsl:param name="process"/>
		<xsl:variable name="UPES-activities">
			<xsl:for-each select="$process//fdl:programActivity">
				<xsl:variable name="program-activity-type">
					<xsl:call-template name="program-activity-type">
						<xsl:with-param name="activity" select="current()"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="$program-activity-type = 'service invocation activity'">
					<xsl:copy-of select="current()"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="xalan:nodeset($UPES-activities)/*">
				<xsl:value-of select="'TRUE'"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'FALSE'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
		****************************************************************************************************************
		Template "program-activity-type":

		Determines the type of an FDL program activity.
		Selects from types "empty activity", "service invocation activity" (UPES activity),  "staff activity",
		"assumed staff activity"
		(NOTE THAT THIS TEMPLATE IS SHARED IN "XFDLBPEL_XSD.XSL" AND "XFDLBPEL_WSDL.XSL"!)
		****************************************************************************************************************
	 -->
	<xsl:template name="program-activity-type">
		<xsl:param name="activity"/>
		<xsl:choose>
			<!--
				CASE: "empty activity"
					A program activity is an "empty activity" if
					1) if the activity implementation is a program with the name FMCINTERNALNOOP
					2) the execution mode is chained
					3) the input and output data structures are the same
			-->
			<xsl:when test="$activity/fdl:program/@name='FMCINTERNALNOOP'
								and $activity/fdl:program/@synchronization='chained'
								and $activity/fdl:input/@type = $activity/fdl:output/@type">
				<xsl:value-of select="'empty activity'"/>
			</xsl:when>
			<!--
				CASE: "service invocation activity"
					A program activity is an "service invocation activity" if a user-defined program execution server
					(UPES) is specified (attribute "fdl:program/@programExecutionUnit").
			-->
			<xsl:when test="$activity/fdl:program/@programExecutionUnit">
				<xsl:value-of select="'service invocation activity'"/>
			</xsl:when>
			<!--
				CASE: "staff activity"
					A program activity is a "staff activity" if the following conditions apply:
					1. Attribute "checkoutPossible" indicates that it can be checked out from the runtime database.
					2. Start type is "manual"
			-->
			<xsl:when test="$activity/fdl:join/@startType='manual' and ( $activity/fdl:defaultSetting/@checkoutPossible='yes'
								 or $activity/ancestor::fdl:process/fdl:activityDefaultSetting/@checkoutPossible='yes' )">
				<xsl:value-of select="'staff activity'"/>
			</xsl:when>
			<!--
				OTHERWISE: "unclassified activity"
					A program activity is an "unclassified activity" if none of the above rules apply.
					In this case assume a "staff activity".
			-->
			<xsl:otherwise>
				<xsl:value-of select="'assumed staff activity'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:transform>
